(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     99488,       2866]
NotebookOptionsPosition[     80295,       2424]
NotebookOutlinePosition[     81926,       2477]
CellTagsIndexPosition[     81703,       2467]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["EPM`Graphics`", "Section",
 InitializationGroup->True],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox["Essentials of Programming in Mathematica\n",
  FontSlant->"Italic"],
 "\[Copyright] Paul R. Wellin 2015"
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14],

Cell[CellGroupData[{

Cell["Metadata", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Name", ":", " ", "EPM`Graphics`"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Book", ":", " ", 
   RowBox[{
   "Essentials", " ", "of", " ", "Programming", " ", "in", " ", 
    "Mathematica"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Summary", ":", " ", 
   RowBox[{
   "This", " ", "package", " ", "contains", " ", "the", " ", "functions", " ",
     "defined", " ", "in", " ", "Chapter", " ", "8", " ", 
    RowBox[{"Graphics", "."}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Context", ":", " ", "EPM`Graphics`"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Copyright", ":", " ", 
    RowBox[{"Copyright", " ", "2015"}]}], ",", " ", 
   RowBox[{"Paul", " ", "R", " ", "Wellin"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{"Dec", " ", "2012"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Keywords", ":", " ", 
    RowBox[{"amino", " ", "acids"}]}], ",", " ", "centroids", ",", " ", 
   RowBox[{"space", "-", 
    RowBox[{"filling", " ", "plots"}]}], ",", " ", 
   RowBox[{"color", " ", "wheel"}], ",", " ", 
   RowBox[{"plotting", " ", "complex", " ", "numbers"}], ",", " ", 
   RowBox[{"convex", " ", "hull"}], ",", " ", 
   RowBox[{"dot", " ", "plots"}], ",", " ", "eigenvectors", ",", " ", 
   "epicycloids", ",", " ", "hypocycloids", ",", " ", 
   RowBox[{"integer", " ", "lattice"}], ",", " ", 
   RowBox[{"plotting", " ", "paths"}], ",", " ", 
   RowBox[{"plotting", " ", "roots"}], ",", " ", 
   RowBox[{"standard", " ", "deviation"}], ",", " ", 
   RowBox[{"triangle", " ", "area"}], ",", " ", 
   RowBox[{"Venn", " ", "diagrams"}], ",", " ", 
   RowBox[{"point", " ", "in", " ", "polygon"}]}], "\[IndentingNewLine]", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Source", ":", " ", 
   RowBox[{"Graphics", ".", "nb"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", "Version"}], ":", " ", "10.3"}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "11.1"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"f825b041-4090-44aa-9f84-b7153f0abceb"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "AminoAcidPlot", ",", "CentroidPlot", ",", "ChemicalSpaceFillingPlot", ",", 
   "colorWheel", ",", "ComplexListPlot", ",", "ComplexRootPlot", ",", 
   "ConvexHullPlot", ",", "Dimension", ",", "DotPlot", ",", "EigenvectorPlot",
    ",", "EpicycloidPlot", ",", "Hypocycloid", ",", "HypocycloidPlot", ",", 
   "Lattice3D", ",", "PathPlot", ",", "RandomCompose", ",", "RandomWalkPi", 
   ",", "RootPlot", ",", "SimplePath", ",", "StandardDeviationPlot", ",", 
   "TriangleArea", ",", "VennDiagram"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"BeginPackage", "[", "\"\<EPM`Graphics`\>\"", "]"}], " ", 
  "*)"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for public functions", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AminoAcidPlot", "::", "usage"}], "=", "\"\<AminoAcidPlot[\!\(\*
StyleBox[\"aa\", \"TI\"]\)] plots the amino acid \!\(\*
StyleBox[\"aa\", \"TI\"]\) as a colored structure diagram. A second argument \
can be given to specify a different visualization, including \
\\\"StructureDiagram\\\", \\\"CHColorStructureDiagram\\\", \
\\\"CHStructureDiagram\\\", \\\"ColorStructureDiagram\\\", \\\"MoleculePlot\\\
\", \\\"SpaceFillingMoleculePlot\\\".\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CentroidPlot", "::", "usage"}], "=", 
   "\"\<CentroidPlot[Triangle[{\!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"1\"]\)\!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"2\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"3\"]\)}]] generates a plot of a triangle together \
with its centroids and the triangle medians.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ChemicalSpaceFillingPlot", "::", "usage"}], "=", 
   "\"\<ChemicalSpaceFillingPlot[\!\(\*
StyleBox[\"chem\", \"TI\"]\)] generates a molecular space-filling plot for \
the chemical \!\(\*
StyleBox[\"chem\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"colorWheel", "::", "usage"}], "=", "\"\<colorWheel[\!\(\*
StyleBox[\"n\", \"TI\"]\)] displays a color wheel with \!\(\*
StyleBox[\"n\", \"TI\"]\) sectors.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ComplexListPlot", "::", "usage"}], "=", "\"\<ComplexListPlot[\!\(\*
StyleBox[\"pts\", \"TI\"]\)] plots the complex points \!\(\*
StyleBox[\"pts\", \"TI\"]\) in the complex plane. ComplexListPlot inherits \
all the options of ListPlot.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ComplexRootPlot", "::", "usage"}], "=", "\"\<ComplexRootPlot[\!\(\*
StyleBox[\"poly\", \"TI\"]\), \!\(\*
StyleBox[\"var\", \"TI\"]\)] plots the complex root of the polynomial \!\(\*
StyleBox[\"poly\", \"TI\"]\) in the complex plane.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConvexHullPlot", "::", "usage"}], "=", "\"\<ConvexHullPlot[\!\(\*
StyleBox[\"pts\", \"TI\"]\)] plots the convex hull of the set of points \
\!\(\*
StyleBox[\"pts\", \"TI\"]\). ConvexHullPlot inherits options from Graphics.\>\
\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Dimension", "::", "usage"}], "=", 
   "\"\<Dimension is an option to ConvexHullPlot. Values can be either 2 or \
3.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DotPlot", "::", "usage"}], "=", "\"\<DotPlot[\!\(\*SubscriptBox[
StyleBox[\"seq\", \"TI\"], \"1\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*SubscriptBox[
StyleBox[\"seq\", \"TI\"], \"2\"]\)] plots a dot plot of the two sequences \!\
\(\*SubscriptBox[
StyleBox[\"seq\", \"TI\"], \"1\"]\) and \!\(\*SubscriptBox[
StyleBox[\"seq\", \"TI\"], \"2\"]\). The option WindowSize takes a default \
value of one. All other options are inherited from ArrayPlot such as \
FrameLabel.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EigenvectorPlot", "::", "usage"}], "=", "\"\<EigenvectorPlot[\!\(\*
StyleBox[\"data\", \"TI\"]\)] displays an eigenvector plot of \!\(\*
StyleBox[\"data\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EpicycloidPlot", "::", "usage"}], "=", "\"\<EpicycloidPlot[\!\(\*
StyleBox[\"R\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"r\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"\[Theta]\", \"TI\"]\)] displays a plot of a epicycloid generated \
by rolling a circle of radius \!\(\*
StyleBox[\"r\", \"TI\"]\) outside of a fixed circle of radius \!\(\*
StyleBox[\"R\", \"TI\"]\). The angle \[Theta] is the parameter that \
determines how far along the curve to sketch.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Hypocycloid", "::", "usage"}], "=", "\"\<Hypocycloid[{\!\(\*
StyleBox[\"R\", \"TI\"]\), \!\(\*
StyleBox[\"r\", \"TI\"]\)}, \[Theta]] generates a hypocycloid curve with the \
radius of the fixed outside circle given by \!\(\*
StyleBox[\"R\", \"TI\"]\) and the radius of the rotating inner circle given \
by \!\(\*
StyleBox[\"r\", \"TI\"]\). The angle of rotation is given by the paramter \
\[Theta].\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HypocycloidPlot", "::", "usage"}], "=", "\"\<HypocycloidPlot[\!\(\*
StyleBox[\"R\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"r\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"\[Theta]\", \"TI\"]\)] displays a plot of a hypocycloid generated \
by rolling a circle of radius \!\(\*
StyleBox[\"r\", \"TI\"]\) inside of a fixed circle of radius \!\(\*
StyleBox[\"R\", \"TI\"]\). The angle \[Theta] is the parameter that \
determines how far along the curve to sketch.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Lattice3D", "::", "usage"}], "=", "\"\<Lattice3D[{\!\(\*
StyleBox[\"xmin\", \"TI\"]\), \!\(\*
StyleBox[\"xmax\", \"TI\"]\)}, {\!\(\*
StyleBox[\"ymin\", \"TI\"]\), \!\(\*
StyleBox[\"ymax\", \"TI\"]\)}, {\!\(\*
StyleBox[\"zmin\", \"TI\"]\), \!\(\*
StyleBox[\"zmax\", \"TI\"]\)}] displays a three-dimensional lattice in space.\
\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PathPlot", "::", "usage"}], "=", "\"\<PathPlot[\!\(\*
StyleBox[\"lis\", \"TI\"]\)] displays a plot consisting of a line connecting \
each coordinate point in \!\(\*
StyleBox[\"lis\", \"TI\"]\) in order.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RandomCompose", "::", "usage"}], "=", "\"\<RandomCompose[\!\(\*
StyleBox[\"n\", \"TI\"]\), \!\(\*
StyleBox[\"instr\", \"TI\"]\)] generates an uncorrelated set of  \!\(\*
StyleBox[\"n\", \"TI\"]\) tones using the MIDI instrument \!\(\*
StyleBox[\"instr\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RandomWalkPi", "::", "usage"}], "=", "\"\<RandomWalkPi[\!\(\*
StyleBox[\"n\", \"TI\"]\), \!\(\*
StyleBox[\"b\", \"TI\"]\)] generates \!\(\*
StyleBox[\"n\", \"TI\"]\) steps of a random walk on the base \!\(\*
StyleBox[\"b\", \"TI\"]\) digits of \[Pi].\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RootPlot", "::", "usage"}], "=", "\"\<RootPlot[\!\(\*
StyleBox[\"fun\", \"TI\"]\), {\!\(\*
StyleBox[\"x\", \"TI\"]\), \!\(\*
StyleBox[\"xmin\", \"TI\"]\), \!\(\*
StyleBox[\"xmax\", \"TI\"]\)}] plots the function \!\(\*
StyleBox[\"fun\", \"TI\"]\) together with its roots over the interval from \!\
\(\*
StyleBox[\"xmin\", \"TI\"]\) to \!\(\*
StyleBox[\"xmax\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SimplePath", "::", "usage"}], "=", "\"\<SimplePath[\!\(\*
StyleBox[\"lis\", \"TI\"]\)] finds a simple closed path through the \
two-dimensional points, \!\(\*
StyleBox[\"lis\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardDeviationPlot", "::", "usage"}], "=", 
   "\"\<StandardDeviationPlot[\!\(\*
StyleBox[\"data\", \"TI\"]\), \!\(\*
StyleBox[\"sd\", \"TI\"]\)] plots \!\(\*
StyleBox[\"data\", \"TI\"]\) where points within one standard deviation are \
colored differently than those more than one standard deviation from the \
mean. The second argument, sd, is 1 by default and can set to any standard \
deviation value.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TriangleArea", "::", "usage"}], "=", 
   "\"\<TriangleArea[{\!\(\*SubscriptBox[
StyleBox[\"v\", \"TI\"], \"1\"]\),\!\(\*SubscriptBox[
StyleBox[\"v\", \"TI\"], \"2\"]\),\!\(\*SubscriptBox[
StyleBox[\"v\", \"TI\"], \"3\"]\)}] computes the area of the triangle given \
by the three vertices \!\(\*SubscriptBox[
StyleBox[\"v\", \"TI\"], \"1\"]\), \!\(\*SubscriptBox[
StyleBox[\"v\", \"TI\"], \"2\"]\), and \!\(\*SubscriptBox[
StyleBox[\"v\", \"TI\"], \"3\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VennDiagram", "::", "usage"}], "=", "\"\<VennDiagram[\!\(\*
StyleBox[\"expr\", \"TI\"]\),\!\(\*
StyleBox[\"vars\", \"TI\"]\)] creates and displays a Venn diagram of the \
logical expression \!\(\*
StyleBox[\"expr\", \"TI\"]\) in the variables given as a list, \!\(\*
StyleBox[\"vars\", \"TI\"]\). The logical expression can be in either two or \
three variables.\>\""}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "CentroidPlot", "]"}], "=", 
   RowBox[{"Options", "[", "Graphics", "]"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ComplexListPlot", "]"}], "=", 
   RowBox[{"Options", "[", "ListPlot", "]"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ConvexHullPlot", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Dimension", "\[Rule]", "2"}], "}"}], ",", 
     RowBox[{"Options", "[", "Graphics", "]"}], ",", 
     RowBox[{"Options", "[", "Graphics3D", "]"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DotPlot", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"WindowSize", "\[Rule]", "1"}], "}"}], ",", 
     RowBox[{"Options", "[", "ArrayPlot", "]"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "PathPlot", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ClosedPath", "\[Rule]", "True"}], "}"}], ",", 
     RowBox[{"Options", "[", "Graphics", "]"}]}], "]"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "RootPlot", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Options", "[", "NSolve", "]"}], ",", 
     RowBox[{"Options", "[", "Plot", "]"}]}], "]"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Messages", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConvexHullPlot", "::", "baddim"}], "=", 
   "\"\<The value `1` of the Dimension option should be either 2 or 3\>\""}], 
  ";"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CentroidPlot", "::", "collinpts"}], "=", 
   "\"\<The points `1` are collinear, giving a degenerate triangle.\>\""}], 
  ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Private context", "Subsection"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions (public and private)", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AminoAcidPlot", "[", 
   RowBox[{"aa_String", ",", 
    RowBox[{"diagram_:", "\"\<ColorStructureDiagram\>\""}]}], "]"}], ":=", 
  RowBox[{"Labeled", "[", 
   RowBox[{
    RowBox[{"Framed", "[", 
     RowBox[{
      RowBox[{"ChemicalData", "[", 
       RowBox[{"aa", ",", "diagram"}], "]"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "All"}]}], "]"}], ",", 
    RowBox[{"ChemicalData", "[", 
     RowBox[{"aa", ",", "\"\<Name\>\""}], "]"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"\"\<Menu\>\"", ",", "9"}], "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CentroidPlot", "[", 
   RowBox[{
    RowBox[{"Triangle", "[", 
     RowBox[{"{", 
      RowBox[{"p1_", ",", "p2_", ",", "p3_"}], "}"}], "]"}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "Graphics", "]"}]}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TriangleArea", "[", 
      RowBox[{"{", 
       RowBox[{"p1", ",", "p2", ",", "p3"}], "}"}], "]"}], "\[Equal]", "0"}], 
    ",", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"CentroidPlot", "::", "collinpts"}], ",", 
      RowBox[{"{", 
       RowBox[{"p1", ",", "p2", ",", "p3"}], "}"}]}], "]"}], ",", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"Graphics", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"LightBlue", ",", 
          RowBox[{"EdgeForm", "[", "Blue", "]"}], ",", 
          RowBox[{"Triangle", "[", 
           RowBox[{"{", 
            RowBox[{"p1", ",", "p2", ",", "p3"}], "}"}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{"p1", ",", "p2", ",", "p3"}], "}"}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
          RowBox[{"Point", "@", 
           RowBox[{"RegionCentroid", "[", 
            RowBox[{"Triangle", "[", 
             RowBox[{"{", 
              RowBox[{"p1", ",", "p2", ",", "p3"}], "}"}], "]"}], "]"}]}]}], 
         "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"Gray", ",", 
          RowBox[{"TriangleMedians", "[", 
           RowBox[{"Triangle", "[", 
            RowBox[{"{", 
             RowBox[{"p1", ",", "p2", ",", "p3"}], "}"}], "]"}], "]"}], ",", 
          RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
          RowBox[{"Point", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#1", "+", "#2"}], ")"}], "/", "2"}], "&"}], "@@@", 
            RowBox[{"Subsets", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"p1", ",", "p2", ",", "p3"}], "}"}], ",", 
              RowBox[{"{", "2", "}"}]}], "]"}]}], "]"}]}], "}"}]}], 
       "\[IndentingNewLine]", "}"}], ",", "opts"}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellTags->"8.1 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ChemicalSpaceFillingPlot", "[", "file_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "elements", ",", "pos", ",", "radii", ",", "names", ",", "colors", ",", 
      "labels"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"pos", ",", "elements"}], "}"}], "=", 
      RowBox[{"First", "/@", 
       RowBox[{"Import", "[", 
        RowBox[{"file", ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"\"\<VertexCoordinates\>\"", ",", "\"\<VertexTypes\>\""}], 
           "}"}], "}"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"radii", "=", 
      RowBox[{"QuantityMagnitude", "@", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ElementData", "[", 
           RowBox[{"#", ",", "\"\<VanDerWaalsRadius\>\""}], "]"}], "&"}], ",",
          "elements"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"labels", "=", 
      RowBox[{"DeleteDuplicates", "[", "elements", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"names", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"ElementData", "[", 
         RowBox[{"#", ",", "\"\<StandardName\>\""}], "]"}], "&"}], "/@", 
       "labels"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"colors", "=", 
      RowBox[{"labels", "/.", 
       RowBox[{"ColorData", "[", 
        RowBox[{"\"\<Atoms\>\"", ",", "\"\<ColorRules\>\""}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Legended", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Graphics3D", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Specularity", "[", 
            RowBox[{"White", ",", "50"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"MapThread", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"ColorData", "[", 
                 RowBox[{"\"\<Atoms\>\"", ",", "#1"}], "]"}], ",", 
                RowBox[{"Sphere", "[", 
                 RowBox[{"#2", ",", "#3"}], "]"}]}], "}"}], "&"}], ",", 
             RowBox[{"{", 
              RowBox[{"elements", ",", "pos", ",", "radii"}], "}"}]}], 
            "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
         RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"SwatchLegend", "[", 
        RowBox[{"colors", ",", "names", ",", 
         RowBox[{"LegendMarkers", "\[Rule]", "\"\<SphereBubble\>\""}]}], 
        "]"}]}], "\[IndentingNewLine]", "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"colorWheel", "[", "n_", "]"}], ":=", 
  RowBox[{"Graphics", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Hue", "[", 
         RowBox[{"Rescale", "[", 
          RowBox[{"#", ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "]"}], ",", 
        RowBox[{"Disk", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", "1", ",", 
          RowBox[{"{", 
           RowBox[{"#", ",", 
            RowBox[{"#", "+", " ", "n"}]}], "}"}]}], "]"}]}], "}"}], "&"}], 
     ")"}], "/@", 
    RowBox[{"Range", "[", 
     RowBox[{"0", ",", 
      RowBox[{"2", " ", "\[Pi]"}], ",", "n"}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ComplexListPlot", "[", 
   RowBox[{"points_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Re", "[", "#", "]"}], ",", 
         RowBox[{"Im", "[", "#", "]"}]}], "}"}], "&"}], ",", "points"}], 
     "]"}], ",", "opts", ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Red", ",", 
       RowBox[{"PointSize", "[", "Medium", "]"}]}], "}"}]}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<Re\>\"", ",", "\"\<Im\>\""}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", "\"\<Menu\>\"", "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ComplexRootPlot", "[", 
   RowBox[{"poly_", ",", "z_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"ComplexListPlot", "[", 
   RowBox[{
    RowBox[{"z", "/.", 
     RowBox[{"NSolve", "[", 
      RowBox[{
       RowBox[{"poly", "==", "0"}], ",", "z"}], "]"}]}], ",", "opts", ",", 
    RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConvexHullPlot", "[", 
   RowBox[{"pts_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[ScriptCapitalR]", ",", 
      RowBox[{"dim", "=", 
       RowBox[{"OptionValue", "[", "Dimension", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[ScriptCapitalR]", "=", 
      RowBox[{"ConvexHullMesh", "[", "pts", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"dim", "\[Equal]", "2"}], ",", 
       RowBox[{"Show", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[ScriptCapitalR]", ",", 
           RowBox[{"Graphics", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Point", "[", "pts", "]"}], ",", "Red", ",", 
              RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
              RowBox[{"MeshPrimitives", "[", 
               RowBox[{"\[ScriptCapitalR]", ",", "0"}], "]"}]}], "}"}], 
            "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"{", "opts", "}"}], ",", 
           RowBox[{"Options", "[", "Graphics", "]"}]}], "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"dim", "\[Equal]", "3"}], ",", 
       RowBox[{"Show", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[ScriptCapitalR]", ",", 
           RowBox[{"Graphics3D", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Point", "[", "pts", "]"}], ",", "Red", ",", 
              RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
              RowBox[{"MeshPrimitives", "[", 
               RowBox[{"\[ScriptCapitalR]", ",", "0"}], "]"}]}], "}"}], 
            "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"{", "opts", "}"}], ",", 
           RowBox[{"Options", "[", "Graphics3D", "]"}]}], "]"}]}], "]"}], ",",
        "\[IndentingNewLine]", "True", ",", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"ConvexHullPlot", "::", "baddim"}], ",", "dim"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DotPlot", "[", 
   RowBox[{"p1_", ",", "p2_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"w", "=", 
      RowBox[{"OptionValue", "[", "WindowSize", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ArrayPlot", "[", 
     RowBox[{
      RowBox[{"Outer", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Boole", "[", 
          RowBox[{"#1", "==", "#2"}], "]"}], "&"}], ",", 
        RowBox[{"stringPartition", "[", 
         RowBox[{"p1", ",", "w", ",", "1", ",", "1", ",", 
          RowBox[{"{", "}"}]}], "]"}], ",", 
        RowBox[{"stringPartition", "[", 
         RowBox[{"p2", ",", "w", ",", "1", ",", "1", ",", 
          RowBox[{"{", "}"}]}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"FilterRules", "[", 
       RowBox[{
        RowBox[{"{", "opts", "}"}], ",", 
        RowBox[{"Options", "@", "ArrayPlot"}]}], "]"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]}], "]"}]}]], "Input",
 CellTags->"i:1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"For", " ", "large", " ", "data", " ", 
     RowBox[{"(", 
      RowBox[{">", 
       RowBox[{"10", "^", "5"}]}], ")"}]}], ",", " ", 
    RowBox[{
     RowBox[{"the", " ", "following", " ", "is", " ", "slow"}], ";"}]}], " ", 
   "*)"}], 
  RowBox[{"(*", " ", 
   RowBox[{
   "better", " ", "to", " ", "use", " ", "GraphicsComplex", " ", "version", 
    " ", "below"}], " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"EigenvectorPlot", "[", 
     RowBox[{
      RowBox[{"data", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", "tensor_", 
      ",", 
      RowBox[{"opts", ":", 
       RowBox[{"OptionsPattern", "[", "ListLinePlot", "]"}]}]}], "]"}], ":=", 
    
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"T", "=", "tensor"}], ",", "cmx", ",", "cmy", ",", 
        "\[Lambda]1", ",", "\[Lambda]2", ",", "v1x", ",", "v1y", ",", "v2x", 
        ",", "v2y"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], "=", 
        RowBox[{"Eigenvalues", "[", "T", "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{
        RowBox[{"{", 
         RowBox[{"cmx", ",", "cmy"}], "}"}], "=", 
        RowBox[{"Mean", "[", "data", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"v1x", ",", "v1y"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"v2x", ",", "v2y"}], "}"}]}], "}"}], "=", 
        RowBox[{"Eigenvectors", "[", "T", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Show", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ListLinePlot", "[", 
            RowBox[{"data", ",", "opts", ",", 
             RowBox[{"PlotStyle", "\[Rule]", "Thin"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Graphics", "[", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"cmx", "-", "\[Lambda]1"}], ",", 
                   RowBox[{"cmy", "-", 
                    FractionBox[
                    RowBox[{"v1y", " ", "\[Lambda]1"}], "v1x"]}]}], "}"}], 
                 ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"cmx", "+", "\[Lambda]1"}], ",", 
                   RowBox[{"cmy", "+", 
                    FractionBox[
                    RowBox[{"v1y", " ", "\[Lambda]1"}], "v1x"]}]}], "}"}]}], 
                "}"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"cmx", "-", "\[Lambda]2"}], ",", 
                   RowBox[{"cmy", "-", 
                    FractionBox[
                    RowBox[{"v2y", " ", "\[Lambda]2"}], "v2x"]}]}], "}"}], 
                 ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"cmx", "+", "\[Lambda]2"}], ",", 
                   RowBox[{"cmy", "+", 
                    FractionBox[
                    RowBox[{"v2y", " ", "\[Lambda]2"}], "v2x"]}]}], "}"}]}], 
                "}"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"PointSize", "[", "Large", "]"}], ",", "Red", ",", 
              RowBox[{"Point", "@", 
               RowBox[{"Mean", "[", "data", "]"}]}]}], "}"}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], ",", 
         RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]}]}], 
     "]"}]}], "\[IndentingNewLine]", "*)"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EigenvectorPlot", "[", 
   RowBox[{
    RowBox[{"data", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", "tensor_", ",", 
    
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "Graphics", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"T", "=", "tensor"}], ",", "cmx", ",", "cmy", ",", "\[Lambda]1",
       ",", "\[Lambda]2", ",", "v1x", ",", "v1y", ",", "v2x", ",", "v2y"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], "=", 
      RowBox[{"Eigenvalues", "[", "T", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"cmx", ",", "cmy"}], "}"}], "=", 
      RowBox[{"Mean", "[", "data", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"v1x", ",", "v1y"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"v2x", ",", "v2y"}], "}"}]}], "}"}], "=", 
      RowBox[{"Eigenvectors", "[", "T", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", 
      RowBox[{
       RowBox[{"GraphicsComplex", "[", 
        RowBox[{"data", ",", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.368417", ",", "0.506779", ",", "0.709798"}], "]"}], 
           ",", 
           RowBox[{"Thickness", "[", ".001", "]"}], ",", 
           RowBox[{"Line", "@", 
            RowBox[{"Range", "[", 
             RowBox[{"Length", "[", "data", "]"}], "]"}]}]}], 
          "\[IndentingNewLine]", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
       "opts", ",", 
       RowBox[{"Axes", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"cmx", "-", "\[Lambda]1"}], ",", 
               RowBox[{"cmy", "-", 
                FractionBox[
                 RowBox[{"v1y", " ", "\[Lambda]1"}], "v1x"]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"cmx", "+", "\[Lambda]1"}], ",", 
               RowBox[{"cmy", "+", 
                FractionBox[
                 RowBox[{"v1y", " ", "\[Lambda]1"}], "v1x"]}]}], "}"}]}], 
            "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"cmx", "-", "\[Lambda]2"}], ",", 
               RowBox[{"cmy", "-", 
                FractionBox[
                 RowBox[{"v2y", " ", "\[Lambda]2"}], "v2x"]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"cmx", "+", "\[Lambda]2"}], ",", 
               RowBox[{"cmy", "+", 
                FractionBox[
                 RowBox[{"v2y", " ", "\[Lambda]2"}], "v2x"]}]}], "}"}]}], 
            "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"PointSize", "[", "Large", "]"}], ",", "Red", ",", 
          RowBox[{"Point", "@", 
           RowBox[{"{", 
            RowBox[{"cmx", ",", "cmy"}], "}"}]}]}], "}"}]}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EpicycloidPlot", "[", 
   RowBox[{"R_", ",", "r_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"epicycloid", ",", "center"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"epicycloid", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a_", ",", "b_"}], "}"}], ",", "t_"}], "]"}], ":=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "+", "b"}], ")"}], 
          RowBox[{"Cos", "[", "t", "]"}]}], "-", 
         RowBox[{"b", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"t", " ", 
            FractionBox[
             RowBox[{"a", "+", "b"}], "b"]}], "]"}]}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "+", "b"}], ")"}], 
          RowBox[{"Sin", "[", "t", "]"}]}], "+", 
         RowBox[{"b", " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"t", " ", 
            FractionBox[
             RowBox[{"a", "+", "b"}], "b"]}], "]"}]}]}]}], "}"}]}], ";", 
     RowBox[{
      RowBox[{"center", "[", 
       RowBox[{"th_", ",", "R1_", ",", "r2_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"R1", "+", "r2"}], ")"}], 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cos", "[", "th", "]"}], ",", 
         RowBox[{"Sin", "[", "th", "]"}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ParametricPlot", "[", 
          RowBox[{
           RowBox[{"epicycloid", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"R", ",", "r"}], "}"}], ",", "t"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", "0", ",", "\[Theta]"}], "}"}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", "Red"}], ",", 
           RowBox[{"Axes", "\[Rule]", "None"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Graphics", "[", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Blue", ",", "Thick", ",", 
              RowBox[{"Circle", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", "R"}], "]"}]}], "}"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"Circle", "[", 
              RowBox[{
               RowBox[{"center", "[", 
                RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], ",", "r"}], 
              "]"}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"PointSize", "[", ".015", "]"}], ",", 
              RowBox[{"Point", "[", 
               RowBox[{"center", "[", 
                RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], "]"}]}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"Thick", ",", 
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"center", "[", 
                  RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], ",", 
                 RowBox[{"epicycloid", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"R", ",", "r"}], "}"}], ",", "\[Theta]"}], 
                  "]"}]}], "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
            
            RowBox[{"{", 
             RowBox[{"Red", ",", 
              RowBox[{"PointSize", "[", ".015", "]"}], ",", 
              RowBox[{"Point", "[", 
               RowBox[{"epicycloid", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"R", ",", "r"}], "}"}], ",", "\[Theta]"}], "]"}], 
               "]"}]}], "}"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], "}"}],
        ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"1.5", 
         RowBox[{"(", 
          RowBox[{"R", "+", "r"}], ")"}]}]}], ",", 
       RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Hypocycloid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a_", ",", "b_"}], "}"}], ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "-", "b"}], ")"}], 
      RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
     RowBox[{"b", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Theta]", " ", 
        FractionBox[
         RowBox[{"a", "-", "b"}], "b"]}], "]"}]}]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "-", "b"}], ")"}], 
      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "-", 
     RowBox[{"b", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Theta]", " ", 
        FractionBox[
         RowBox[{"a", "-", "b"}], "b"]}], "]"}]}]}]}], "}"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HypocycloidPlot", "[", 
   RowBox[{"R_", ",", "r_", ",", "\[Theta]_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "Graphics", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "center", "}"}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"center", "[", 
       RowBox[{"th_", ",", "R1_", ",", "r2_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"R1", "-", "r2"}], ")"}], " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cos", "[", "th", "]"}], ",", 
         RowBox[{"Sin", "[", "th", "]"}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ParametricPlot", "[", 
          RowBox[{
           RowBox[{"Hypocycloid", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"R", ",", "r"}], "}"}], ",", "t"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", "0", ",", "\[Theta]"}], "}"}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", "Red"}], ",", 
           RowBox[{"Axes", "\[Rule]", "None"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"Graphics", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Blue", ",", 
              RowBox[{"Thickness", "[", "Medium", "]"}], ",", 
              RowBox[{"Circle", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", "R"}], "]"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"Circle", "[", 
              RowBox[{
               RowBox[{"center", "[", 
                RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], ",", "r"}], 
              "]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"PointSize", "[", ".02", "]"}], ",", 
              RowBox[{"Point", "[", 
               RowBox[{"center", "[", 
                RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], "]"}]}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Thick", ",", 
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"center", "[", 
                  RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], ",", 
                 RowBox[{"Hypocycloid", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"R", ",", "r"}], "}"}], ",", "\[Theta]"}], 
                  "]"}]}], "}"}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Red", ",", 
              RowBox[{"PointSize", "[", ".02", "]"}], ",", 
              RowBox[{"Point", "[", 
               RowBox[{"Hypocycloid", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"R", ",", "r"}], "}"}], ",", "\[Theta]"}], "]"}], 
               "]"}]}], "}"}]}], "}"}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", "opts", ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Lattice3D", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"xmin_", ",", "xmax_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"ymin_", ",", "ymax_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"zmin_", ",", "zmax_"}], "}"}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "Graphics3D", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"gridX", ",", "gridY", ",", "gridZ"}], "}"}], ",", 
    RowBox[{
     RowBox[{"gridX", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"xmin", ",", "y", ",", "z"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"xmax", ",", "y", ",", "z"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", "ymin", ",", "ymax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"z", ",", "zmin", ",", "zmax"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gridY", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x", ",", "ymin", ",", "z"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "ymax", ",", "z"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"z", ",", "zmin", ",", "zmax"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gridZ", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x", ",", "y", ",", "zmin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "y", ",", "zmax"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", "ymin", ",", "ymax"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graphics3D", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{"Line", ",", "gridX"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Map", "[", 
          RowBox[{"Line", ",", "gridY"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Map", "[", 
          RowBox[{"Line", ",", "gridZ"}], "]"}]}], "\[IndentingNewLine]", 
        "}"}], ",", "opts", ",", 
       RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PathPlot", "[", 
   RowBox[{"lis_List", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"coords", "=", "lis"}], "}"}], ",", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"OptionValue", "[", "ClosedPath", "]"}], ",", 
       RowBox[{"coords", "=", 
        RowBox[{"coords", "/.", "\[VeryThinSpace]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"a_", ",", "b__"}], "}"}], "\[RuleDelayed]", 
          RowBox[{"{", 
           RowBox[{"a", ",", "b", ",", "a"}], "}"}]}]}]}]}], "]"}], ";", 
     RowBox[{"Graphics", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Line", "[", "coords", "]"}], ",", 
         RowBox[{"PointSize", "[", "Medium", "]"}], ",", "Red", ",", 
         RowBox[{"Point", "[", "coords", "]"}]}], "}"}], ",", 
       RowBox[{"FilterRules", "[", 
        RowBox[{
         RowBox[{"{", "opts", "}"}], ",", 
         RowBox[{"Options", "[", "Graphics", "]"}]}], "]"}]}], "]"}]}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomWalkPi", "[", 
   RowBox[{"d_", ",", 
    RowBox[{"base_", "/;", 
     RowBox[{"base", ">", "2"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"digits", ",", "angles", ",", "rules"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"digits", "=", 
      RowBox[{"First", "[", 
       RowBox[{"RealDigits", "[", 
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{"\[Pi]", ",", "d"}], "]"}], ",", "base"}], "]"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"angles", "=", 
      RowBox[{"Rest", "@", 
       RowBox[{"Range", "[", 
        RowBox[{"0.", ",", 
         RowBox[{"2", "\[Pi]"}], ",", 
         RowBox[{"2", 
          RowBox[{"\[Pi]", "/", 
           RowBox[{"(", "base", ")"}]}]}]}], "]"}]}]}], ";", 
     RowBox[{"rules", "=", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "\[Rule]", "#2"}], "&"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", 
            RowBox[{"base", "-", "1"}]}], "]"}], ",", "angles"}], "}"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Accumulate", "[", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Cos", "[", "#", "]"}], ",", 
           RowBox[{"Sin", "[", "#", "]"}]}], "}"}], "&"}], ",", 
        RowBox[{"digits", "/.", "rules"}]}], "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RootPlot", "[", 
   RowBox[{"fun_", ",", 
    RowBox[{"{", 
     RowBox[{"var_", ",", "varmin_", ",", "varmax_"}], "}"}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"f", "=", "fun"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Plot", "[", 
     RowBox[{"f", ",", 
      RowBox[{"{", 
       RowBox[{"var", ",", "varmin", ",", "varmax"}], "}"}], ",", 
      "\[IndentingNewLine]", "opts", ",", "\[IndentingNewLine]", 
      RowBox[{"Mesh", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"{", "0", "}"}], "}"}]}], ",", 
      RowBox[{"MeshFunctions", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"f", "/.", 
          RowBox[{"var", "\[Rule]", "#"}]}], "&"}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"MeshStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Red", ",", 
         RowBox[{"PointSize", "[", "Medium", "]"}]}], "}"}]}]}], "]"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SimplePath", "[", "lis_List", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"base", ",", "angle", ",", "sorted"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"base", "=", 
      RowBox[{"First", "[", 
       RowBox[{"SortBy", "[", 
        RowBox[{"lis", ",", "Last"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"angle", "[", 
       RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
      RowBox[{"ArcTan", "@@", 
       RowBox[{"(", 
        RowBox[{"b", "-", "a"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"sorted", "=", 
      RowBox[{"Sort", "[", 
       RowBox[{
        RowBox[{"Complement", "[", 
         RowBox[{"lis", ",", 
          RowBox[{"{", "base", "}"}]}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"angle", "[", 
           RowBox[{"base", ",", "#1"}], "]"}], "\[LessEqual]", 
          RowBox[{"angle", "[", 
           RowBox[{"base", ",", "#2"}], "]"}]}], "&"}]}], "]"}]}], ";", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", "base", "}"}], ",", "sorted"}], "]"}]}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StandardDeviationPlot", "[", 
   RowBox[{
    RowBox[{"data_", "?", "VectorQ"}], ",", 
    RowBox[{"n_:", "1"}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "ListPlot", "]"}]}]}], "]"}], ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"in", ",", "out", ",", 
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "data", "]"}]}], ",", "lenrange", ",", 
      RowBox[{"\[Mu]", "=", 
       RowBox[{"Mean", "[", "data", "]"}]}], ",", 
      RowBox[{"\[Sigma]", "=", 
       RowBox[{"StandardDeviation", "[", "data", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"lenrange", "=", 
      RowBox[{"Range", "[", 
       RowBox[{"Length", "[", "data", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"in", "=", 
      RowBox[{"Pick", "[", 
       RowBox[{"lenrange", ",", 
        RowBox[{"Thread", "[", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"data", "-", "\[Mu]"}], ")"}], "/", "\[Sigma]"}], "]"}], 
          "<", "n"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"out", "=", 
      RowBox[{"Complement", "[", 
       RowBox[{"lenrange", ",", "in"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"in", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "in", "]"}], "===", "0"}], ",", 
        RowBox[{"{", 
         RowBox[{"Missing", "[", "]"}], "}"}], ",", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"in", ",", 
           RowBox[{"data", "[", 
            RowBox[{"[", "in", "]"}], "]"}]}], "}"}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"out", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "out", "]"}], "===", "0"}], ",", 
        RowBox[{"{", 
         RowBox[{"Missing", "[", "]"}], "}"}], ",", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"out", ",", 
           RowBox[{"data", "[", 
            RowBox[{"[", "out", "]"}], "]"}]}], "}"}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"in", ",", "out"}], "}"}], ",", "\[IndentingNewLine]", "opts",
        ",", "\[IndentingNewLine]", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", "Pink"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Dashed", ",", "\[IndentingNewLine]", 
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"\[Mu]", "+", 
                RowBox[{"n", " ", "\[Sigma]"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"len", ",", 
               RowBox[{"\[Mu]", "+", 
                RowBox[{"n", " ", "\[Sigma]"}]}]}], "}"}]}], "}"}], "]"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"\[Mu]", "-", 
                RowBox[{"n", " ", "\[Sigma]"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"len", ",", 
               RowBox[{"\[Mu]", "-", 
                RowBox[{"n", " ", "\[Sigma]"}]}]}], "}"}]}], "}"}], "]"}]}], 
         "}"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriangleArea", "[", 
   RowBox[{"tri", ":", 
    RowBox[{"{", 
     RowBox[{"v1_", ",", "v2_", ",", "v3_"}], "}"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Det", "[", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"PadRight", "[", 
        RowBox[{"#", ",", "3", ",", "1"}], "]"}], "&"}], ",", "tri"}], "]"}], 
    "]"}], "/", "2"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"VennDiagram", "[", 
   RowBox[{"f_Symbol", ",", 
    RowBox[{"vars", ":", 
     RowBox[{"{", 
      RowBox[{"A_", ",", "B_"}], "}"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"eqns", ",", "x", ",", "y", ",", 
      RowBox[{"c1", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", ".5"}], ",", "0"}], "}"}]}], ",", 
      RowBox[{"c2", "=", 
       RowBox[{"{", 
        RowBox[{".5", ",", "0"}], "}"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"eqns", "=", 
      RowBox[{"Apply", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"#1", "+", "x"}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"#2", "+", "y"}], ")"}], "2"]}], "<", "1"}], "&"}], ",", 
        
        RowBox[{"{", 
         RowBox[{"c1", ",", "c2"}], "}"}], ",", 
        RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Show", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"RegionPlot", "[", 
        RowBox[{
         RowBox[{"Apply", "[", 
          RowBox[{"f", ",", "eqns"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", 
           RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"y", ",", 
           RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameTicks", "\[Rule]", "None"}], ",", 
         RowBox[{"PlotLabel", "\[Rule]", 
          RowBox[{"f", "@@", "vars"}]}], ",", 
         RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1.2"}], ",", "1.2"}], "}"}]}], "}"}]}], ",", 
         RowBox[{"MaxRecursion", "\[Rule]", "5"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Graphics", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Circle", "[", "c1", "]"}], ",", 
          RowBox[{"Circle", "[", "c2", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"First", "[", "vars", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", ".5"}], ",", ".75"}], "}"}]}], "]"}], ",", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Last", "[", "vars", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{".5", ",", ".75"}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}]}], "]"}]}]], "Input",
 CellTags->"9.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"VennDiagram", "[", 
   RowBox[{"expr_", ",", 
    RowBox[{
     RowBox[{"vars", ":", 
      RowBox[{"{", "__", "}"}]}], "/;", 
     RowBox[{
      RowBox[{"Length", "[", "vars", "]"}], "\[Equal]", "2"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"c1", ",", "c2", ",", "regions", ",", "x", ",", "y", ",", "f"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"c1", ",", "c2"}], "}"}], "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", ".5"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{".5", ",", "0"}], "}"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"regions", "=", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"x", "-", "#1"}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"y", "-", "#2"}], ")"}], "2"]}], "<", "1"}], "&"}], "@@@", 
       RowBox[{"{", 
        RowBox[{"c1", ",", "c2"}], "}"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"f", "=", 
      RowBox[{
       RowBox[{"expr", "/.", 
        RowBox[{"Thread", "[", 
         RowBox[{"vars", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}]}], "]"}]}], "&"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"RegionPlot", "[", 
         RowBox[{
          RowBox[{"f", "@@", "regions"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", 
            RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", 
            RowBox[{"-", "1.2"}], ",", "1.2"}], "}"}], ",", 
          RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
          RowBox[{"FrameTicks", "\[Rule]", "None"}], ",", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"TraditionalForm", "[", "expr", "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"LabelStyle", "\[Rule]", 
           RowBox[{"Directive", "[", "8", "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Graphics", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Circle", "[", "c1", "]"}], ",", 
           RowBox[{"Circle", "[", "c2", "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"vars", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", ".5"}], ",", ".75"}], "}"}]}], "]"}], ",", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"vars", "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{".5", ",", ".75"}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
       "\[IndentingNewLine]", "}"}], "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"VennDiagram", "[", 
   RowBox[{"expr_", ",", 
    RowBox[{
     RowBox[{"vars", ":", 
      RowBox[{"{", "__", "}"}]}], "/;", 
     RowBox[{
      RowBox[{"Length", "[", "vars", "]"}], "\[Equal]", "3"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "c1", ",", "c2", ",", "c3", ",", "regions", ",", "x", ",", "y", ",", 
      "f"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"c1", ",", "c2", ",", "c3"}], "}"}], "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", ".5"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{".5", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"regions", "=", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"x", "-", "#1"}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"y", "-", "#2"}], ")"}], "2"]}], "<", "1"}], "&"}], "@@@", 
       RowBox[{"{", 
        RowBox[{"c1", ",", "c2", ",", "c3"}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f", "=", 
      RowBox[{
       RowBox[{"expr", "/.", 
        RowBox[{"Thread", "[", 
         RowBox[{"vars", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2", ",", "#3"}], "}"}]}], "]"}]}], "&"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"RegionPlot", "[", 
         RowBox[{
          RowBox[{"f", "@@", "regions"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", 
            RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", 
            RowBox[{"-", "2.2"}], ",", "1.2"}], "}"}], ",", 
          RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
          RowBox[{"FrameTicks", "\[Rule]", "None"}], ",", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"TraditionalForm", "[", "expr", "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"LabelStyle", "\[Rule]", 
           RowBox[{"Directive", "[", "8", "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Graphics", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Circle", "[", "c1", "]"}], ",", 
           RowBox[{"Circle", "[", "c2", "]"}], ",", 
           RowBox[{"Circle", "[", "c3", "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"vars", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", ".5"}], ",", ".75"}], "}"}]}], "]"}], ",", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"vars", "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{".5", ",", ".75"}], "}"}]}], "]"}], ",", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"vars", "[", 
              RowBox[{"[", "3", "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"-", "1.75"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
       "\[IndentingNewLine]", "}"}], "]"}]}]}], "]"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection"],

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"EndPackage", "[", "]"}], "*)"}]], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section"],

Cell[CellGroupData[{

Cell["Load package", "Subsection"],

Cell["Quit current session:", "Text"],

Cell[BoxData["Quit"], "Input",ExpressionUUID->"ca55437d-d504-4f90-a60b-7f3e93d318c2"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to evaluate init \
cells dialog)."
}], "Text"],

Cell[BoxData[
 RowBox[{"<<", "EPM`"}]], "Input",ExpressionUUID->"0939886d-4429-4862-896d-fefdceb05800"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection"],

Cell[BoxData[
 RowBox[{"?", "AminoAcidPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "CentroidPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "ChemicalSpaceFillingPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "colorWheel"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "ComplexListPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "ComplexRootPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "ConvexHullPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "DotPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "EigenvectorPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "EpicycloidPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "Hypocycloid"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "HypocycloidPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "Lattice3D"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "PathPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "RandomWalkPi"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "RootPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "SimplePath"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "StandardDeviationPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "VennDiagram"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection"],

Cell[CellGroupData[{

Cell["AminoAcidPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"ChemicalData", "[", "\"\<AminoAcids\>\"", "]"}]], "Input",Expression\
UUID->"c08bc24b-a7a6-47f9-b578-0f52918df75b"],

Cell[BoxData[
 RowBox[{"AminoAcidPlot", "[", "\"\<Glycine\>\"", "]"}]], "Input",ExpressionUU\
ID->"b1d4f484-7adc-4ea2-b1ef-8a95c9847250"],

Cell[BoxData[
 RowBox[{"AminoAcidPlot", "[", 
  RowBox[{"\"\<LTryptophan\>\"", ",", "\"\<MoleculePlot\>\""}], 
  "]"}]], "Input",ExpressionUUID->"51171762-cfa5-4422-bd69-914cfda7c1c8"]
}, Closed]],

Cell[CellGroupData[{

Cell["CentroidPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"CentroidPlot", "[", 
  RowBox[{"Triangle", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}]}], "}"}], "]"}], "]"}]], "Input",Expressi\
onUUID->"3c407dd9-0b9d-433d-a49c-8f0a997b3611"],

Cell["\<\
Test pathological example where the points all lie on a straight line:\
\>", "Text"],

Cell[BoxData[
 RowBox[{"CentroidPlot", "[", 
  RowBox[{"Triangle", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0"}], "}"}]}], "}"}], "]"}], "]"}]], "Input",Expressi\
onUUID->"b1247f5e-9d45-4589-8f16-e764df531425"]
}, Closed]],

Cell[CellGroupData[{

Cell["ChemicalSpaceFillingPlot", "Subsubsection"],

Cell["\<\
Either the .sdf file must be on your path or you should give a full path name.\
\>", "Text"],

Cell[BoxData[
 RowBox[{"tryptophan", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
    "$UserBaseDirectory", ",", "\"\<Applications\>\"", ",", "\"\<EPM\>\"", 
     ",", "\"\<Data\>\"", ",", "\"\<ltryptophan.sdf\>\""}], "}"}], 
   "]"}]}]], "Input",ExpressionUUID->"efa3a333-01e5-4aa5-892e-4bae6a40f0a8"],

Cell[BoxData[
 RowBox[{"ChemicalSpaceFillingPlot", "[", "tryptophan", "]"}]], "Input",Expres\
sionUUID->"2241cdc6-9a3d-417a-9b81-a727c2b910fa"]
}, Closed]],

Cell[CellGroupData[{

Cell["colorWheel", "Subsubsection"],

Cell[BoxData[
 RowBox[{"colorWheel", "[", 
  FractionBox["\[Pi]", "256"], "]"}]], "Input",ExpressionUUID->"1133e23b-fe89-\
48cd-ad72-baac84349a1f"]
}, Closed]],

Cell[CellGroupData[{

Cell["ComplexListPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"ComplexListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", "I"}], ",", 
     RowBox[{"2", "+", "I"}], ",", 
     RowBox[{"1", "-", 
      RowBox[{"2", "I"}]}], ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Blue", ",", 
      RowBox[{"PointSize", "[", "Large", "]"}]}], "}"}]}]}], "]"}]], "Input",E\
xpressionUUID->"0187f8b2-2328-4bae-aa17-ecfdeb3307aa"]
}, Closed]],

Cell[CellGroupData[{

Cell["ComplexRootPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"ComplexRootPlot", "[", 
  RowBox[{
   RowBox[{"Cyclotomic", "[", 
    RowBox[{"17", ",", "z"}], "]"}], ",", "z", ",", 
   RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}]], "Input",Expression\
UUID->"6aed3c21-8af6-4db4-a779-7b0a420c3fc9"]
}, Closed]],

Cell[CellGroupData[{

Cell["ConvexHullPlot", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"30", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ConvexHullPlot", "[", 
  RowBox[{"pts", ",", 
   RowBox[{"Axes", "\[Rule]", "Automatic"}]}], "]"}]}], "Input",ExpressionUUID\
->"8d38285b-bee9-4471-be80-fbe5f5df0e22"]
}, Closed]],

Cell[CellGroupData[{

Cell["DotPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
    "$UserBaseDirectory", ",", "\"\<Applications\>\"", ",", "\"\<EPM\>\"", 
     ",", "\"\<Data\>\""}], "}"}], "]"}], "]"}]], "Input",ExpressionUUID->\
"d044adc8-1a3c-4c65-9ef0-7c40c91b3ea6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"seq1", "=", 
   RowBox[{"First", "@", 
    RowBox[{"Import", "[", "\"\<H5N1ChickenDQ023146.1.fasta\>\"", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"seq2", "=", 
   RowBox[{"First", "@", 
    RowBox[{"Import", "[", "\"\<H5N1DuckDQ232610.1.fasta\>\"", "]"}]}]}], 
  ";"}]}], "Input",ExpressionUUID->"bbd3c5bb-4f40-4008-a59a-98e2858fb7e8"],

Cell[BoxData[
 RowBox[{"DotPlot", "[", 
  RowBox[{"seq1", ",", "seq2", ",", "\[IndentingNewLine]", 
   RowBox[{"WindowSize", "\[Rule]", "6"}], ",", "\[IndentingNewLine]", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<H5N1ChickenDQ023146\>\"", ",", "\"\<H5N1DuckDQ232610\>\""}],
      "}"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"ColorRules", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "Red"}], ",", 
      RowBox[{"0", "\[Rule]", "White"}]}], "}"}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",ExpressionUUID->"d24e03f2-d2cd-4513-a5dc-d708e0f66845"]
}, Closed]],

Cell[CellGroupData[{

Cell["EigenvectorPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<EPM`RandomWalks`\>\"", "]"}]], "Input", \
"TOP",ExpressionUUID->"7c746685-64ca-45b2-9ae2-8bee61639f4a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"coords", "=", 
   RowBox[{"RandomWalk", "[", 
    RowBox[{"10000", ",", 
     RowBox[{"Dimension", "\[Rule]", "2"}], ",", 
     RowBox[{"LatticeWalk", "\[Rule]", "False"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[ScriptCapitalT]", "=", 
   RowBox[{"RadiusOfGyrationTensor", "[", "coords", "]"}]}], ";"}]}], "Input",\
ExpressionUUID->"128b7877-ff04-4c28-bc94-5ace19228c8d"],

Cell[BoxData[
 RowBox[{"EigenvectorPlot", "[", 
  RowBox[{"coords", ",", "\[ScriptCapitalT]"}], "]"}]], "Input",ExpressionUUID\
->"427935d5-eacc-4851-b3a2-7866f9de0e60"]
}, Closed]],

Cell[CellGroupData[{

Cell["EpicycloidPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"R", "=", "15"}], ",", 
     RowBox[{"r", "=", "11"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"EpicycloidPlot", "[", 
    RowBox[{"R", ",", "r", ",", 
     RowBox[{"2", "\[Pi]", " ", 
      RowBox[{"Denominator", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"R", "-", "r"}], ")"}], "/", "r"}], "]"}]}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",ExpressionUUID->"0a8858d7-e624-4785-\
8ca1-c8da039ce071"]
}, Closed]],

Cell[CellGroupData[{

Cell["Hypocycloid", "Subsubsection"],

Cell[BoxData[
 RowBox[{"Table", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ParametricPlot", "[", 
    RowBox[{
     RowBox[{"Hypocycloid", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"R", ",", "1"}], "}"}], ",", "\[Theta]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]", ",", "0", ",", 
       RowBox[{"2", " ", 
        RowBox[{"Denominator", "[", "R", "]"}], " ", "\[Pi]"}]}], "}"}], ",", 
     
     RowBox[{"Axes", "\[Rule]", "None"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "Tiny"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"R", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"7", "/", "2"}], ",", 
       RowBox[{"13", "/", "5"}], ",", "4", ",", 
       RowBox[{"21", "/", "13"}]}], "}"}]}], "}"}]}], "]"}]], "Input",Expressi\
onUUID->"de94e19e-6989-4297-9c6a-5aba3b33befc"]
}, Closed]],

Cell[CellGroupData[{

Cell["HypocycloidPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"R", "=", "3"}], ",", 
     RowBox[{"r", "=", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"HypocycloidPlot", "[", 
    RowBox[{"R", ",", "r", ",", 
     RowBox[{"2", "\[Pi]", " ", 
      RowBox[{"Denominator", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"R", "-", "r"}], ")"}], "/", "r"}], "]"}]}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",ExpressionUUID->"82040590-e7a3-4d5b-\
ba97-82bf97395ffa"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"HypocycloidPlot", "[", 
    RowBox[{"R", ",", "r", ",", "\[Theta]"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", 
     RowBox[{"0", "+", "0.01"}], ",", 
     RowBox[{"2", "\[Pi]", " ", 
      RowBox[{"Denominator", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"R", "-", "r"}], ")"}], "/", "r"}], "]"}]}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"R", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8"}], "}"}], 
     ",", "Setter"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"r", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
     "Setter"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"SaveDefinitions", "\[Rule]", "True"}]}], "]"}]], "Input",Expressio\
nUUID->"e19c6be0-9bd6-4ef6-a0bb-174a9f2b5624"]
}, Closed]],

Cell[CellGroupData[{

Cell["Lattice3D", "Subsubsection"],

Cell[BoxData[
 RowBox[{"Lattice3D", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "3"}], "}"}], ",", 
   RowBox[{"Background", "\[Rule]", "Pink"}]}], "]"}]], "Input",ExpressionUUID\
->"70b231b1-09b5-44a9-bc1e-c7edb5e3a39d"]
}, Closed]],

Cell[CellGroupData[{

Cell["RandomWalkPi", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"walk", "=", 
   RowBox[{"RandomWalkPi", "[", 
    RowBox[{"10000", ",", "5"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"len", "=", 
   RowBox[{"Length", "[", "walk", "]"}]}], ";"}]}], "Input",ExpressionUUID->\
"10f70f0c-1e2e-4b83-b242-0e5970c8f1ef"],

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{
   RowBox[{"GraphicsComplex", "[", 
    RowBox[{"walk", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", ".2", "]"}], ",", 
       RowBox[{"Line", "[", 
        RowBox[{"Range", "[", "len", "]"}], "]"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]], "Input",Expressi\
onUUID->"9a348d1b-e8fb-4911-86a0-0aecce0fc922"]
}, Closed]],

Cell[CellGroupData[{

Cell["RootPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"RootPlot", "[", 
  RowBox[{
   RowBox[{"Sinc", "[", "z", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", 
     RowBox[{"-", "10"}], ",", "10"}], "}"}]}], "]"}]], "Input",ExpressionUUID\
->"a50bd990-74dd-4c6a-82a7-6b47d3dfa86c"],

Cell[BoxData[
 RowBox[{"RootPlot", "[", 
  RowBox[{
   RowBox[{"z", " ", 
    RowBox[{"Sin", "[", 
     RowBox[{"z", "+", 
      RowBox[{
       SqrtBox["2"], 
       RowBox[{"Sin", "[", "z", "]"}]}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", 
     RowBox[{"-", "20"}], ",", "20"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"MeshStyle", "\[Rule]", 
    RowBox[{"Directive", "[", 
     RowBox[{
      RowBox[{"Opacity", "[", "0.5", "]"}], ",", 
      RowBox[{"PointSize", "[", "Medium", "]"}]}], "]"}]}], ",", 
   RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}]], "Input",Expression\
UUID->"ab5b5410-4d60-4721-9823-57534fca2989"]
}, Closed]],

Cell[CellGroupData[{

Cell["SimplePath", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"50", ",", "2"}], "}"}]}], "]"}]}], ";"}]], "Input",ExpressionUU\
ID->"0d3f0fd0-6ecc-4cee-9d24-0e0196aa3fbd"],

Cell[BoxData[
 RowBox[{"PathPlot", "[", 
  RowBox[{"SimplePath", "[", "pts", "]"}], "]"}]], "Input",ExpressionUUID->\
"30396341-eaff-4108-adda-78cf40b965b1"]
}, Closed]],

Cell[CellGroupData[{

Cell["StandardDeviationPlot", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"5", ",", "8"}], "]"}], ",", 
     RowBox[{"{", "600", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"StandardDeviationPlot", "[", 
  RowBox[{"data", ",", "2"}], "]"}]}], "Input",ExpressionUUID->"26307360-7912-\
462e-981b-86cf5069d033"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"5", ",", "8"}], "]"}], ",", 
     RowBox[{"{", "600", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"StandardDeviationPlot", "[", 
  RowBox[{"data", ",", "1.5", ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"PointSize", "@", "Medium"}], ",", "Black"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"PointSize", "@", "Medium"}], ",", "Gray"}], "}"}]}], 
     "}"}]}]}], "]"}]}], "Input",ExpressionUUID->"ee9956d0-8c87-49e0-83bd-\
e822a246ea9f"]
}, Closed]],

Cell[CellGroupData[{

Cell["VennDiagram", "Subsubsection"],

Cell[BoxData[
 RowBox[{"VennDiagram", "[", 
  RowBox[{"Xor", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B"}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"2d67c308-9c32-4dd3-a94c-1b2322d057ee"],

Cell[BoxData[
 RowBox[{"VennDiagram", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"A", "\[Or]", "B", "\[Or]", "C"}], ")"}], "&&", 
    RowBox[{"\[Not]", 
     RowBox[{"(", 
      RowBox[{"A", "\[And]", "B", "\[And]", "C"}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C"}], "}"}]}], "]"}]], "Input",ExpressionUUID\
->"5b5effe2-379e-4d5e-964c-75e58e0dcc64"]
}, Closed]]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{900, 904},
WindowMargins->{{Automatic, 787}, {Automatic, 57}},
ShowSelection->True,
FrontEndVersion->"11.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 16, \
2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "8.3 Solutions"->{
  Cell[13665, 402, 367, 10, 
  28, "Input", "ExpressionUUID" -> "596e28b4-61bc-4be6-a2ef-a8f9b8125a8f",
   CellTags->"8.3 Solutions"],
  Cell[14946, 449, 213, 6, 
  46, "Input", "ExpressionUUID" -> "70503ff3-990d-46fb-89cb-4721c66be08b",
   CellTags->"8.3 Solutions"]},
 "8.4 Solutions"->{
  Cell[14035, 414, 306, 9, 
  28, "Input", "ExpressionUUID" -> "238fda75-a954-443e-893c-2b3a4afdca69",
   CellTags->"8.4 Solutions"]},
 "8.1 Exercises"->{
  Cell[16227, 495, 2635, 70, 
  199, "Input", "ExpressionUUID" -> "b962834f-d0ab-4cdf-a94a-6af9245e63ae",
   CellTags->"8.1 Exercises"]},
 "i:1"->{
  Cell[26075, 766, 1117, 30, 
  80, "Input", "ExpressionUUID" -> "1f623f56-2b41-459b-b763-aff06f339a43",
   CellTags->"i:1"]},
 "11.1 Solutions"->{
  Cell[34720, 996, 4236, 114, 
  259, "Input", "ExpressionUUID" -> "e794c030-056c-48c6-b5a6-9769b2bd51a5",
   CellTags->"11.1 Solutions"]},
 "9.1"->{
  Cell[54855, 1570, 2881, 81, 
  181, "Input", "ExpressionUUID" -> "a103390c-3ccc-4af5-9dcc-4c118257f486",
   CellTags->"9.1"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"8.3 Solutions", 80660, 2437},
 {"8.4 Solutions", 80950, 2444},
 {"8.1 Exercises", 81105, 2448},
 {"i:1", 81253, 2452},
 {"11.1 Solutions", 81401, 2456},
 {"9.1", 81551, 2460}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 60, 1, 64, "Section", "ExpressionUUID" -> \
"42152a26-3022-4a16-9cd1-1cdcdf5c9b2c",
 InitializationGroup->True],
Cell[642, 25, 240, 9, 49, "Text", "ExpressionUUID" -> \
"1b4abd5c-71e1-46da-beb4-01b99e5cea50"],
Cell[CellGroupData[{
Cell[907, 38, 30, 0, 44, "Subsection", "ExpressionUUID" -> \
"31f55e7b-6c37-49a3-ad51-0161027a0484"],
Cell[940, 40, 109, 2, 32, "Input", "ExpressionUUID" -> \
"98416a8e-44ed-4018-9b38-956f3a5d4154"],
Cell[1052, 44, 191, 5, 32, "Input", "ExpressionUUID" -> \
"4621ab29-8105-472b-bda2-54984919ddc6"],
Cell[1246, 51, 146, 4, 32, "Input", "ExpressionUUID" -> \
"e498b54e-2a83-4866-b9b6-e49086298bb2"],
Cell[1395, 57, 279, 6, 32, "Input", "ExpressionUUID" -> \
"e3550c73-eea6-482c-9824-c27980f59dbf"],
Cell[1677, 65, 112, 2, 32, "Input", "ExpressionUUID" -> \
"23803b3d-59f5-4098-927a-b354a02c1d72"],
Cell[1792, 69, 147, 4, 32, "Input", "ExpressionUUID" -> \
"d31e1397-e9b2-4032-8f6f-14d924e9c766"],
Cell[1942, 75, 209, 5, 32, "Input", "ExpressionUUID" -> \
"0495b534-7874-436f-8400-c64859cc029b"],
Cell[2154, 82, 256, 8, 32, "Input", "ExpressionUUID" -> \
"5ccaca34-91ca-4515-9897-937b145f7a06"],
Cell[2413, 92, 921, 19, 117, "Input", "ExpressionUUID" -> \
"d11bf35b-20f9-400d-a1fb-f8ae90442b99"],
Cell[3337, 113, 131, 3, 32, "Input", "ExpressionUUID" -> \
"78895a61-0957-403f-88e8-fc9999897352"],
Cell[3471, 118, 140, 4, 32, "Input", "ExpressionUUID" -> \
"c82a9d88-90b7-409c-84eb-1c2625d82884"],
Cell[3614, 124, 181, 3, 32, "Input", "ExpressionUUID" -> \
"f825b041-4090-44aa-9f84-b7153f0abceb"]
}, Closed]],
Cell[CellGroupData[{
Cell[3832, 132, 34, 0, 36, "Subsection", "ExpressionUUID" -> \
"5f98f236-f255-4096-8825-5ae99e505ab3"],
Cell[3869, 134, 565, 9, 96, "Input", "ExpressionUUID" -> \
"ac92bf12-8655-40c5-b26f-e04a0e8c849a"],
Cell[4437, 145, 123, 3, 32, "Input", "ExpressionUUID" -> \
"4dc20f36-7952-4bf3-8ea5-8b97c9ca9f80"]
}, Closed]],
Cell[CellGroupData[{
Cell[4597, 153, 57, 0, 36, "Subsection", "ExpressionUUID" -> \
"480f9065-70cd-499e-83c8-1e42ca9eb278"],
Cell[4657, 155, 511, 9, 117, "Input", "ExpressionUUID" -> \
"3261a7b2-8b8b-4f74-b6e7-90c30aff372e"],
Cell[5171, 166, 425, 9, 75, "Input", "ExpressionUUID" -> \
"b64f5432-ddc3-4d0c-8b6d-f101047fe77c"],
Cell[5599, 177, 288, 7, 54, "Input", "ExpressionUUID" -> \
"67bcfbda-1bca-456e-be5f-9bc38ff62d7d"],
Cell[5890, 186, 226, 5, 32, "Input", "ExpressionUUID" -> \
"752c747b-aa13-409e-b6ec-73b8fe7f83c9"],
Cell[6119, 193, 306, 6, 75, "Input", "ExpressionUUID" -> \
"a8b972ba-ffc4-4a90-9459-90d22594b0b4"],
Cell[6428, 201, 304, 6, 54, "Input", "ExpressionUUID" -> \
"4b8d8a04-fc47-4229-bf99-5bc57daaea1d"],
Cell[6735, 209, 296, 7, 75, "Input", "ExpressionUUID" -> \
"24ce754a-72bf-4c6c-a1ef-12264a6e60bf"],
Cell[7034, 218, 187, 5, 32, "Input", "ExpressionUUID" -> \
"44a1f96e-173b-4b05-9ac3-ed7eab3ad0da"],
Cell[7224, 225, 572, 12, 96, "Input", "ExpressionUUID" -> \
"8ff15356-5b8c-451a-8fc2-455c0d3ced01"],
Cell[7799, 239, 238, 5, 32, "Input", "ExpressionUUID" -> \
"828facf5-3abc-458c-ae04-60f882785652"],
Cell[8040, 246, 629, 14, 96, "Input", "ExpressionUUID" -> \
"57070849-21ac-4497-bcf8-6d1698c05d0d"],
Cell[8672, 262, 470, 10, 96, "Input", "ExpressionUUID" -> \
"cbf8a61d-d3d7-4cf8-a812-d4ca18fa148a"],
Cell[9145, 274, 631, 14, 96, "Input", "ExpressionUUID" -> \
"9b225f87-8a49-4fd1-9683-e8a9e2a9f318"],
Cell[9779, 290, 397, 10, 75, "Input", "ExpressionUUID" -> \
"7a97b885-8494-417f-9094-4e2dd6d11d63"],
Cell[10179, 302, 274, 6, 75, "Input", "ExpressionUUID" -> \
"c54408ba-e076-42d2-ba8c-9f31c12226c0"],
Cell[10456, 310, 337, 7, 75, "Input", "ExpressionUUID" -> \
"297736f2-a843-4837-a337-6f8a5b63f02a"],
Cell[10796, 319, 322, 7, 54, "Input", "ExpressionUUID" -> \
"f8ddcc6f-eed3-435c-b5d4-99dde137b2ab"],
Cell[11121, 328, 443, 11, 75, "Input", "ExpressionUUID" -> \
"0c0525d2-e869-42c9-8b82-b29819fed015"],
Cell[11567, 341, 259, 6, 54, "Input", "ExpressionUUID" -> \
"b6df1cdb-34a1-4d80-93dc-41e37a1cdb56"],
Cell[11829, 349, 480, 10, 117, "Input", "ExpressionUUID" -> \
"46adfddc-5356-4a37-8812-1255c2d19b8e"],
Cell[12312, 361, 528, 11, 75, "Input", "ExpressionUUID" -> \
"9a76d482-2275-4cde-b316-08fb42f6ade1"],
Cell[12843, 374, 434, 9, 96, "Input", "ExpressionUUID" -> \
"9eeb43b9-df0e-40fe-9357-5f493efbff3e"]
}, Closed]],
Cell[CellGroupData[{
Cell[13314, 388, 29, 0, 36, "Subsection", "ExpressionUUID" -> \
"7f998b26-7391-4433-9c30-ae684cd875d4"],
Cell[13346, 390, 155, 4, 28, "Input", "ExpressionUUID" -> \
"eb5bfc29-67f8-4b35-99b1-654c80bde2a2"],
Cell[13504, 396, 158, 4, 28, "Input", "ExpressionUUID" -> \
"168ba71f-1815-4257-a445-13c24ba250ec"],
Cell[13665, 402, 367, 10, 28, "Input", "ExpressionUUID" -> \
"596e28b4-61bc-4be6-a2ef-a8f9b8125a8f",
 CellTags->"8.3 Solutions"],
Cell[14035, 414, 306, 9, 28, "Input", "ExpressionUUID" -> \
"238fda75-a954-443e-893c-2b3a4afdca69",
 CellTags->"8.4 Solutions"],
Cell[14344, 425, 281, 8, 28, "Input", "ExpressionUUID" -> \
"f3e404d0-67cf-4043-9c70-cb63302fc9e7"],
Cell[14628, 435, 248, 7, 28, "Input", "ExpressionUUID" -> \
"71b59040-71f6-4ce6-b944-1fca36b1a358"]
}, Closed]],
Cell[CellGroupData[{
Cell[14913, 447, 30, 0, 36, "Subsection", "ExpressionUUID" -> \
"b6f1e1eb-0c08-4f05-8fe1-f89a2597d97b"],
Cell[14946, 449, 213, 6, 46, "Input", "ExpressionUUID" -> \
"70503ff3-990d-46fb-89cb-4721c66be08b",
 CellTags->"8.3 Solutions"],
Cell[15162, 457, 184, 5, 28, "Input", "ExpressionUUID" -> \
"8770d455-8a28-4660-972b-cdf866a2b922"]
}, Closed]],
Cell[CellGroupData[{
Cell[15383, 467, 37, 0, 36, "Subsection", "ExpressionUUID" -> \
"5e96baa9-33ca-4949-8747-9bbbf0bc1abe"],
Cell[15423, 469, 74, 1, 28, "Input", "ExpressionUUID" -> \
"6e9b1948-ff3f-401c-a12d-f75bd330b5e4"]
}, Closed]],
Cell[CellGroupData[{
Cell[15534, 475, 63, 0, 36, "Subsection", "ExpressionUUID" -> \
"38c18206-bb47-406b-b1c9-eb272ab2baa0"],
Cell[15600, 477, 624, 16, 63, "Input", "ExpressionUUID" -> \
"042bf8e2-bcc2-4161-89eb-538669791a01"],
Cell[16227, 495, 2635, 70, 199, "Input", "ExpressionUUID" -> \
"b962834f-d0ab-4cdf-a94a-6af9245e63ae",
 CellTags->"8.1 Exercises"],
Cell[18865, 567, 2722, 68, 267, "Input", "ExpressionUUID" -> \
"03f38e2e-33e7-434a-92bd-586f29f3f880"],
Cell[21590, 637, 803, 25, 46, "Input", "ExpressionUUID" -> \
"38ec09f5-3384-4400-85c4-406a0386fa3a"],
Cell[22396, 664, 867, 25, 63, "Input", "ExpressionUUID" -> \
"fe9a1f0d-b087-495e-8595-067a9da9c30c"],
Cell[23266, 691, 447, 12, 46, "Input", "ExpressionUUID" -> \
"6d3bfeb4-1ae1-4246-8a75-84d7aa202181"],
Cell[23716, 705, 2356, 59, 216, "Input", "ExpressionUUID" -> \
"aa3decd4-509e-4de0-a216-861435b3af74"],
Cell[26075, 766, 1117, 30, 80, "Input", "ExpressionUUID" -> \
"1f623f56-2b41-459b-b763-aff06f339a43",
 CellTags->"i:1"],
Cell[27195, 798, 4030, 103, 339, "Input", "ExpressionUUID" -> \
"8816181c-41cd-4d73-a53d-a06af33fc622"],
Cell[31228, 903, 3489, 91, 331, "Input", "ExpressionUUID" -> \
"d6a5a13a-fba2-496b-9751-ac12bc432ff2"],
Cell[34720, 996, 4236, 114, 259, "Input", "ExpressionUUID" -> \
"e794c030-056c-48c6-b5a6-9769b2bd51a5",
 CellTags->"11.1 Solutions"],
Cell[38959, 1112, 808, 27, 49, "Input", "ExpressionUUID" -> \
"ad19a2dc-f658-4caf-b342-a10b5c966a2c"],
Cell[39770, 1141, 3351, 85, 233, "Input", "ExpressionUUID" -> \
"2f9233e1-34b5-482a-839e-ed50853c8e5c"],
Cell[43124, 1228, 2587, 71, 216, "Input", "ExpressionUUID" -> \
"9214bede-1abb-4f60-b611-4522d807e6c0"],
Cell[45714, 1301, 1140, 32, 97, "Input", "ExpressionUUID" -> \
"68ea53fa-7cd6-4dcd-9675-20f59886a19d"],
Cell[46857, 1335, 1574, 47, 114, "Input", "ExpressionUUID" -> \
"56fad64b-6543-440e-a545-a520f6f99479"],
Cell[48434, 1384, 1072, 30, 97, "Input", "ExpressionUUID" -> \
"f9572df9-ee85-413a-8530-1c3f710d25f6"],
Cell[49509, 1416, 1190, 35, 97, "Input", "ExpressionUUID" -> \
"40228c9c-bcd1-4e27-887d-db8ebc4ba587"],
Cell[50702, 1453, 3745, 100, 301, "Input", "ExpressionUUID" -> \
"513ae220-4fac-49df-b071-139b8a3b0e6d"],
Cell[54450, 1555, 402, 13, 28, "Input", "ExpressionUUID" -> \
"759d3d45-e594-4c1a-bfd7-63c6c4780ec5"],
Cell[54855, 1570, 2881, 81, 181, "Input", "ExpressionUUID" -> \
"a103390c-3ccc-4af5-9dcc-4c118257f486",
 CellTags->"9.1"],
Cell[57739, 1653, 3065, 85, 211, "Input", "ExpressionUUID" -> \
"c4597b96-3bee-4c8d-bbf2-52e830ffbb31"],
Cell[60807, 1740, 3533, 98, 244, "Input", "ExpressionUUID" -> \
"c6ed78b7-c322-4f86-a6d7-bfc88d6f01e2"]
}, Closed]],
Cell[CellGroupData[{
Cell[64377, 1843, 41, 0, 36, "Subsection", "ExpressionUUID" -> \
"7d4c8b5a-3c0a-4215-a596-71136186811f"],
Cell[64421, 1845, 51, 1, 28, "Input", "ExpressionUUID" -> \
"e004f9ab-8093-4f4b-96d8-79d51c116e25"]
}, Closed]],
Cell[CellGroupData[{
Cell[64509, 1851, 32, 0, 36, "Subsection", "ExpressionUUID" -> \
"d4b7632c-eb84-4555-b3b8-ee2368d690e9"],
Cell[64544, 1853, 83, 2, 28, "Input", "ExpressionUUID" -> \
"02fb980e-0025-4bbe-9d85-6131b1432a82"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[64676, 1861, 27, 0, 64, "Section", "ExpressionUUID" -> \
"dc186613-a628-468d-a306-40e90685b68f"],
Cell[CellGroupData[{
Cell[64728, 1865, 34, 0, 44, "Subsection", "ExpressionUUID" -> \
"711a20e5-5249-4af1-b630-739d28a042e8"],
Cell[64765, 1867, 37, 0, 30, "Text", "ExpressionUUID" -> \
"b3ca0355-b80d-4271-b2a1-0d7ae5d805ff"],
Cell[64805, 1869, 85, 0, 32, "Input", "ExpressionUUID" -> \
"ca55437d-d504-4f90-a60b-7f3e93d318c2"],
Cell[64893, 1871, 183, 6, 30, "Text", "ExpressionUUID" -> \
"974668db-7137-444f-a50b-0dafde895bec"],
Cell[65079, 1879, 103, 1, 32, "Input", "ExpressionUUID" -> \
"0939886d-4429-4862-896d-fefdceb05800"]
}, Open  ]],
Cell[CellGroupData[{
Cell[65219, 1885, 41, 0, 44, "Subsection", "ExpressionUUID" -> \
"40ff83d5-9197-466a-b2a1-9a4e67d46252"],
Cell[65263, 1887, 56, 1, 32, "Input", "ExpressionUUID" -> \
"15cc4bfd-b6b8-492d-a45d-e641c2f6c41f"],
Cell[65322, 1890, 55, 1, 32, "Input", "ExpressionUUID" -> \
"80eaadf9-c0b6-49b6-9960-7957dbcf3e96"],
Cell[65380, 1893, 67, 1, 32, "Input", "ExpressionUUID" -> \
"f8f1ec81-62fa-4040-81c2-a8dbd73bd618"],
Cell[65450, 1896, 53, 1, 32, "Input", "ExpressionUUID" -> \
"371203c9-8898-4d45-b0ca-d68d1fccc823"],
Cell[65506, 1899, 58, 1, 32, "Input", "ExpressionUUID" -> \
"d56272c5-15ff-4443-a603-360691e9682e"],
Cell[65567, 1902, 58, 1, 32, "Input", "ExpressionUUID" -> \
"73018b29-8e05-4134-ba55-f304aa0ea375"],
Cell[65628, 1905, 57, 1, 32, "Input", "ExpressionUUID" -> \
"1259d2e4-78ec-4f52-9929-12b471ed1739"],
Cell[65688, 1908, 50, 1, 32, "Input", "ExpressionUUID" -> \
"a3805007-262a-4bf1-a5d8-729c18d1ec08"],
Cell[65741, 1911, 58, 1, 32, "Input", "ExpressionUUID" -> \
"fe19f531-a3ce-440c-8dd0-9a6c3be7a5b8"],
Cell[65802, 1914, 57, 1, 32, "Input", "ExpressionUUID" -> \
"096ee15e-1218-4343-a5e2-e6caafdd3756"],
Cell[65862, 1917, 54, 1, 32, "Input", "ExpressionUUID" -> \
"b02a05e6-3ff2-4b3e-a355-455d0f3c2e3d"],
Cell[65919, 1920, 58, 1, 32, "Input", "ExpressionUUID" -> \
"6244fa2f-da95-485d-9f73-9fc481db8f14"],
Cell[65980, 1923, 52, 1, 32, "Input", "ExpressionUUID" -> \
"82627a53-b1eb-4dc4-bfca-d2b4aff89a41"],
Cell[66035, 1926, 51, 1, 32, "Input", "ExpressionUUID" -> \
"ab0f6fd7-bbde-429e-a03e-2a35e70c8844"],
Cell[66089, 1929, 55, 1, 32, "Input", "ExpressionUUID" -> \
"e2fc36ca-f705-4d9d-81ae-6a5291dfb7b8"],
Cell[66147, 1932, 51, 1, 32, "Input", "ExpressionUUID" -> \
"d6610326-2314-4471-994a-b2695eefefbc"],
Cell[66201, 1935, 53, 1, 32, "Input", "ExpressionUUID" -> \
"5beb1267-e42c-4585-aeb2-3f56d79b3079"],
Cell[66257, 1938, 64, 1, 32, "Input", "ExpressionUUID" -> \
"3e6a1174-c8ce-41d4-b036-89e174218378"],
Cell[66324, 1941, 54, 1, 32, "Input", "ExpressionUUID" -> \
"0ca7472e-e7e1-4546-ac19-e9682bd306f6"]
}, Closed]],
Cell[CellGroupData[{
Cell[66415, 1947, 56, 0, 36, "Subsection", "ExpressionUUID" -> \
"20a2c6e0-033d-4155-b3c7-4e10e32d994c"],
Cell[CellGroupData[{
Cell[66496, 1951, 38, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"e6cf2f51-950e-4213-b1cf-4ad505c7702f"],
Cell[66537, 1953, 139, 2, 32, "Input", "ExpressionUUID" -> \
"c08bc24b-a7a6-47f9-b578-0f52918df75b"],
Cell[66679, 1957, 137, 2, 32, "Input", "ExpressionUUID" -> \
"b1d4f484-7adc-4ea2-b1ef-8a95c9847250"],
Cell[66819, 1961, 184, 3, 32, "Input", "ExpressionUUID" -> \
"51171762-cfa5-4422-bd69-914cfda7c1c8"]
}, Closed]],
Cell[CellGroupData[{
Cell[67040, 1969, 37, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"4b4d6a3f-286b-4bae-91a2-1e3502dba7f0"],
Cell[67080, 1971, 398, 12, 32, "Input", "ExpressionUUID" -> \
"3c407dd9-0b9d-433d-a49c-8f0a997b3611"],
Cell[67481, 1985, 94, 2, 30, "Text", "ExpressionUUID" -> \
"3d7fb46b-39ee-41e1-93c2-1e0c957e46c5"],
Cell[67578, 1989, 398, 12, 32, "Input", "ExpressionUUID" -> \
"b1247f5e-9d45-4589-8f16-e764df531425"]
}, Closed]],
Cell[CellGroupData[{
Cell[68013, 2006, 49, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"f567bba3-86db-4ea9-984b-88f6d35d35e2"],
Cell[68065, 2008, 102, 2, 30, "Text", "ExpressionUUID" -> \
"a4f218b1-0fe9-4188-84cd-586b0dd9c99a"],
Cell[68170, 2012, 325, 7, 32, "Input", "ExpressionUUID" -> \
"efa3a333-01e5-4aa5-892e-4bae6a40f0a8"],
Cell[68498, 2021, 143, 2, 32, "Input", "ExpressionUUID" -> \
"2241cdc6-9a3d-417a-9b81-a727c2b910fa"]
}, Closed]],
Cell[CellGroupData[{
Cell[68678, 2028, 35, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"06e46b1d-ada4-414b-8ffb-c73c479ddeeb"],
Cell[68716, 2030, 147, 3, 47, "Input", "ExpressionUUID" -> \
"1133e23b-fe89-48cd-ad72-baac84349a1f"]
}, Closed]],
Cell[CellGroupData[{
Cell[68900, 2038, 40, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"49b1c5f8-90ee-4859-b13d-51c641b3c16f"],
Cell[68943, 2040, 485, 14, 32, "Input", "ExpressionUUID" -> \
"0187f8b2-2328-4bae-aa17-ecfdeb3307aa"]
}, Closed]],
Cell[CellGroupData[{
Cell[69465, 2059, 40, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"4974a196-c62c-4cc3-8f3a-fbbf609c8f40"],
Cell[69508, 2061, 268, 6, 32, "Input", "ExpressionUUID" -> \
"6aed3c21-8af6-4db4-a779-7b0a420c3fc9"]
}, Closed]],
Cell[CellGroupData[{
Cell[69813, 2072, 39, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"459ea7af-278e-4f85-b13e-a6f014160022"],
Cell[69855, 2074, 382, 11, 54, "Input", "ExpressionUUID" -> \
"8d38285b-bee9-4471-be80-fbe5f5df0e22"]
}, Closed]],
Cell[CellGroupData[{
Cell[70274, 2090, 32, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"cb937fb9-44aa-4a82-8948-eac3ce912bf3"],
Cell[70309, 2092, 298, 7, 32, "Input", "ExpressionUUID" -> \
"d044adc8-1a3c-4c65-9ef0-7c40c91b3ea6"],
Cell[70610, 2101, 395, 10, 54, "Input", "ExpressionUUID" -> \
"bbd3c5bb-4f40-4008-a59a-98e2858fb7e8"],
Cell[71008, 2113, 615, 13, 117, "Input", "ExpressionUUID" -> \
"d24e03f2-d2cd-4513-a5dc-d708e0f66845"]
}, Closed]],
Cell[CellGroupData[{
Cell[71660, 2131, 40, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"be236de1-9f1a-479e-b9b7-73f09a7b748d"],
Cell[71703, 2133, 145, 2, 32, "Input", "ExpressionUUID" -> \
"7c746685-64ca-45b2-9ae2-8bee61639f4a"],
Cell[71851, 2137, 436, 11, 54, "Input", "ExpressionUUID" -> \
"128b7877-ff04-4c28-bc94-5ace19228c8d"],
Cell[72290, 2150, 169, 3, 32, "Input", "ExpressionUUID" -> \
"427935d5-eacc-4851-b3a2-7866f9de0e60"]
}, Closed]],
Cell[CellGroupData[{
Cell[72496, 2158, 39, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"2115db75-810f-44d7-aa4d-77e68dbf34ba"],
Cell[72538, 2160, 530, 15, 75, "Input", "ExpressionUUID" -> \
"0a8858d7-e624-4785-8ca1-c8da039ce071"]
}, Closed]],
Cell[CellGroupData[{
Cell[73105, 2180, 36, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"1e891a6d-b995-4fc3-aecc-e5ac8ad647fb"],
Cell[73144, 2182, 869, 24, 75, "Input", "ExpressionUUID" -> \
"de94e19e-6989-4297-9c6a-5aba3b33befc"]
}, Closed]],
Cell[CellGroupData[{
Cell[74050, 2211, 40, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"ce92a566-d75b-4221-ace7-2ad6de00f415"],
Cell[74093, 2213, 529, 15, 75, "Input", "ExpressionUUID" -> \
"82040590-e7a3-4d5b-ba97-82bf97395ffa"],
Cell[74625, 2230, 1003, 26, 138, "Input", "ExpressionUUID" -> \
"e19c6be0-9bd6-4ef6-a0bb-174a9f2b5624"]
}, Closed]],
Cell[CellGroupData[{
Cell[75665, 2261, 34, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"7fce87ea-e0da-41dc-a5d7-e9af59766733"],
Cell[75702, 2263, 351, 10, 32, "Input", "ExpressionUUID" -> \
"70b231b1-09b5-44a9-bc1e-c7edb5e3a39d"]
}, Closed]],
Cell[CellGroupData[{
Cell[76090, 2278, 37, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"b6a10f84-a1de-4d13-ba9c-fed7fa6d55e3"],
Cell[76130, 2280, 305, 8, 54, "Input", "ExpressionUUID" -> \
"10f70f0c-1e2e-4b83-b242-0e5970c8f1ef"],
Cell[76438, 2290, 439, 11, 54, "Input", "ExpressionUUID" -> \
"9a348d1b-e8fb-4911-86a0-0aecce0fc922"]
}, Closed]],
Cell[CellGroupData[{
Cell[76914, 2306, 33, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"680e1291-b8dc-4b37-8efd-38a54eb896af"],
Cell[76950, 2308, 255, 7, 32, "Input", "ExpressionUUID" -> \
"a50bd990-74dd-4c6a-82a7-6b47d3dfa86c"],
Cell[77208, 2317, 705, 19, 68, "Input", "ExpressionUUID" -> \
"ab5b5410-4d60-4721-9823-57534fca2989"]
}, Closed]],
Cell[CellGroupData[{
Cell[77950, 2341, 35, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"be7f612d-498e-41a9-a173-8de81f5ed8e7"],
Cell[77988, 2343, 243, 7, 32, "Input", "ExpressionUUID" -> \
"0d3f0fd0-6ecc-4cee-9d24-0e0196aa3fbd"],
Cell[78234, 2352, 157, 3, 32, "Input", "ExpressionUUID" -> \
"30396341-eaff-4108-adda-78cf40b965b1"]
}, Closed]],
Cell[CellGroupData[{
Cell[78428, 2360, 46, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"013c691e-1c68-4b5b-9670-e3b3c4f494e4"],
Cell[78477, 2362, 399, 10, 54, "Input", "ExpressionUUID" -> \
"26307360-7912-462e-981b-86cf5069d033"],
Cell[78879, 2374, 707, 20, 75, "Input", "ExpressionUUID" -> \
"ee9956d0-8c87-49e0-83bd-e822a246ea9f"]
}, Closed]],
Cell[CellGroupData[{
Cell[79623, 2399, 36, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"f760567f-12f5-4caf-bb98-edba319e6ceb"],
Cell[79662, 2401, 195, 5, 32, "Input", "ExpressionUUID" -> \
"2d67c308-9c32-4dd3-a94c-1b2322d057ee"],
Cell[79860, 2408, 395, 11, 32, "Input", "ExpressionUUID" -> \
"5b5effe2-379e-4d5e-964c-75e58e0dcc64"]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

