(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     20143,        655]
NotebookOptionsPosition[     12872,        472]
NotebookOutlinePosition[     13573,        501]
CellTagsIndexPosition[     13507,        496]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["EPM`Introduction`", "Section",
 InitializationGroup->True],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox["Essentials of Programming in Mathematica\n",
  FontSlant->"Italic"],
 "\[Copyright] Paul R. Wellin 2015"
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14],

Cell[CellGroupData[{

Cell["Metadata", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Name", ":", " ", "EPM`Introduction`"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Book", ":", " ", 
   RowBox[{
   "Essentials", " ", "of", " ", "Programming", " ", "in", " ", 
    "Mathematica"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Summary", ":", " ", 
   RowBox[{
   "This", " ", "package", " ", "contains", " ", "the", " ", "functions", " ",
     "defined", " ", "in", " ", "Chapter", " ", "1"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Context", ":", " ", "EPM`Introduction`"}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", "Version"}], ":", " ", "1.1"}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Copyright", ":", " ", 
    RowBox[{"Copyright", " ", "2015"}]}], ",", " ", 
   RowBox[{"Paul", " ", "R", " ", "Wellin"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{
   "Dec", " ", "2012", "\[IndentingNewLine]", "\t\t\t", "Version", " ", "1.1",
     " ", "by", " ", "Paul", " ", "Wellin", " ", "July", " ", "2014"}]}], " ",
   "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Keywords", ":", " ", 
    RowBox[{"leading", " ", "digit"}]}], ",", " ", 
   RowBox[{"pass", " ", "phrase"}], ",", " ", "StringMemberQ"}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Source", ":", " ", 
   RowBox[{"Introduction", ".", "nb"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", "Version"}], ":", " ", "10.3"}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "11.1"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"3d782710-4ead-4efa-98ee-737dd709e683"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "LeadingDigit", ",", "LeadingDigitChart", ",", "PassPhrase", ",", 
   "StringMemberQ"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"BeginPackage", "[", "\"\<EPM`Introduction`\>\"", "]"}], " ", 
  "*)"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for public functions", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"LeadingDigit", "::", "usage"}], "MessageName"], "=", 
   "\"\<LeadingDigit[\!\(\*
StyleBox[\"n\", \"TI\"]\)] returns the leading digit of the integer \!\(\*
StyleBox[\"n\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"LeadingDigitChart", "::", "usage"}], "MessageName"], "=", 
   "\"\<LeadingDigitChart[\!\(\*
StyleBox[\"data\", \"TI\"]\)] makes a horizontal bar chart showing the \
distribution of the leading digits among the \!\(\*
StyleBox[\"data\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LeadingDigitChart", "::", "badinput"}], "=", 
   "\"\<The argument to LeadingDigitChart must be an array of numerical data.\
\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"PassPhrase", "::", "usage"}], "MessageName"], "=", 
   "\"\<PassPhrase[\!\(\*
StyleBox[\"n\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"{\", \"TI\"]\)\!\(\*
StyleBox[\"min\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"max\", \"TI\"]\)\!\(\*
StyleBox[\"}\", \"TI\"]\)] generates a phrase of \!\(\*
StyleBox[\"n\", \"TI\"]\) random words from the dictionary each of string \
length from \!\(\*
StyleBox[\"min\", \"TI\"]\) to \!\(\*
StyleBox[\"max\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"StringMemberQ", "::", "usage"}], "MessageName"], "=", 
   "\"\<StringMemberQ[\!\(\*
StyleBox[\"str\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"chars\", \"TI\"]\)] returns True if the list of string characters, \
\!\(\*
StyleBox[\"chars\", \"TI\"]\) are all present in the string \!\(\*
StyleBox[\"str\", \"TI\"]\).\>\""}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "BondPercolation", "]"}], "=", 
   RowBox[{"Options", "[", "Graph", "]"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "LeadingDigitChart", "]"}], "=", 
   RowBox[{"Options", "[", "BarChart", "]"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Private context", "Subsection"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions (public and private)", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LeadingDigit", "[", "n_Integer", "]"}], ":=", 
  RowBox[{"First", "[", 
   RowBox[{"IntegerDigits", "[", "n", "]"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToPercents", "[", "lis_", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"StringJoin", "[", 
      RowBox[{
       RowBox[{"ToString", "[", 
        RowBox[{"SetPrecision", "[", 
         RowBox[{"#", ",", "3"}], "]"}], "]"}], ",", "\"\<%\>\""}], "]"}], 
     "&"}], ",", 
    RowBox[{"100", 
     RowBox[{"N", "[", 
      RowBox[{"lis", "/", 
       RowBox[{"Total", "[", "lis", "]"}]}], "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LeadingDigitChart", "[", 
   RowBox[{"data_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"digCounts", ",", "ratios", ",", "labels"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Not", "@", 
       RowBox[{"ArrayQ", "[", 
        RowBox[{"data", ",", "1", ",", "NumericQ"}], "]"}]}], ",", 
      RowBox[{"Message", "[", 
       RowBox[{"LeadingDigitChart", "::", "badinput"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"digCounts", "=", 
        RowBox[{"Sort", "@", 
         RowBox[{
          RowBox[{"Tally", "[", "data", "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"labels", "=", 
        RowBox[{"ToPercents", "[", "digCounts", "]"}]}], ";", 
       RowBox[{"BarChart", "[", 
        RowBox[{
         RowBox[{"MapThread", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Labeled", "[", 
             RowBox[{"#1", ",", "#2", ",", "Right"}], "]"}], "&"}], ",", 
           RowBox[{"{", 
            RowBox[{"digCounts", ",", "labels"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "opts", ",", 
         RowBox[{"BarOrigin", "\[Rule]", "Left"}], ",", "\[IndentingNewLine]", 
         RowBox[{"ChartLabels", "\[Rule]", 
          RowBox[{"Reverse", "@", 
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", "labels", "]"}], "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ChartStyle", "\[Rule]", "47"}]}], "]"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PassPhrase", "[", 
   RowBox[{"n_", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"min_:", "2"}], ",", 
      RowBox[{"max_:", "6"}]}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "words", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"words", "=", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"w__", "/;", 
        RowBox[{"min", "\[LessEqual]", 
         RowBox[{"StringLength", "[", "w", "]"}], "\[LessEqual]", "max"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"StringJoin", "[", 
      RowBox[{"Riffle", "[", 
       RowBox[{
        RowBox[{"RandomChoice", "[", 
         RowBox[{"words", ",", "n"}], "]"}], ",", "\"\< \>\""}], "]"}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 CellTags->"1.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringMemberQ", "[", 
   RowBox[{"str_String", ",", "chars_List"}], "]"}], ":=", 
  RowBox[{"SubsetQ", "[", 
   RowBox[{
    RowBox[{"Characters", "[", "str", "]"}], ",", "chars"}], 
   "]"}]}]], "InputOnly",
 CellTags->"1.1"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection"],

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"EndPackage", "[", "]"}], "*)"}]], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section"],

Cell[CellGroupData[{

Cell["Load package", "Subsection"],

Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "Input",ExpressionUUID->"c05ee97e-a95a-4ea5-9b17-e13d87605ba2"],

Cell[TextData[{
 "Load the package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to evaluate init \
cells dialog)."
}], "Text"],

Cell[BoxData[
 RowBox[{"<<", "EPM`"}]], "Input",ExpressionUUID->"32f41260-a967-4ec3-a9e8-5c7fe7f335b7"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection"],

Cell[BoxData[
 RowBox[{"?", "LeadingDigit"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "LeadingDigitChart"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "PassPhrase"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "StringMemberQ"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection"],

Cell[CellGroupData[{

Cell["LeadingDigit", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"leadingDigs", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"LeadingDigit", "[", 
      RowBox[{"Fibonacci", "[", "i", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "5000"}], "}"}]}], "]"}]}], ";"}]], "Input",Expression\
UUID->"460da3db-35a8-4598-9c75-eb2d3be7fc96"],

Cell[BoxData[
 RowBox[{"LeadingDigitChart", "[", 
  RowBox[{"leadingDigs", ",", 
   RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}]], "Input",ExpressionUUI\
D->"45783aea-5d82-42e4-a08b-5af9254e75d4"]
}, Closed]],

Cell[CellGroupData[{

Cell["LeadingDigitChart", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"leadingDigs", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"LeadingDigit", "[", 
      RowBox[{"Fibonacci", "[", "i", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "5000"}], "}"}]}], "]"}]}], ";"}]], "Input",Expression\
UUID->"241f2032-6a11-4881-a1f6-493f22b9fc99"],

Cell[BoxData[
 RowBox[{"LeadingDigitChart", "[", 
  RowBox[{"leadingDigs", ",", 
   RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}]], "Input",ExpressionUUI\
D->"13e9198b-f0ec-47fc-b1df-cf33a24dee98"]
}, Closed]],

Cell[CellGroupData[{

Cell["PassPhrase", "Subsubsection"],

Cell[BoxData[
 RowBox[{"PassPhrase", "[", 
  RowBox[{"4", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "5"}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"4e163a0d-65a1-4281-ba8c-7ac6096c5d87"]
}, Closed]],

Cell[CellGroupData[{

Cell["StringMemberQ", "Subsubsection"],

Cell[BoxData[
 RowBox[{"StringMemberQ", "[", 
  RowBox[{"\"\<equation\>\"", ",", 
   RowBox[{"{", 
    RowBox[{
    "\"\<a\>\"", ",", "\"\<e\>\"", ",", "\"\<i\>\"", ",", "\"\<o\>\"", ",", 
     "\"\<u\>\""}], "}"}]}], "]"}]], "Input",ExpressionUUID->"43b6be22-9589-\
4136-bd1e-b66389781e3f"]
}, Closed]]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{801, 803},
WindowMargins->{{Automatic, 738}, {Automatic, 150}},
ShowSelection->True,
FrontEndVersion->"11.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 16, \
2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "1.1"->{
  Cell[8639, 301, 839, 24, 
  80, "Input", "ExpressionUUID" -> "a59b03fb-5ea7-4e56-80db-fdcc594db23a",
   CellTags->"1.1"],
  Cell[9481, 327, 261, 8, 
  27, "InputOnly", "ExpressionUUID" -> "24ebfd01-0482-44d6-8404-e91d1b3401b1",
   
   CellTags->"1.1"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"1.1", 13228, 485}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 64, 1, 64, "Section", "ExpressionUUID" -> \
"bd70b444-6f8d-4d52-80bf-40b540539633",
 InitializationGroup->True],
Cell[646, 25, 240, 9, 49, "Text", "ExpressionUUID" -> \
"0e4319ad-7363-4bce-a6a2-14933a21226d"],
Cell[CellGroupData[{
Cell[911, 38, 30, 0, 44, "Subsection", "ExpressionUUID" -> \
"04c0d4d4-fc57-40a2-bbdc-d148fae21ce8"],
Cell[944, 40, 113, 2, 32, "Input", "ExpressionUUID" -> \
"9dbe9063-3aee-4804-8c2b-3455953a3f6e"],
Cell[1060, 44, 191, 5, 32, "Input", "ExpressionUUID" -> \
"972d5476-4696-49b8-b389-4d6f2f08f429"],
Cell[1254, 51, 146, 4, 32, "Input", "ExpressionUUID" -> \
"d1ee7ee6-3401-4e44-a206-74d05d5d3edc"],
Cell[1403, 57, 242, 5, 32, "Input", "ExpressionUUID" -> \
"b0693f7b-93fe-4c58-be94-8d6a9638cfa3"],
Cell[1648, 64, 119, 3, 32, "Input", "ExpressionUUID" -> \
"acadc45c-2e88-4226-8710-f5afc83dd4f8"],
Cell[1770, 69, 135, 4, 32, "Input", "ExpressionUUID" -> \
"8455b199-9e7f-4fde-a0fc-12aa2936da3d"],
Cell[1908, 75, 209, 5, 32, "Input", "ExpressionUUID" -> \
"86bad378-527f-4639-96be-8bb134620056"],
Cell[2120, 82, 389, 11, 54, "Input", "ExpressionUUID" -> \
"ccd84b52-aaba-4eda-8de1-de875d9fe66e"],
Cell[2512, 95, 227, 6, 32, "Input", "ExpressionUUID" -> \
"84f31f16-5bfc-46cb-ad7c-b596c90bccab"],
Cell[2742, 103, 135, 3, 32, "Input", "ExpressionUUID" -> \
"a080374a-0ff2-47ae-bc98-49c4bb14a452"],
Cell[2880, 108, 140, 4, 32, "Input", "ExpressionUUID" -> \
"467b194a-0499-4f40-904e-2e39e62a80ee"],
Cell[3023, 114, 181, 3, 32, "Input", "ExpressionUUID" -> \
"3d782710-4ead-4efa-98ee-737dd709e683"]
}, Closed]],
Cell[CellGroupData[{
Cell[3241, 122, 34, 0, 36, "Subsection", "ExpressionUUID" -> \
"13c07081-b124-4dac-a1b4-f0234d1181c1"],
Cell[3278, 124, 157, 4, 32, "Input", "ExpressionUUID" -> \
"7d0b5147-e2c4-4b39-ab5d-f7399c8c1324"],
Cell[3438, 130, 127, 3, 32, "Input", "ExpressionUUID" -> \
"a7576329-b0e4-4771-99c7-87e1a3453cf6"]
}, Closed]],
Cell[CellGroupData[{
Cell[3602, 138, 57, 0, 36, "Subsection", "ExpressionUUID" -> \
"4cd52bb0-068b-430f-b859-a5c193478b7a"],
Cell[3662, 140, 269, 7, 32, "Input", "ExpressionUUID" -> \
"5ab135be-02cd-4937-bc7a-da9bbb3353cb"],
Cell[3934, 149, 332, 8, 75, "Input", "ExpressionUUID" -> \
"da67986c-5493-448e-8090-53817bad2dc2"],
Cell[4269, 159, 197, 5, 54, "Input", "ExpressionUUID" -> \
"0ac92d02-4a68-4f1d-8ecf-26f7052e1453"],
Cell[4469, 166, 641, 18, 75, "Input", "ExpressionUUID" -> \
"355b4fa7-9d9b-458c-aa1e-5a827fcdb435"],
Cell[5113, 186, 450, 12, 75, "Input", "ExpressionUUID" -> \
"13398712-abcb-4539-9530-87e858ea316b"]
}, Closed]],
Cell[CellGroupData[{
Cell[5600, 203, 29, 0, 36, "Subsection", "ExpressionUUID" -> \
"620dcfb9-f783-481a-96d0-e68d85f7f9e4"],
Cell[5632, 205, 155, 4, 28, "Input", "ExpressionUUID" -> \
"6e283cc9-4ef3-473e-8223-b7c50a95c99c"],
Cell[5790, 211, 160, 4, 28, "Input", "ExpressionUUID" -> \
"951f882c-6c70-464c-a598-086e350247d8"]
}, Closed]],
Cell[CellGroupData[{
Cell[5987, 220, 37, 0, 36, "Subsection", "ExpressionUUID" -> \
"4cd6ca10-9722-4a9a-810c-11ae3c786b3f"],
Cell[6027, 222, 74, 1, 510, "Input", "ExpressionUUID" -> \
"f40f417f-d9a7-4035-b886-41b171c8971a"]
}, Closed]],
Cell[CellGroupData[{
Cell[6138, 228, 63, 0, 36, "Subsection", "ExpressionUUID" -> \
"2d37f557-3088-4f5c-9cae-55b1a8ed9b3e"],
Cell[6204, 230, 170, 4, 28, "Input", "ExpressionUUID" -> \
"4514ce95-a55e-40d8-a2c1-3855bd576e9e"],
Cell[6377, 236, 481, 15, 46, "Input", "ExpressionUUID" -> \
"6bfe152c-a8c6-421e-a10d-b4053e455115"],
Cell[6861, 253, 1775, 46, 165, "Input", "ExpressionUUID" -> \
"b4928a5d-9856-442d-8e6e-5d35944e5821"],
Cell[8639, 301, 839, 24, 80, "Input", "ExpressionUUID" -> \
"a59b03fb-5ea7-4e56-80db-fdcc594db23a",
 CellTags->"1.1"],
Cell[9481, 327, 261, 8, 27, "InputOnly", "ExpressionUUID" -> \
"24ebfd01-0482-44d6-8404-e91d1b3401b1",
 CellTags->"1.1"]
}, Closed]],
Cell[CellGroupData[{
Cell[9779, 340, 41, 0, 36, "Subsection", "ExpressionUUID" -> \
"cfc3708a-bdb5-4004-b90c-08d9eec0ec3f"],
Cell[9823, 342, 51, 1, 1113, "Input", "ExpressionUUID" -> \
"628eb4b3-293e-4814-aeb4-0725c965741d"]
}, Closed]],
Cell[CellGroupData[{
Cell[9911, 348, 32, 0, 36, "Subsection", "ExpressionUUID" -> \
"499c8467-3608-431c-869f-47eb4a60e94b"],
Cell[9946, 350, 83, 2, 56, "Input", "ExpressionUUID" -> \
"98fb02be-7d2a-401b-b34b-54b7c9c2d1f2"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10078, 358, 27, 0, 64, "Section", "ExpressionUUID" -> \
"4fc28b77-9220-49c6-8cd7-5d5e7eb11d5a"],
Cell[CellGroupData[{
Cell[10130, 362, 34, 0, 44, "Subsection", "ExpressionUUID" -> \
"f12dd979-e5d8-4495-b84c-9db66897d8d0"],
Cell[10167, 364, 107, 1, 32, "Input", "ExpressionUUID" -> \
"c05ee97e-a95a-4ea5-9b17-e13d87605ba2"],
Cell[10277, 367, 187, 6, 30, "Text", "ExpressionUUID" -> \
"638551c8-0d03-40f4-bb88-78288fe3a5c6"],
Cell[10467, 375, 103, 1, 32, "Input", "ExpressionUUID" -> \
"32f41260-a967-4ec3-a9e8-5c7fe7f335b7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10607, 381, 41, 0, 44, "Subsection", "ExpressionUUID" -> \
"90103e65-8d25-4706-bba5-f00c776d0cf1"],
Cell[10651, 383, 55, 1, 32, "Input", "ExpressionUUID" -> \
"ee29c823-acb9-4a58-bf4b-76c320e7d05c"],
Cell[10709, 386, 60, 1, 32, "Input", "ExpressionUUID" -> \
"2ad946bf-29dc-4bfb-a976-8b03619c80df"],
Cell[10772, 389, 53, 1, 32, "Input", "ExpressionUUID" -> \
"0ffdb8d8-0f0f-470d-94ef-cb11926430a0"],
Cell[10828, 392, 56, 1, 32, "Input", "ExpressionUUID" -> \
"0856c5a7-8c3f-493b-86da-68bba5da9637"]
}, Closed]],
Cell[CellGroupData[{
Cell[10921, 398, 56, 0, 36, "Subsection", "ExpressionUUID" -> \
"3a5d7601-757e-482d-8984-a098218d3446"],
Cell[CellGroupData[{
Cell[11002, 402, 37, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"9aa6fb5a-5c57-4116-9a19-d22a6a6f5ea8"],
Cell[11042, 404, 330, 9, 32, "Input", "ExpressionUUID" -> \
"460da3db-35a8-4598-9c75-eb2d3be7fc96"],
Cell[11375, 415, 203, 4, 32, "Input", "ExpressionUUID" -> \
"45783aea-5d82-42e4-a08b-5af9254e75d4"]
}, Closed]],
Cell[CellGroupData[{
Cell[11615, 424, 42, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"bec0d66e-1eb0-41fd-8ced-587950ad5e2e"],
Cell[11660, 426, 330, 9, 32, "Input", "ExpressionUUID" -> \
"241f2032-6a11-4881-a1f6-493f22b9fc99"],
Cell[11993, 437, 203, 4, 32, "Input", "ExpressionUUID" -> \
"13e9198b-f0ec-47fc-b1df-cf33a24dee98"]
}, Closed]],
Cell[CellGroupData[{
Cell[12233, 446, 35, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"bebf7826-5c4a-4edd-ace8-80c2226ce8f7"],
Cell[12271, 448, 192, 5, 32, "Input", "ExpressionUUID" -> \
"4e163a0d-65a1-4281-ba8c-7ac6096c5d87"]
}, Closed]],
Cell[CellGroupData[{
Cell[12500, 458, 38, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"d1701a92-c43f-4236-98d8-5e6d89f7e9f7"],
Cell[12541, 460, 291, 7, 32, "Input", "ExpressionUUID" -> \
"43b6be22-9589-4136-bd1e-b66389781e3f"]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

