(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     29954,        910]
NotebookOptionsPosition[     21053,        689]
NotebookOutlinePosition[     22229,        731]
CellTagsIndexPosition[     22131,        725]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["EPM`Patterns`", "Section",
 InitializationGroup->True],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox["Essentials of Programming in Mathematica\n",
  FontSlant->"Italic"],
 "\[Copyright] Paul R. Wellin 2015"
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14],

Cell[CellGroupData[{

Cell["Metadata", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Name", ":", " ", "EPM`Patterns`"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Book", ":", " ", 
   RowBox[{
   "Essentials", " ", "of", " ", "Programming", " ", "in", " ", 
    "Mathematica"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Summary", ":", " ", 
   RowBox[{
   "This", " ", "package", " ", "contains", " ", "the", " ", "functions", " ",
     "defined", " ", "in", " ", "Chapter", " ", "4", " ", "Patterns", " ", 
    "and", " ", 
    RowBox[{"rules", "."}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Context", ":", " ", "EPM`Patterns`"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", "Version"}], ":", " ", "1.1"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"038495be-b44f-4da8-963a-8eb99211d5ae"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Copyright", ":", " ", 
    RowBox[{"Copyright", " ", "2015"}]}], ",", " ", 
   RowBox[{"Paul", " ", "R", " ", "Wellin"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{":", "History", ":", "\[IndentingNewLine]", "\t", 
     RowBox[{"Version", " ", "1.0", " ", "Dec", " ", "2012"}]}], ";", 
    "\[IndentingNewLine]", "\t", 
    RowBox[{"Version", " ", "1.1", " ", "Apr", " ", "2017"}]}], ",", " ", 
   RowBox[{
    RowBox[{"check", " ", "$VersionNumber", " ", "for", " ", "Perimeter"}], 
    ";"}]}], "\[IndentingNewLine]", " ", "*)"}]], "Input",ExpressionUUID->\
"23379a7f-967b-4f9d-9910-0e39a940652e"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", "dice"}]}], ",", " ", 
   RowBox[{"finding", " ", "subsequences"}], ",", " ", 
   RowBox[{"square", " ", "matrix"}], ",", " ", 
   RowBox[{"area", " ", "of", " ", "triangle"}], ",", " ", "perimeter"}], " ",
   "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Source", ":", " ", 
   RowBox[{"Patterns", ".", "nb"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", "Version"}], ":", " ", "10.3"}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "11.1"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"03b9e7c3-fc4d-48eb-a992-7aeab7e952ff"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "Color", ",", "Dice", ",", "FindSubsequence", ",", "FixArray", ",", 
   "SignedArea", ",", "squareMatrixQ"}], "]"}]], "Input",ExpressionUUID->\
"a2e607ba-4e6f-41ce-a51e-a1947c744c7e"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"BeginPackage", "[", "\"\<EPM`Patterns`\>\"", "]"}], " ", 
  "*)"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for public functions", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Color", "::", "usage"}], "=", 
   "\"\<Color is an option for Dice that specifies the background color. The \
default value is Darker@Blue.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Dice", "::", "usage"}], "=", "\"\<Dice[\!\(\*
StyleBox[\"n\", \"TI\"]\)] displays a regular six-sided die with value \!\(\*
StyleBox[\"n\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FindSubsequence", "::", "usage"}], "=", "\"\<FindSubsequence[\!\(\*
StyleBox[\"digs\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"subseq\", \"TI\"]\)] returns the positions in the sequence of \
digits \!\(\*
StyleBox[\"digs\", \"TI\"]\) where the subsequence \!\(\*
StyleBox[\"subseq\", \"TI\"]\) occurs.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FixArray", "::", "usage"}], "=", "\"\<FixArray[\!\(\*
StyleBox[\"mat\", \"TI\"]\)] replaces any occurrences of the string \\\"NAN\\\
\" with the column mean for each column in which the string appears. \>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"$VersionNumber", "<", "11.1"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Perimeter", "::", "usage"}], "=", 
     "\"\<Perimeter[Triangle[{\!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"1\"]\),\!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"2\"]\),\!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"3\"]\)}]] computes the perimeter of the triangle \
determined by the three points \!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"1\"]\), \!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"2\"]\), and \!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"3\"]\).\>\""}]}], "]"}], ";"}]], "Input",Expressio\
nUUID->"663ef4b3-e12d-48a4-920e-3e1fa0983070"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SignedArea", "::", "usage"}], "=", 
   "\"\<SignedArea[Triangle[{\!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"1\"]\),\!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"2\"]\),\!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"3\"]\)}]] computes the area of the triangle \
determined by the three points \!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"1\"]\), \!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"2\"]\), and \!\(\*SubscriptBox[
StyleBox[\"pt\", \"TI\"], \"3\"]\). This value may be negative depending upon \
the order of the three points. The area is zero if the points are \
collinear.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"squareMatrixQ", "::", "usage"}], "=", "\"\<squareMatrixQ[\!\(\*
StyleBox[\"mat\", \"TI\"]\)] yields true if \!\(\*
StyleBox[\"mat\", \"TI\"]\) is a square matrix.\>\""}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Dice", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Color", "\[Rule]", 
     RowBox[{"Darker", "@", "Blue"}]}], "}"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Private context", "Subsection"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions (public and private)", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Dice", "[", 
   RowBox[{"n_", ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rules", ",", 
      RowBox[{"off", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"OptionValue", "[", "Color", "]"}], ",", 
         RowBox[{"Disk", "[", "]"}]}], "}"}]}], ",", 
      RowBox[{"on", "=", 
       RowBox[{"{", 
        RowBox[{"White", ",", 
         RowBox[{"Disk", "[", "]"}]}], "}"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rules", "=", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "off"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "off"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "on"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "off"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "off"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "off"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "off"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "off"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "off"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "on"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "off"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "on"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "off"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "on"}]}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "on"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "on"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "on"}]}], "}"}], ",", "\[IndentingNewLine]",
         "\[VeryThinSpace]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "on"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "on"}], ",", 
          RowBox[{"5", "\[Rule]", "off"}], ",", 
          RowBox[{"6", "\[Rule]", "on"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "on"}]}], "}"}]}], "\[IndentingNewLine]", 
       "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"GraphicsGrid", "[", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{"Graphics", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Range", "[", "9", "]"}], ",", "3"}], "]"}], "/.", 
          "\[VeryThinSpace]", 
          RowBox[{"rules", "[", 
           RowBox[{"[", "n", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", "2", "}"}]}], "]"}], ",", 
       RowBox[{"Background", "\[Rule]", 
        RowBox[{"First", "[", "off", "]"}]}], ",", 
       RowBox[{"Spacings", "\[Rule]", "10"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "40"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindSubsequence", "[", 
   RowBox[{"lis_List", ",", "subseq_List"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", ",", 
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "subseq", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"p", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"lis", ",", "len", ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Position", "[", 
       RowBox[{"p", ",", "subseq"}], "]"}], "/.", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"num_", "?", "IntegerQ"}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{"num", ",", 
         RowBox[{"num", "+", "len", "-", "1"}]}], "}"}]}]}]}]}], 
   "]"}]}]], "InputOnly",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindSubsequence", "[", 
   RowBox[{"n_Integer", ",", "subseq_Integer"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"nlist", "=", 
       RowBox[{"IntegerDigits", "[", "n", "]"}]}], ",", 
      RowBox[{"sublist", "=", 
       RowBox[{"IntegerDigits", "[", "subseq", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"FindSubsequence", "[", 
     RowBox[{"nlist", ",", "sublist"}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "InputOnly",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FixArray", "[", "mat_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "fixcolumn", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"fixcolumn", "[", "col_", "]"}], ":=", 
      RowBox[{
       RowBox[{"mat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "col"}], "]"}], "]"}], "/.", 
       RowBox[{"\"\<NAN\>\"", "\[RuleDelayed]", 
        RowBox[{"Mean", "[", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"mat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "col"}], "]"}], "]"}], ",", 
           RowBox[{"_", "?", "NumberQ"}]}], "]"}], "]"}]}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Transpose", "[", 
      RowBox[{"Map", "[", 
       RowBox[{"fixcolumn", ",", 
        RowBox[{"Range", "[", 
         RowBox[{"Length", "[", 
          RowBox[{"First", "[", "mat", "]"}], "]"}], "]"}]}], "]"}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$VersionNumber", "<", "11.1"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Perimeter", "[", 
     RowBox[{"Triangle", "[", 
      RowBox[{"pts", ":", 
       RowBox[{"{", 
        RowBox[{"p1_", ",", "p2_", ",", "p3_"}], "}"}]}], "]"}], "]"}], ":=", 
    
    RowBox[{"RegionMeasure", "[", 
     RowBox[{"Line", "[", 
      RowBox[{"pts", "/.", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"pt1_", ",", "pn__"}], "}"}], "\[RuleDelayed]", 
        RowBox[{"{", 
         RowBox[{"pt1", ",", "pn", ",", "pt1"}], "}"}]}]}], "]"}], "]"}]}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",ExpressionUUID->"bbc4b6fd-5f36-4901-\
95e8-6e4426734331"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SignedArea", "[", 
   RowBox[{"Triangle", "[", 
    RowBox[{"{", 
     RowBox[{"v1_", ",", "v2_", ",", "v3_"}], "}"}], "]"}], "]"}], ":=", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   RowBox[{"Det", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"v1", ",", "v2", ",", "v3"}], "}"}], "/.", "\[InvisibleSpace]", 
     
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_"}], "}"}], "\[RuleDelayed]", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y", ",", "1"}], "}"}]}]}], "]"}]}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection"],

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"EndPackage", "[", "]"}], "*)"}]], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section"],

Cell[CellGroupData[{

Cell["Load package", "Subsection"],

Cell["Quit current session:", "Text"],

Cell[BoxData["Quit"], "Input",ExpressionUUID->"6a88bd03-ebd5-4458-99e4-dd09c629da97"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to evaluate init \
cells dialog)."
}], "Text"],

Cell[BoxData[
 RowBox[{"<<", "EPM`"}]], "Input",ExpressionUUID->"6de6f805-40fd-4503-b940-ee5f6aaffa62"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection"],

Cell[BoxData[
 RowBox[{"?", "Dice"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "FindSubsequence"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "FixArray"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "Perimeter"}]], "Input",ExpressionUUID->"02086517-8d03-46ec-b153-356d99ab00dd"],

Cell[BoxData[
 RowBox[{"?", "SignedArea"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection"],

Cell[CellGroupData[{

Cell["Dice", "Subsubsection"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"Dice", "[", "n", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "1", ",", "6"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"Dice", "[", 
  RowBox[{"5", ",", 
   RowBox[{"Color", "\[Rule]", "Red"}]}], "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["FindSubsequence", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pidigs", "=", 
   RowBox[{"First", "[", 
    RowBox[{"RealDigits", "[", 
     RowBox[{"\[Pi]", ",", "10", ",", 
      SuperscriptBox["10", "6"], ",", 
      RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";"}]], "Input",
 CellTags->"4.3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindSubsequence", "[", 
   RowBox[{"pidigs", ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "4", ",", "1", ",", "5", ",", "9"}], "}"}]}],
    "]"}], "//", "Timing"}]], "Input",
 CellTags->"4.3"],

Cell["Or use two integers as arguments.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pi", "=", 
   RowBox[{"FromDigits", "[", 
    RowBox[{"First", "@", 
     RowBox[{"RealDigits", "[", 
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"Pi", ",", 
         SuperscriptBox["10", "5"]}], "]"}], "-", "3"}], "]"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{"FindSubsequence", "[", 
  RowBox[{"pi", ",", "1415"}], "]"}]}], "InputOnly",
 CellTags->"4.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["FixArray", "Subsubsection"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{"array", "=", 
    TagBox[
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {"0.9034000000000001`", "\"\<NAN\>\"", "0.7163`", "0.8588`", 
         "0.1228`"},
        {"0.30310000000000004`", "0.5827`", "0.26990000000000003`", 
         "0.8063`", "\"\<NAN\>\""},
        {"0.041800000000000004`", "0.8426`", "\"\<NAN\>\"", 
         "0.8634000000000001`", "0.9682000000000001`"},
        {"0.9163`", "0.8913000000000001`", "0.06620000000000001`", 
         "0.8432000000000001`", "0.054700000000000006`"},
        {"0.7937000000000001`", "0.6905`", "0.9105000000000001`", 
         "0.5589000000000001`", "0.8993`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
     Function[BoxForm`e$, 
      MatrixForm[BoxForm`e$]]]}], ";"}],
  NumberMarks->False]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FixArray", "[", "array", "]"}], "//", "MatrixForm"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Perimeter", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Perimeter", "[", 
  RowBox[{"Triangle", "[", "pts", "]"}], "]"}]}], "Input",ExpressionUUID->\
"e1d20590-4717-4fa9-8012-9f60ffa16c90"]
}, Closed]],

Cell[CellGroupData[{

Cell["SignedArea", "Subsubsection"],

Cell[BoxData[
 RowBox[{"SignedArea", "[", 
  RowBox[{"Triangle", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "}"}], "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"SignedArea", "[", 
  RowBox[{"Triangle", "[", 
   RowBox[{"Reverse", "@", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "4"}], "}"}]}], "}"}]}], "]"}], "]"}]], "Input"]
}, Closed]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{808, 699},
WindowMargins->{{Automatic, 811}, {Automatic, 164}},
ShowSelection->True,
FrontEndVersion->"11.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 16, \
2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "4.3 Solutions"->{
  Cell[11889, 355, 848, 26, 
  74, "InputOnly", "ExpressionUUID" -> "591fef0b-525e-4471-ae6b-8b3de13f2f03",
   
   CellTags->"4.3 Solutions"],
  Cell[12740, 383, 571, 16, 
  95, "InputOnly", "ExpressionUUID" -> "74acf83f-f6f3-44ea-ad44-a4860ee2d713",
   
   CellTags->"4.3 Solutions"],
  Cell[17933, 581, 413, 13, 
  55, "InputOnly", "ExpressionUUID" -> "fbc8b2cc-81ce-4f07-8b1e-f7da8a3265b3",
   
   CellTags->"4.3 Solutions"]},
 "4.3"->{
  Cell[17372, 560, 264, 8, 
  35, "Input", "ExpressionUUID" -> "b95a110b-52ca-419f-8c75-d0cb6929c49f",
   CellTags->"4.3"],
  Cell[17639, 570, 239, 7, 
  32, "Input", "ExpressionUUID" -> "f6e52bf1-020a-44f4-98d9-9eb2e2fab76a",
   CellTags->"4.3"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"4.3 Solutions", 21419, 702},
 {"4.3", 21859, 715}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 60, 1, 64, "Section", "ExpressionUUID" -> \
"c94a21cb-3aba-448d-99e2-29813c50cc8b",
 InitializationGroup->True],
Cell[642, 25, 240, 9, 49, "Text", "ExpressionUUID" -> \
"6feaa97d-d1c7-4346-a1c5-9f261df2ea55"],
Cell[CellGroupData[{
Cell[907, 38, 30, 0, 44, "Subsection", "ExpressionUUID" -> \
"086f15bd-ebdf-4cbe-a271-eb7e9b08f7ef"],
Cell[940, 40, 109, 2, 32, "Input", "ExpressionUUID" -> \
"aa435e2d-3933-4421-aee3-f0b1487f5271"],
Cell[1052, 44, 191, 5, 32, "Input", "ExpressionUUID" -> \
"49335658-028b-4b97-a34c-3b4088dcb2f5"],
Cell[1246, 51, 146, 4, 32, "Input", "ExpressionUUID" -> \
"91d3a3f4-a19f-4dc7-9e9a-114cba80b384"],
Cell[1395, 57, 310, 7, 54, "Input", "ExpressionUUID" -> \
"09c8a8e1-e149-4620-a8a1-a2537c8c7caa"],
Cell[1708, 66, 112, 2, 32, "Input", "ExpressionUUID" -> \
"6e7b36fd-79f8-484a-84cb-db33fdf32d28"],
Cell[1823, 70, 190, 4, 32, "Input", "ExpressionUUID" -> \
"038495be-b44f-4da8-963a-8eb99211d5ae"],
Cell[2016, 76, 209, 5, 32, "Input", "ExpressionUUID" -> \
"bc444255-131a-4ad7-9668-a116f2e6af4b"],
Cell[2228, 83, 505, 11, 96, "Input", "ExpressionUUID" -> \
"23379a7f-967b-4f9d-9910-0e39a940652e"],
Cell[2736, 96, 324, 8, 54, "Input", "ExpressionUUID" -> \
"01c7ebfa-ec8a-471a-b1a1-50ae495b9d7a"],
Cell[3063, 106, 131, 3, 32, "Input", "ExpressionUUID" -> \
"f8fd5c7a-68cb-4553-a692-1943bfa26960"],
Cell[3197, 111, 140, 4, 32, "Input", "ExpressionUUID" -> \
"a0bce5c4-b43f-4d9b-9354-9412df3cb502"],
Cell[3340, 117, 181, 3, 32, "Input", "ExpressionUUID" -> \
"03b9e7c3-fc4d-48eb-a992-7aeab7e952ff"]
}, Closed]],
Cell[CellGroupData[{
Cell[3558, 125, 34, 0, 36, "Subsection", "ExpressionUUID" -> \
"14832385-07e7-4612-8ec4-a672fd61c504"],
Cell[3595, 127, 235, 5, 32, "Input", "ExpressionUUID" -> \
"a2e607ba-4e6f-41ce-a51e-a1947c744c7e"],
Cell[3833, 134, 123, 3, 32, "Input", "ExpressionUUID" -> \
"411063df-cce9-4e91-802d-7b0afd832737"]
}, Closed]],
Cell[CellGroupData[{
Cell[3993, 142, 57, 0, 36, "Subsection", "ExpressionUUID" -> \
"6b34136a-06ca-41e3-9657-5284641f432f"],
Cell[4053, 144, 211, 5, 75, "Input", "ExpressionUUID" -> \
"af0c6934-33d9-43f0-9c22-c54f532b2040"],
Cell[4267, 151, 222, 5, 32, "Input", "ExpressionUUID" -> \
"e98eb8c3-002c-425b-8332-f144d50ae5ae"],
Cell[4492, 158, 424, 10, 75, "Input", "ExpressionUUID" -> \
"5f6df003-da3a-4948-9e4f-757dd47b601e"],
Cell[4919, 170, 277, 6, 75, "Input", "ExpressionUUID" -> \
"00f94143-487f-438a-8032-cd32603ed4e2"],
Cell[5199, 178, 726, 15, 97, "Input", "ExpressionUUID" -> \
"663ef4b3-e12d-48a4-920e-3e1fa0983070"],
Cell[5928, 195, 666, 13, 117, "Input", "ExpressionUUID" -> \
"0a3ecbb2-679c-478f-b06b-96209c14665b"],
Cell[6597, 210, 234, 5, 32, "Input", "ExpressionUUID" -> \
"80a2e20b-9257-4224-bdf7-d3d2d775d853"]
}, Closed]],
Cell[CellGroupData[{
Cell[6868, 220, 29, 0, 36, "Subsection", "ExpressionUUID" -> \
"74e556fe-6f2c-44d5-a51d-4ee5bd5183de"],
Cell[6900, 222, 198, 6, 28, "Input", "ExpressionUUID" -> \
"c15fd831-1c53-4478-b0f1-f14a0dc4dfcc"]
}, Closed]],
Cell[CellGroupData[{
Cell[7135, 233, 37, 0, 36, "Subsection", "ExpressionUUID" -> \
"670230cd-71ee-4f58-9f4e-250a35e9c1d3"],
Cell[7175, 235, 74, 1, 293, "Input", "ExpressionUUID" -> \
"00e625f6-3051-4b19-aed3-1fb7f3076de7"]
}, Closed]],
Cell[CellGroupData[{
Cell[7286, 241, 63, 0, 36, "Subsection", "ExpressionUUID" -> \
"c949c8d1-b1ef-48c5-afaf-72f30068e38d"],
Cell[7352, 243, 4534, 110, 306, "Input", "ExpressionUUID" -> \
"06bf9f34-cdf4-4765-a268-6e0b4ce0a9a9"],
Cell[11889, 355, 848, 26, 74, "InputOnly", "ExpressionUUID" -> \
"591fef0b-525e-4471-ae6b-8b3de13f2f03",
 CellTags->"4.3 Solutions"],
Cell[12740, 383, 571, 16, 95, "InputOnly", "ExpressionUUID" -> \
"74acf83f-f6f3-44ea-ad44-a4860ee2d713",
 CellTags->"4.3 Solutions"],
Cell[13314, 401, 1016, 28, 96, "Input", "ExpressionUUID" -> \
"c0318c43-3b5e-4c07-bd05-f871d1b8d43d"],
Cell[14333, 431, 718, 20, 96, "Input", "ExpressionUUID" -> \
"bbc4b6fd-5f36-4901-95e8-6e4426734331"],
Cell[15054, 453, 546, 17, 49, "Input", "ExpressionUUID" -> \
"67224627-1c0f-4212-8c7f-fc853a28382a"]
}, Closed]],
Cell[CellGroupData[{
Cell[15637, 475, 41, 0, 36, "Subsection", "ExpressionUUID" -> \
"b31c278a-bcaa-40bf-9db9-74b6dfbf4d3f"],
Cell[15681, 477, 51, 1, 571, "Input", "ExpressionUUID" -> \
"577de4ae-581f-4089-88d4-6427829c342e"]
}, Closed]],
Cell[CellGroupData[{
Cell[15769, 483, 32, 0, 36, "Subsection", "ExpressionUUID" -> \
"000f4f38-57da-4d4c-8716-eae2dc3a9af1"],
Cell[15804, 485, 83, 2, 87, "Input", "ExpressionUUID" -> \
"a124f039-b42a-42bc-894e-5c3eb2c02d3e"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15936, 493, 27, 0, 64, "Section", "ExpressionUUID" -> \
"422ccfc1-345f-4fc6-a66e-6ee6930bc06d"],
Cell[CellGroupData[{
Cell[15988, 497, 34, 0, 44, "Subsection", "ExpressionUUID" -> \
"687bccc7-0754-41a8-a8e2-b4e65b514f05"],
Cell[16025, 499, 37, 0, 30, "Text", "ExpressionUUID" -> \
"afe19cb9-055a-497f-9a92-39a5810c4b9f"],
Cell[16065, 501, 85, 0, 32, "Input", "ExpressionUUID" -> \
"6a88bd03-ebd5-4458-99e4-dd09c629da97"],
Cell[16153, 503, 183, 6, 30, "Text", "ExpressionUUID" -> \
"ab8e4f47-d332-4f1f-b39c-521d285cc190"],
Cell[16339, 511, 103, 1, 32, "Input", "ExpressionUUID" -> \
"6de6f805-40fd-4503-b940-ee5f6aaffa62"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16479, 517, 41, 0, 44, "Subsection", "ExpressionUUID" -> \
"d5af6e5a-71fd-4d99-abe8-a03f34bedf51"],
Cell[16523, 519, 47, 1, 32, "Input", "ExpressionUUID" -> \
"5acf2fae-cc2a-4f5d-8bb1-5d22294507ae"],
Cell[16573, 522, 58, 1, 32, "Input", "ExpressionUUID" -> \
"3a83f27f-d0ba-46ed-b4a8-f61332d1d0c8"],
Cell[16634, 525, 51, 1, 32, "Input", "ExpressionUUID" -> \
"b5c296cd-51ed-42fc-b174-c159ea74ea5a"],
Cell[16688, 528, 107, 1, 32, "Input", "ExpressionUUID" -> \
"02086517-8d03-46ec-b153-356d99ab00dd"],
Cell[16798, 531, 53, 1, 32, "Input", "ExpressionUUID" -> \
"6881910d-2907-4c83-940f-7964af2d53b3"]
}, Closed]],
Cell[CellGroupData[{
Cell[16888, 537, 56, 0, 36, "Subsection", "ExpressionUUID" -> \
"9d0dffd2-ef9a-4dd7-938d-7c16598c0922"],
Cell[CellGroupData[{
Cell[16969, 541, 29, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"b1799db4-2cc7-45ff-84ff-a27bc291f4c5"],
Cell[17001, 543, 172, 5, 32, "Input", "ExpressionUUID" -> \
"cbf334d4-d2b7-4fec-9fdd-17798a52ee4c"],
Cell[17176, 550, 116, 3, 32, "Input", "ExpressionUUID" -> \
"d73b3d37-aa82-41a5-b986-832653a711a4"]
}, Closed]],
Cell[CellGroupData[{
Cell[17329, 558, 40, 0, 29, "Subsubsection", "ExpressionUUID" -> \
"f2fd9617-cd81-4c54-b0a4-83374c49e71c"],
Cell[17372, 560, 264, 8, 35, "Input", "ExpressionUUID" -> \
"b95a110b-52ca-419f-8c75-d0cb6929c49f",
 CellTags->"4.3"],
Cell[17639, 570, 239, 7, 32, "Input", "ExpressionUUID" -> \
"f6e52bf1-020a-44f4-98d9-9eb2e2fab76a",
 CellTags->"4.3"],
Cell[17881, 579, 49, 0, 30, "Text", "ExpressionUUID" -> \
"fd385b7c-ac97-45d3-9d10-fbcd2de8298d"],
Cell[17933, 581, 413, 13, 55, "InputOnly", "ExpressionUUID" -> \
"fbc8b2cc-81ce-4f07-8b1e-f7da8a3265b3",
 CellTags->"4.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[18383, 599, 33, 0, 29, "Subsubsection", "ExpressionUUID" -> \
"c84402e7-0221-4498-8ace-5188228f6984"],
Cell[18419, 601, 1225, 29, 97, "Input", "ExpressionUUID" -> \
"f3ea975e-9098-4165-a8ed-4b3d0c9c0df0"],
Cell[19647, 632, 98, 2, 32, "Input", "ExpressionUUID" -> \
"ba905a19-d5c1-4349-b10f-f14270681d4a"]
}, Closed]],
Cell[CellGroupData[{
Cell[19782, 639, 34, 0, 29, "Subsubsection", "ExpressionUUID" -> \
"bacea244-92c4-46a8-b069-008594b710f5"],
Cell[19819, 641, 446, 13, 54, "Input", "ExpressionUUID" -> \
"e1d20590-4717-4fa9-8012-9f60ffa16c90"]
}, Closed]],
Cell[CellGroupData[{
Cell[20302, 659, 35, 0, 29, "Subsubsection", "ExpressionUUID" -> \
"451fdd50-2129-4898-9141-7b9bbb5c86b2"],
Cell[20340, 661, 316, 10, 32, "Input", "ExpressionUUID" -> \
"5d0fa6c7-6f9d-4ab5-be6b-a3c2151b85ab"],
Cell[20659, 673, 354, 11, 32, "Input", "ExpressionUUID" -> \
"8f8c8a55-eed4-493a-8829-b3f77e7d668f"]
}, Closed]]
}, Open  ]]
}, Open  ]]
}
]
*)

