(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    103370,       2974]
NotebookOptionsPosition[     86580,       2590]
NotebookOutlinePosition[     87659,       2628]
CellTagsIndexPosition[     87549,       2622]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["EPM`Programs`", "Section",
 InitializationGroup->True],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox["Essentials of Programming in Mathematica\n",
  FontSlant->"Italic"],
 "\[Copyright] Paul R. Wellin 2015"
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14],

Cell[CellGroupData[{

Cell["Metadata", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Name", ":", " ", "EPM`Programs`"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Book", ":", " ", 
   RowBox[{
   "Essentials", " ", "of", " ", "Programming", " ", "in", " ", 
    "Mathematica"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Summary", ":", " ", 
   RowBox[{
   "This", " ", "package", " ", "contains", " ", "the", " ", "functions", " ",
     "defined", " ", "in", " ", "Chapter", " ", "6", " ", "Programs"}]}], " ",
   "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Context", ":", " ", "EPM`Programs`"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Copyright", ":", " ", 
    RowBox[{"Copyright", " ", "2015"}]}], ",", " ", 
   RowBox[{"Paul", " ", "R", " ", "Wellin"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{"Dec", " ", "2012"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Keywords", ":", " ", 
    RowBox[{"amino", " ", "acid"}]}], ",", " ", 
   RowBox[{"bond", " ", "percolation"}], ",", " ", "residues", ",", " ", 
   RowBox[{"lag", " ", "plots"}], ",", " ", 
   RowBox[{"lucky", " ", "numbers"}], ",", " ", 
   RowBox[{"perfect", " ", "numbers"}], ",", " ", 
   RowBox[{"radius", " ", "of", " ", "gyration"}], ",", " ", 
   RowBox[{"random", " ", "graphs"}], ",", " ", 
   RowBox[{"Smith", " ", "numbers"}], ",", " ", 
   RowBox[{"stem", " ", "plots"}], ",", " ", 
   RowBox[{"truth", " ", "tables"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Source", ":", " ", 
   RowBox[{"Programs", ".", "nb"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", "Version"}], ":", " ", "10.3"}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "11.1"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"97536e40-e6bc-460d-b4de-55cd084e8fec"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "Amino", ",", "BondPercolation", ",", "ColorResidues", ",", "ColorScheme", 
   ",", "FindPercolationPath", ",", "LagPlot", ",", "LuckyNumbers", ",", 
   "MultiplyCount", ",", "NearTo", ",", "PerfectSearch", ",", 
   "PerfectSearchParallel", ",", "RadiusOfGyrationTensor", ",", 
   "RandomGraphGnp", ",", "SmithNumberQ", ",", "StemPlot", ",", "ToEdges", 
   ",", "TruthTable"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"BeginPackage", "[", "\"\<EPM`Programs`\>\"", "]"}], " ", 
  "*)"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for public functions", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Amino", "::", "usage"}], "=", 
   "\"\<Amino is a scheme used with the option ColorScheme in the \
ColorResidues function.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"BondPercolation", "::", "usage"}], "MessageName"], "=", 
   "\"\<BondPercolation[{\!\(\*
StyleBox[\"m\", \"TI\"]\),\!\(\*
StyleBox[\"n\", \"TI\"]\)},\!\(\*
StyleBox[\"prob\", \"TI\"]\)] simulates a bond percolation on an \!\(\*
StyleBox[\"m\", \"TI\"]\)\[Cross]\!\(\*
StyleBox[\"n\", \"TI\"]\) rectangular lattice using 0<\!\(\*
StyleBox[\"prob\", \"TI\"]\)<1 as the probability of a bond forming between a \
site and its neighbors.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BondPercolation", "::", "baddims"}], "=", 
   "\"\<The arguments `1` and `2`, giving the grid dimensions, should be \
positive integers.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ColorResidues", "::", "usage"}], "=", "\"\<ColorResidues[\!\(\*
StyleBox[\"seq\", \"TI\"]\)] displays a sequence of amino acids from the \
protein sequence \!\(\*
StyleBox[\"seq\", \"TI\"]\).\>\""}], ";"}]], "InputOnly"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ColorScheme", "::", "usage"}], "=", 
   "\"\<ColorScheme is an option to ColorResidues that specifies the colors \
used for each amino acid.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FindPercolationPath", "::", "usage"}], "=", 
   "\"\<FindPercolationPath[\!\(\*
StyleBox[\"gr\", \"TI\"]\),{\!\(\*
StyleBox[\"dimx\", \"TI\"]\),\!\(\*
StyleBox[\"dimy\", \"TI\"]\)}] returns a connected path (if it exists) for \
the graph \!\(\*
StyleBox[\"gr\", \"TI\"]\) of dimension \!\(\*
StyleBox[\"dimx\", \"TI\"]\)\[Cross]\!\(\*
StyleBox[\"dimy\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LagPlot", "::", "usage"}], "=", "\"\<LagPlot[\!\(\*
StyleBox[\"data\", \"TI\"]\), \!\(\*
StyleBox[\"lag\", \"TI\"]\)] returns a lag plot of \!\(\*
StyleBox[\"data\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LuckyNumbers", "::", "usage"}], "=", "\"\<LuckyNumber[\!\(\*
StyleBox[\"n\", \"TI\"]\)] returns a list of the lucky numbers less than \!\(\*
StyleBox[\"n\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MultiplyCount", "::", "usage"}], "=", "\"\<MultiplyCount[\!\(\*
StyleBox[\"poly\", \"TI\"]\)] computes the number of explicit multiplications \
in the arithmetic expression \!\(\*
StyleBox[\"poly\", \"TI\"]\).\\nMultiplyCount[\!\(\*
StyleBox[\"poly\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"var\", \"TI\"]\)] computes the number of explicit multiplications \
in the polynomial \!\(\*
StyleBox[\"poly\", \"TI\"]\) in the independent variable \!\(\*
StyleBox[\"var\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NearTo", "::", "usage"}], "=", "\"\<NearTo[\!\(\*
StyleBox[\"lis\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"elem\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"n\", \"TI\"]\)] returns those elements in \!\(\*
StyleBox[\"lis\", \"TI\"]\) that are \!\(\*
StyleBox[\"n\", \"TI\"]\) positions from \!\(\*
StyleBox[\"elem\", \"TI\"]\)\!\(\*
StyleBox[\".\", \"TI\"]\)\\nNearTo[\!\(\*
StyleBox[\"lis\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"elem\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"{\", \"TI\"]\)\!\(\*
StyleBox[\"n\", \"TI\"]\)\!\(\*
StyleBox[\"}\", \"TI\"]\)] returns those elements in \!\(\*
StyleBox[\"lis\", \"TI\"]\) that are less than or equal to \!\(\*
StyleBox[\"n\", \"TI\"]\) positions away from \!\(\*
StyleBox[\"elem\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PerfectSearch", "::", "usage"}], "=", "\"\<PerfectSearch[\!\(\*
StyleBox[\"n\", \"TI\"]\),\!\(\*
StyleBox[\"m\", \"TI\"]\)] returns a list of all those perfect numbers \
(numbers that are equal to the sum of their proper divisors) between \!\(\*
StyleBox[\"n\", \"TI\"]\) and \!\(\*
StyleBox[\"m\", \"TI\"]\).\\nPerfectSearch[\!\(\*
StyleBox[\"n\", \"TI\"]\),\!\(\*
StyleBox[\"m\", \"TI\"]\),\!\(\*
StyleBox[\"k\", \"TI\"]\)] returns a list of all those perfect numbers \
between \!\(\*
StyleBox[\"n\", \"TI\"]\) and \!\(\*
StyleBox[\"m\", \"TI\"]\), searching by increment \!\(\*
StyleBox[\"k\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PerfectSearchParallel", "::", "usage"}], "=", 
   "\"\<PerfectSearchParallel[\!\(\*
StyleBox[\"n\", \"TI\"]\),\!\(\*
StyleBox[\"m\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"k\", \"TI\"]\)] searches for \!\(\*
StyleBox[\"k\", \"TI\"]\)-perfect numbers between \!\(\*
StyleBox[\"n\", \"TI\"]\) and \!\(\*
StyleBox[\"m\", \"TI\"]\) performing the search in parallel. If no subkernels \
are available, the search is performed on a single kernel.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RadiusOfGyrationTensor", "::", "usage"}], "=", 
   "\"\<RadiusOfGyrationTensor[\!\(\*
StyleBox[\"lis\", \"TI\"]\)] computes the radius of gyration tensor of the \
numerical list \!\(\*
StyleBox[\"lis\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RadiusOfGyrationTensor", "::", "badarg"}], "=", 
   "\"\<The argument to RadiusOfGyrationTensor should be a list of the form \
{{\!\(\*SubscriptBox[\(x\), \(1\)]\),\!\(\*SubscriptBox[\(y\), \
\(1\)]\)},{\!\(\*SubscriptBox[\(x\), \(2\)]\),\!\(\*SubscriptBox[\(y\), \
\(2\)]\)},\[Ellipsis]}.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RandomGraphGnp", "::", "usage"}], "=", "\"\<RandomGraphGnp[\!\(\*
StyleBox[\"n\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"p\", \"TI\"]\)] creates a random graph on \!\(\*
StyleBox[\"n\", \"TI\"]\) vertices with probability \!\(\*
StyleBox[\"p\", \"TI\"]\) of an edge being included.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SmithNumberQ", "::", "usage"}], "=", "\"\<SmithNumberQ[\!\(\*
StyleBox[\"n\", \"TI\"]\)] returns if \!\(\*
StyleBox[\"n\", \"TI\"]\) is a Smith number \[Dash] a composite number the \
sum of whose digits is equal to the sum of the digits of its prime factors.\>\
\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StemPlot", "::", "usage"}], "=", "\"\<StemPlot[\!\(\*
StyleBox[\"data\", \"TI\"]\)] returns a stem plot of the discrete data, \
\!\(\*
StyleBox[\"data\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StemPlot", "::", "badarg"}], "=", 
   "\"\<The first argument to StemPlot must be a list of numbers.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToEdges", "::", "usage"}], "=", "\"\<ToEdges[\!\(\*
StyleBox[\"lis\", \"TI\"]\)] converts the list of pairs, \!\(\*
StyleBox[\"lis\", \"TI\"]\), to a list of directed edges of a graph.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TruthTable", "::", "usage"}], "=", "\"\<TruthTable[\!\(\*
StyleBox[\"expr\", \"TI\"]\), \!\(\*
StyleBox[\"vars\", \"TI\"]\)] returns a table of truth values for the logical \
expression \!\(\*
StyleBox[\"expr\", \"TI\"]\) in the variables \!\(\*
StyleBox[\"vars\", \"TI\"]\).\>\""}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ColorResidues", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ColorScheme", "\[Rule]", "Amino"}], "}"}], ",", 
     RowBox[{"Options", "[", "Framed", "]"}]}], "]"}]}], ";"}]], "InputOnly"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "RandomGraphGnp", "]"}], "=", 
   RowBox[{"Options", "[", "Graph", "]"}]}], ";"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "StemPlot", "]"}], "=", 
   RowBox[{"Options", "[", "ListPlot", "]"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ToEdges", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"DirectedEdges", "\[Rule]", "True"}], "}"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions (public and private)", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Amino", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\"\<P\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[44, 51], 
               Rational[10, 17], 
               Rational[26, 51]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.5751633986928104, 0.39215686274509803`, 0.33986928104575165`],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[44/51, 10/17, 26/51]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[44, 51], 
               Rational[10, 17], 
               Rational[26, 51]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[44, 51], 
         Rational[10, 17], 
         Rational[26, 51]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<W\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[12, 17], 
               Rational[6, 17], 
               Rational[12, 17]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.47058823529411764`, 0.23529411764705882`, 0.47058823529411764`],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[12/17, 6/17, 12/17]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[12, 17], 
               Rational[6, 17], 
               Rational[12, 17]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[12, 17], 
         Rational[6, 17], 
         Rational[12, 17]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<L\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[1, 17], 
               Rational[26, 51], 
               Rational[1, 17]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.0392156862745098, 0.33986928104575165`, 0.0392156862745098],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[1/17, 26/51, 1/17]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[1, 17], 
               Rational[26, 51], 
               Rational[1, 17]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[1, 17], 
         Rational[26, 51], 
         Rational[1, 17]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<V\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[1, 17], 
               Rational[26, 51], 
               Rational[1, 17]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.0392156862745098, 0.33986928104575165`, 0.0392156862745098],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[1/17, 26/51, 1/17]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[1, 17], 
               Rational[26, 51], 
               Rational[1, 17]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[1, 17], 
         Rational[26, 51], 
         Rational[1, 17]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<I\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[1, 17], 
               Rational[26, 51], 
               Rational[1, 17]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.0392156862745098, 0.33986928104575165`, 0.0392156862745098],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[1/17, 26/51, 1/17]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[1, 17], 
               Rational[26, 51], 
               Rational[1, 17]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[1, 17], 
         Rational[26, 51], 
         Rational[1, 17]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<N\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[0, 
               Rational[44, 51], 
               Rational[44, 51]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            FrameStyle->RGBColor[0., 0.5751633986928104, 0.5751633986928104],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[0, 44/51, 44/51]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[0, 
               Rational[44, 51], 
               Rational[44, 51]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[0, 
         Rational[44, 51], 
         Rational[44, 51]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<Q\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[0, 
               Rational[44, 51], 
               Rational[44, 51]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            FrameStyle->RGBColor[0., 0.5751633986928104, 0.5751633986928104],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[0, 44/51, 44/51]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[0, 
               Rational[44, 51], 
               Rational[44, 51]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[0, 
         Rational[44, 51], 
         Rational[44, 51]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<S\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[50, 51], 
               Rational[10, 17], 0], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            FrameStyle->RGBColor[0.6535947712418301, 0.39215686274509803`, 0.],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[50/51, 10/17, 0]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[50, 51], 
               Rational[10, 17], 0]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[50, 51], 
         Rational[10, 17], 0],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<T\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[50, 51], 
               Rational[10, 17], 0], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            FrameStyle->RGBColor[0.6535947712418301, 0.39215686274509803`, 0.],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[50/51, 10/17, 0]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[50, 51], 
               Rational[10, 17], 0]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[50, 51], 
         Rational[10, 17], 0],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<C\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[46, 51], 
               Rational[46, 51], 0], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            FrameStyle->RGBColor[0.6013071895424836, 0.6013071895424836, 0.],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[46/51, 46/51, 0]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[46, 51], 
               Rational[46, 51], 0]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[46, 51], 
         Rational[46, 51], 0],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<M\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[46, 51], 
               Rational[46, 51], 0], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            FrameStyle->RGBColor[0.6013071895424836, 0.6013071895424836, 0.],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[46/51, 46/51, 0]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[46, 51], 
               Rational[46, 51], 0]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[46, 51], 
         Rational[46, 51], 0],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<H\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[26, 51], 
               Rational[26, 51], 
               Rational[14, 17]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.33986928104575165`, 0.33986928104575165`, 0.5490196078431373],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[26/51, 26/51, 14/17]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[26, 51], 
               Rational[26, 51], 
               Rational[14, 17]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[26, 51], 
         Rational[26, 51], 
         Rational[14, 17]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<A\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[40, 51], 
               Rational[40, 51], 
               Rational[40, 51]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.5228758169934641, 0.5228758169934641, 0.5228758169934641],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[40/51, 40/51, 40/51]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[40, 51], 
               Rational[40, 51], 
               Rational[40, 51]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[40, 51], 
         Rational[40, 51], 
         Rational[40, 51]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<G\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[47, 51], 
               Rational[47, 51], 
               Rational[47, 51]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.6143790849673203, 0.6143790849673203, 0.6143790849673203],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[47/51, 47/51, 47/51]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[47, 51], 
               Rational[47, 51], 
               Rational[47, 51]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[47, 51], 
         Rational[47, 51], 
         Rational[47, 51]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<F\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[10, 51], 
               Rational[10, 51], 
               Rational[2, 3]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.13071895424836602`, 0.13071895424836602`, 0.4444444444444444],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[10/51, 10/51, 2/3]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[10, 51], 
               Rational[10, 51], 
               Rational[2, 3]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[10, 51], 
         Rational[10, 51], 
         Rational[2, 3]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<Y\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[10, 51], 
               Rational[10, 51], 
               Rational[2, 3]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.13071895424836602`, 0.13071895424836602`, 0.4444444444444444],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[10/51, 10/51, 2/3]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[10, 51], 
               Rational[10, 51], 
               Rational[2, 3]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[10, 51], 
         Rational[10, 51], 
         Rational[2, 3]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<K\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[4, 51], 
               Rational[6, 17], 1], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.05228758169934641, 0.23529411764705882`, 0.6666666666666666],
            FrameTicks->None,
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[4/51, 6/17, 1]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[4, 51], 
               Rational[6, 17], 1]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[4, 51], 
         Rational[6, 17], 1],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<R\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[4, 51], 
               Rational[6, 17], 1], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.05228758169934641, 0.23529411764705882`, 0.6666666666666666],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[4/51, 6/17, 1]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[4, 51], 
               Rational[6, 17], 1]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[4, 51], 
         Rational[6, 17], 1],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<D\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[46, 51], 
               Rational[2, 51], 
               Rational[2, 51]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.6013071895424836, 0.026143790849673203`, 0.026143790849673203`],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[46/51, 2/51, 2/51]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[46, 51], 
               Rational[2, 51], 
               Rational[2, 51]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[46, 51], 
         Rational[2, 51], 
         Rational[2, 51]],
        Editable->False,
        Selectable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<E\>\"", ",", 
       InterpretationBox[
        ButtonBox[
         TooltipBox[
          RowBox[{
           GraphicsBox[{
             {GrayLevel[0], RectangleBox[{0, 0}]}, 
             {GrayLevel[0], RectangleBox[{1, -1}]}, 
             {RGBColor[
               Rational[46, 51], 
               Rational[2, 51], 
               Rational[2, 51]], RectangleBox[{0, -1}, {2, 1}]}},
            AspectRatio->1,
            Frame->True,
            
            FrameStyle->RGBColor[
             0.6013071895424836, 0.026143790849673203`, 0.026143790849673203`],
            FrameTicks->None,
            
            ImageSize->
             Dynamic[{
              Automatic, 
               1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                Magnification])}],
            PlotRangePadding->None], "\[InvisibleSpace]"}],
          "RGBColor[46/51, 2/51, 2/51]"],
         Appearance->None,
         BaseStyle->{},
         BaselinePosition->Baseline,
         ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
           If[
            Not[
             AbsoluteCurrentValue["Deployed"]], 
            SelectionMove[Typeset`box$, All, Expression]; 
            FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
            FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[
               Rational[46, 51], 
               Rational[2, 51], 
               Rational[2, 51]]; 
            FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
            MathLink`CallFrontEnd[
              FrontEnd`AttachCell[Typeset`box$, 
               FrontEndResource["RGBColorValueSelector"], {
               0, {Left, Bottom}}, {Left, Top}, 
               "ClosingActions" -> {
                "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
         DefaultBaseStyle->{},
         Evaluator->Automatic,
         Method->"Preemptive"],
        RGBColor[
         Rational[46, 51], 
         Rational[2, 51], 
         Rational[2, 51]],
        Editable->False,
        Selectable->False]}], "}"}]}], "}"}]}], ";"}]], "InputOnly"],

Cell[BoxData[
 RowBox[{
  RowBox[{"makeAAbox", "[", 
   RowBox[{"scheme_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"aa", ",", "col"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"aa", ",", "col"}], "}"}], "=", 
      RowBox[{"Transpose", "[", "Amino", "]"}]}], ";", 
     RowBox[{"MapThread", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#1", "\[RuleDelayed]", 
         RowBox[{"Framed", "[", 
          RowBox[{"#1", ",", "opts", ",", 
           RowBox[{"Background", "\[Rule]", "#2"}], ",", 
           RowBox[{"FrameStyle", "\[Rule]", "#2"}]}], "]"}]}], "&"}], ",", 
       RowBox[{"{", 
        RowBox[{"aa", ",", "col"}], "}"}]}], "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BondPercolation", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m_", ",", "n_"}], "}"}], ",", "prob_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "gr", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"!", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"IntegerQ", "[", "m", "]"}], "&&", 
         RowBox[{"IntegerQ", "[", "n", "]"}]}], ")"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Message", "[", 
       RowBox[{
        StyleBox[
         RowBox[{"BondPercolation", "::", "baddims"}], "MessageName"], ",", 
        "m", ",", "n"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"gr", "=", 
        RowBox[{"GridGraph", "[", 
         RowBox[{"{", 
          RowBox[{"m", ",", "n"}], "}"}], "]"}]}], ";", 
       RowBox[{"Graph", "[", 
        RowBox[{
         RowBox[{"Pick", "[", 
          RowBox[{
           RowBox[{"EdgeList", "[", "gr", "]"}], ",", 
           RowBox[{"RandomVariate", "[", 
            RowBox[{
             RowBox[{"BernoulliDistribution", "[", "prob", "]"}], ",", 
             RowBox[{"EdgeCount", "[", "gr", "]"}]}], "]"}], ",", "1"}], 
          "]"}], ",", "opts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ColorResidues", "[", 
   RowBox[{"str_String", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Row", "[", 
     RowBox[{
      RowBox[{"Characters", "[", "str", "]"}], "/.", 
      RowBox[{"makeAAbox", "[", 
       RowBox[{"Amino", ",", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"{", "opts", "}"}], ",", 
          RowBox[{"Options", "[", "Framed", "]"}]}], "]"}]}], "]"}]}], 
     "]"}]}], "]"}]}]], "InputOnly"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindPercolationPath", "[", 
   RowBox[{"gr_", ",", 
    RowBox[{"{", 
     RowBox[{"dimx_", ",", "dimy_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"vert", ",", "bot", ",", "top"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vert", "=", 
      RowBox[{"Intersection", "[", 
       RowBox[{
        RowBox[{"VertexList", "[", "gr", "]"}], ",", 
        RowBox[{"VertexList", "[", 
         RowBox[{"GridGraph", "[", 
          RowBox[{"{", 
           RowBox[{"dimx", ",", "dimy"}], "}"}], "]"}], "]"}]}], "]"}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"bot", "=", 
      RowBox[{"Select", "[", 
       RowBox[{"vert", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"#", ",", "dimx"}], "]"}], "\[Equal]", "1"}], "&"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"top", "=", 
      RowBox[{"Select", "[", 
       RowBox[{"vert", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"#", ",", "dimx"}], "]"}], "\[Equal]", "0"}], "&"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Outer", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FindPath", "[", 
           RowBox[{"gr", ",", "#1", ",", "#2"}], "]"}], "&"}], ",", "top", 
         ",", "bot"}], "]"}], ",", "2"}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LagPlot", "[", 
   RowBox[{"data_", ",", 
    RowBox[{"lag_", ":", "1"}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "ListPlot", "]"}]}]}], "]"}], ":=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Drop", "[", 
        RowBox[{"data", ",", "lag"}], "]"}], ",", 
       RowBox[{"Drop", "[", 
        RowBox[{"data", ",", 
         RowBox[{"-", "lag"}]}], "]"}]}], "}"}], "]"}], ",", "opts"}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LuckyNumbers", "[", 
   RowBox[{"n_Integer", "?", "Positive"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", ",", 
      RowBox[{"i", "=", "2"}], ",", 
      RowBox[{"ints", "=", 
       RowBox[{"Range", "[", 
        RowBox[{"1", ",", "n", ",", "2"}], "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ints", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "<", 
        RowBox[{"Length", "[", "ints", "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"p", "=", 
         RowBox[{"ints", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ints", "=", 
         RowBox[{"Drop", "[", 
          RowBox[{"ints", ",", 
           RowBox[{"p", ";;", 
            RowBox[{"-", "1"}], ";;", "p"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"i", "++"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     "ints"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MultiplyCount", "[", 
   RowBox[{"expr_", "?", "PolynomialQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Total", "@", 
    RowBox[{"Cases", "[", 
     RowBox[{
      RowBox[{"{", "expr", "}"}], ",", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"_", ",", "exp_"}], "]"}], "\[RuleDelayed]", 
       RowBox[{"exp", "-", "1"}]}], ",", "Infinity"}], "]"}]}], "+", 
   RowBox[{"Total", "@", 
    RowBox[{"Cases", "[", 
     RowBox[{
      RowBox[{"{", "expr", "}"}], ",", 
      RowBox[{"fac_Times", "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"Length", "[", "fac", "]"}], "-", "1"}]}], ",", "Infinity"}], 
     "]"}]}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MultiplyCount", "[", 
   RowBox[{"expr_", ",", "var_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"PolynomialQ", "[", 
     RowBox[{"expr", ",", "var"}], "]"}], ",", 
    RowBox[{
     RowBox[{"Total", "@", 
      RowBox[{"Cases", "[", 
       RowBox[{
        RowBox[{"{", "expr", "}"}], ",", 
        RowBox[{
         RowBox[{"Power", "[", 
          RowBox[{"_", ",", "exp_"}], "]"}], "\[RuleDelayed]", 
         RowBox[{"exp", "-", "1"}]}], ",", "Infinity"}], "]"}]}], "+", 
     RowBox[{"Total", "@", 
      RowBox[{"Cases", "[", 
       RowBox[{
        RowBox[{"{", "expr", "}"}], ",", 
        RowBox[{"fac_Times", "\[RuleDelayed]", 
         RowBox[{
          RowBox[{"Length", "[", "fac", "]"}], "-", "1"}]}], ",", 
        "Infinity"}], "]"}]}]}], ",", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"MultiplyCount", "::", "poly"}], ",", "expr"}], "]"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NearTo", "[", 
   RowBox[{"lis_List", ",", "elem_", ",", 
    RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"pos", "=", 
      RowBox[{"Position", "[", 
       RowBox[{"lis", ",", "elem"}], "]"}]}], "}"}], ",", 
    RowBox[{"Extract", "[", 
     RowBox[{"lis", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"pos", "-", "n"}], ",", 
        RowBox[{"pos", "+", "n"}]}], "}"}]}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NearTo", "[", 
   RowBox[{"lis_List", ",", "elem_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"pos", "=", 
      RowBox[{"Position", "[", 
       RowBox[{"lis", ",", "elem"}], "]"}]}], "}"}], ",", 
    RowBox[{"Extract", "[", 
     RowBox[{"lis", ",", 
      RowBox[{"Range", "[", 
       RowBox[{
        RowBox[{"pos", "-", "n"}], ",", 
        RowBox[{"pos", "+", "n"}]}], "]"}]}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PerfectSearch", "[", 
   RowBox[{"n_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "perfectQ", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"perfectQ", "[", "j_", "]"}], ":=", 
      RowBox[{
       RowBox[{"DivisorSigma", "[", 
        RowBox[{"1", ",", "j"}], "]"}], "\[Equal]", 
       RowBox[{"2", " ", "j"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"Range", "[", 
        RowBox[{"n", ",", "m", ",", "2"}], "]"}], ",", "perfectQ"}], 
      "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PerfectSearch", "[", 
   RowBox[{"n_", ",", "m_", ",", "k_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "perfectQ", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"perfectQ", "[", "j_", "]"}], ":=", 
      RowBox[{
       RowBox[{"DivisorSigma", "[", 
        RowBox[{"1", ",", "j"}], "]"}], "\[Equal]", 
       RowBox[{"k", " ", "j"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"Range", "[", 
        RowBox[{"n", ",", "m"}], "]"}], ",", "perfectQ"}], "]"}]}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PerfectSearchParallel", "[", 
   RowBox[{"n_", ",", "m_", ",", "k_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "perfectQ", "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"perfectQ", "[", "j_", "]"}], ":=", 
      RowBox[{
       RowBox[{"DivisorSigma", "[", 
        RowBox[{"1", ",", "j"}], "]"}], "\[Equal]", 
       RowBox[{"k", " ", "j"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"DistributeDefinitions", "[", "perfectQ", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Parallelize", "[", 
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{"n", ",", "m", ",", "2"}], "]"}], ",", "perfectQ"}], "]"}], 
      "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RadiusOfGyrationTensor", "[", "lis_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"xy", ",", "vx", ",", "vy"}], "}"}], ",", "\[IndentingNewLine]", 
    
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Not", "@", 
       RowBox[{"MatchQ", "[", 
        RowBox[{"lis", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Message", "[", 
       RowBox[{"RadiusOfGyrationTensor", "::", "badarg"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xy", "=", 
        RowBox[{
         RowBox[{"Dot", "@@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Transpose", "[", "lis", "]"}], "-", 
            RowBox[{"Mean", "[", "lis", "]"}]}], ")"}]}], "/", 
         RowBox[{"Length", "[", "lis", "]"}]}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vx", ",", "vy"}], "}"}], "=", 
        RowBox[{"CentralMoment", "[", 
         RowBox[{"lis", ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"vx", ",", "xy"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"xy", ",", "vy"}], "}"}]}], "}"}]}]}], 
     "\[IndentingNewLine]", "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomGraphGnp", "[", 
   RowBox[{"n_", ",", "p_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"cg", "=", 
       RowBox[{"CompleteGraph", "[", "n", "]"}]}], ",", "probs"}], "}"}], ",",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"probs", "=", 
      RowBox[{"RandomChoice", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"p", ",", 
           RowBox[{"1", "-", "p"}]}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False"}], "}"}]}], ",", 
        RowBox[{"EdgeCount", "[", "cg", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graph", "[", 
      RowBox[{
       RowBox[{"Pick", "[", 
        RowBox[{
         RowBox[{"EdgeRules", "[", "cg", "]"}], ",", "probs"}], "]"}], ",", 
       "opts", ",", 
       RowBox[{"DirectedEdges", "\[Rule]", "False"}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SmithNumberQ", "[", 
   RowBox[{"n_", "/;", 
    RowBox[{"n", "\[LessEqual]", "1"}]}], "]"}], ":=", "False"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SmithNumberQ", "[", 
   RowBox[{"n_", "?", "PrimeQ"}], "]"}], ":=", "False"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SmithNumberQ", "[", "n_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lis", "=", 
      RowBox[{"FactorInteger", "[", "n", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Flatten", "[", 
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"IntegerDigits", "[", "#1", "]"}], "#2"}], "&"}], ",", 
         RowBox[{"Transpose", "[", "lis", "]"}]}], "]"}], "]"}], "]"}], 
     "\[Equal]", 
     RowBox[{"Total", "[", 
      RowBox[{"IntegerDigits", "[", "n", "]"}], "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StemPlot", "[", 
   RowBox[{"lis_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"MatchQ", "[", 
     RowBox[{"lis", ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"__", "?", "NumericQ"}], "}"}], ".."}], "}"}], "|", 
       RowBox[{"{", 
        RowBox[{"__", "?", "NumericQ"}], "}"}]}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ListPlot", "[", 
     RowBox[{"lis", ",", "opts", ",", 
      RowBox[{"Filling", "\[Rule]", "Axis"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Message", "[", 
     RowBox[{"StemPlot", "::", "badarg"}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToEdges", "[", 
   RowBox[{
    RowBox[{"lis", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"OptionValue", "[", "DirectedEdges", "]"}], ",", 
    RowBox[{"DirectedEdge", "@@@", "lis"}], ",", 
    RowBox[{"UndirectedEdge", "@@@", "lis"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToEdges", "[", 
   RowBox[{
    RowBox[{"lis", ":", 
     RowBox[{"{", 
      RowBox[{"_", ",", "_"}], "}"}]}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"OptionValue", "[", "DirectedEdges", "]"}], ",", 
    RowBox[{"DirectedEdge", "@@", "lis"}], ",", 
    RowBox[{"UndirectedEdge", "@@", "lis"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TruthTable", "[", 
   RowBox[{"expr_", ",", "vars_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "vars", "]"}]}], ",", "tuples", ",", "rules", 
      ",", "table", ",", "head"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"True", ",", "False"}], "}"}], ",", "len"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rules", "=", "\[VeryThinSpace]", 
      RowBox[{
       RowBox[{
        RowBox[{"Thread", "[", 
         RowBox[{"vars", "\[Rule]", "#1"}], "]"}], "&"}], "/@", "tuples"}]}], 
     ";", 
     RowBox[{"table", "=", 
      RowBox[{"Transpose", "@", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", "tuples", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"expr", "/.", "rules"}], "}"}]}], "]"}]}]}], ";", 
     RowBox[{"head", "=", 
      RowBox[{"Append", "[", 
       RowBox[{"vars", ",", 
        RowBox[{"TraditionalForm", "[", "expr", "]"}]}], "]"}]}], ";", 
     RowBox[{"Grid", "[", 
      RowBox[{
       RowBox[{"Prepend", "[", 
        RowBox[{
         RowBox[{"table", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"True", "\[Rule]", "\"\<T\>\""}], ",", 
            RowBox[{"False", "\[Rule]", "\"\<F\>\""}]}], "}"}]}], ",", 
         "head"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Dividers", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "Black"}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"-", "1"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "Black"}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"-", "2"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", 
               RowBox[{"GrayLevel", "[", "0.5", "]"}]}], "}"}]}]}], "}"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "Black"}], "}"}]}], ",", 
            RowBox[{"2", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", 
               RowBox[{"GrayLevel", "[", "0.5", "]"}]}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"-", "1"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "Black"}], "}"}]}]}], "}"}]}], "}"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", "\"\<SRSmall\>\"", "}"}]}], ",", 
       RowBox[{"Spacings", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", " ", ".8"}], "}"}]}]}], "]"}]}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"using", " ", "BooleanTable"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"truthTable", "[", "expr_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"head", ",", 
        RowBox[{"vars", "=", 
         RowBox[{"BooleanVariables", "[", "expr", "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"head", "=", 
        RowBox[{"Append", "[", 
         RowBox[{"vars", ",", "expr"}], "]"}]}], ";", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"Prepend", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"BooleanTable", "[", 
             RowBox[{
              RowBox[{"Flatten", "[", 
               RowBox[{"{", 
                RowBox[{"vars", ",", "expr"}], "}"}], "]"}], ",", "vars"}], 
             "]"}], "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"True", "\[Rule]", "\"\<T\>\""}], ",", 
              RowBox[{"False", "\[Rule]", "\"\<F\>\""}]}], "}"}]}], ",", 
           "head"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Dividers", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Thin", ",", "Black"}], "}"}]}], ",", 
              RowBox[{
               RowBox[{"-", "1"}], "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Thin", ",", "Black"}], "}"}]}], ",", 
              RowBox[{
               RowBox[{"-", "2"}], "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Thin", ",", 
                 RowBox[{"GrayLevel", "[", "0.5", "]"}]}], "}"}]}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Thin", ",", "Black"}], "}"}]}], ",", 
              RowBox[{"2", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Thin", ",", 
                 RowBox[{"GrayLevel", "[", "0.5", "]"}]}], "}"}]}], ",", 
              RowBox[{
               RowBox[{"-", "1"}], "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Thin", ",", "Black"}], "}"}]}]}], "}"}]}], "}"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"BaseStyle", "\[Rule]", 
          RowBox[{"{", "\"\<SRSmall\>\"", "}"}]}], ",", 
         RowBox[{"Spacings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Scaled", "[", ".025", "]"}], ",", 
            RowBox[{"Scaled", "[", ".015", "]"}]}], "}"}]}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"None", ",", 
            RowBox[{"{", 
             RowBox[{"LightGray", ",", 
              RowBox[{"{", 
               RowBox[{"None", ",", "LightBlue"}], "}"}]}], "}"}]}], 
           "}"}]}]}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   "*)"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"EndPackage", "[", "]"}], "*)"}]], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section"],

Cell[CellGroupData[{

Cell["Load package", "Subsection"],

Cell["Quit current session:", "Text"],

Cell[BoxData["Quit"], "Input",ExpressionUUID->"3c60f4a8-0cd4-43e4-ab85-2d715c6f835b"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to evaluate init \
cells dialog)."
}], "Text"],

Cell[BoxData[
 RowBox[{"<<", "EPM`"}]], "Input",ExpressionUUID->"f976b857-0243-4764-9f6e-1f51793a0771"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection"],

Cell[BoxData[
 RowBox[{"?", "BondPercolation"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "ColorResidues"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "FindPercolationPath"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "LagPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "LuckyNumbers"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "MultiplyCount"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "NearTo"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "PerfectSearch"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "PerfectSearchParallel"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "RadiusOfGyrationTensor"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "RandomGraphGnp"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "SmithNumberQ"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "StemPlot"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "ToEdges"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "TruthTable"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and their options", "Subsection"],

Cell[CellGroupData[{

Cell["BondPercolation", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "22", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gr", "=", 
   RowBox[{"BondPercolation", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"13", ",", "21"}], "}"}], ",", "0.47"}], "]"}]}], 
  ";"}]}], "Input",ExpressionUUID->"25025f02-7ba5-47e2-8782-b227978ac02b"],

Cell[BoxData[
 RowBox[{"HighlightGraph", "[", 
  RowBox[{
   RowBox[{"GridGraph", "[", 
    RowBox[{"{", 
     RowBox[{"13", ",", "21"}], "}"}], "]"}], ",", "gr", ",", 
   RowBox[{"GraphHighlightStyle", "\[Rule]", "\"\<DehighlightGray\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"7483bdb1-38ca-438b-bc5a-cb302002cbf9"]
}, Closed]],

Cell[CellGroupData[{

Cell["ColorResidues", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"muc6", "=", 
   RowBox[{"StringTake", "[", 
    RowBox[{
     RowBox[{"ProteinData", "[", 
      RowBox[{"\"\<MUC6\>\"", ",", "\"\<Sequence\>\""}], "]"}], ",", "100"}], 
    "]"}]}], ";"}]], "Input",ExpressionUUID->"ddac350f-4e82-4a46-9ac2-\
1d44ca2180cd"],

Cell[BoxData[
 RowBox[{"ColorResidues", "[", 
  RowBox[{"muc6", ",", 
   RowBox[{"ColorScheme", "\[Rule]", "Amino"}], ",", 
   RowBox[{"FrameMargins", "\[Rule]", "2"}]}], "]"}]], "Input",ExpressionUUID-\
>"2afe3133-5814-4f35-a594-9660f18e50a2"]
}, Closed]],

Cell[CellGroupData[{

Cell["FindPercolationPath", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"path", "=", 
   RowBox[{"FindPercolationPath", "[", 
    RowBox[{"gr", ",", 
     RowBox[{"{", 
      RowBox[{"13", ",", "21"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"HighlightGraph", "[", 
  RowBox[{
   RowBox[{"GridGraph", "[", 
    RowBox[{"{", 
     RowBox[{"13", ",", "21"}], "}"}], "]"}], ",", 
   RowBox[{"PathGraph", "/@", "path"}], ",", 
   RowBox[{"GraphHighlightStyle", "\[Rule]", "\"\<DehighlightGray\>\""}]}], 
  "]"}]}], "Input",ExpressionUUID->"c96e98e6-3e34-4e07-a1db-802d01c3a370"]
}, Closed]],

Cell[CellGroupData[{

Cell["LagPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"BlockRandom", "[", 
    RowBox[{
     RowBox[{"SeedRandom", "[", 
      RowBox[{"1", ",", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Congruential\>\"", ",", 
          RowBox[{"\"\<Multiplier\>\"", "\[Rule]", "11"}], ",", 
          RowBox[{"\"\<Increment\>\"", "\[Rule]", "0"}], ",", 
          RowBox[{"\"\<Modulus\>\"", "\[Rule]", "17"}]}], "}"}]}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"RandomReal", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", "1000", "}"}]}], "]"}]}], "]"}]}], ";"}]], "Input",Express\
ionUUID->"f511f86d-e6d9-4c45-9c21-963492a3aed5"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"LagPlot", "[", 
    RowBox[{"data", ",", "lag", ",", 
     RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"lag", ",", "1", ",", "4"}], "}"}]}], "]"}]], "Input",ExpressionUU\
ID->"8195e899-7dd1-40e5-bb43-450019cacdf0"]
}, Closed]],

Cell[CellGroupData[{

Cell["LuckyNumbers", "Subsubsection"],

Cell[BoxData[
 RowBox[{"LuckyNumbers", "[", "1000", "]"}]], "Input",ExpressionUUID->"e0f84591-6230-4bdf-8b87-acd06568a222"]
}, Closed]],

Cell[CellGroupData[{

Cell["MultiplyCount", "Subsubsection"],

Cell[BoxData[
 RowBox[{"MultiplyCount", "[", 
  RowBox[{
   RowBox[{"3", 
    SuperscriptBox["x", "4"]}], "-", 
   RowBox[{"5", "x"}], "+", "2"}], "]"}]], "Input",ExpressionUUID->"1e103cd4-\
d03f-42a0-aaa1-84f05cef5122"],

Cell[BoxData[
 RowBox[{"MultiplyCount", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"3", 
     SuperscriptBox["x", "4"]}], "-", 
    RowBox[{"5", "x"}], "+", "2"}], ",", "x"}], "]"}]], "Input",ExpressionUUID\
->"2a278719-1561-4d15-b58a-b758a57a5489"],

Cell["Test bad argument.", "Text"],

Cell[BoxData[
 RowBox[{"MultiplyCount", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"3", 
      SuperscriptBox["x", "4"]}], "-", 
     RowBox[{"5", "x"}], "+", "2"}], "}"}], ",", "x"}], "]"}]], "Input",Expres\
sionUUID->"1b65e5e2-e31f-4d28-9a67-ebcfa8ad7d88"]
}, Closed]],

Cell[CellGroupData[{

Cell["NearTo", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"chars", "=", 
   RowBox[{"CharacterRange", "[", 
    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}], ";"}]], "Input",Expressi\
onUUID->"6959bf60-5860-4a2b-b538-cd1a217389a0"],

Cell[BoxData[
 RowBox[{"NearTo", "[", 
  RowBox[{"chars", ",", "\"\<q\>\"", ",", "3"}], "]"}]], "Input",ExpressionUUI\
D->"2392bf41-616a-421c-a921-5c0ca847810a"],

Cell[BoxData[
 RowBox[{"NearTo", "[", 
  RowBox[{"chars", ",", "\"\<q\>\"", ",", 
   RowBox[{"{", "3", "}"}]}], "]"}]], "Input",ExpressionUUID->"dc886500-4733-\
4eee-8a38-c43d465360c7"]
}, Closed]],

Cell[CellGroupData[{

Cell["PerfectSearch", "Subsubsection"],

Cell[BoxData[
 RowBox[{"PerfectSearch", "[", 
  RowBox[{"2", ",", 
   SuperscriptBox["10", "5"]}], "]"}]], "Input",ExpressionUUID->"ab534794-\
a372-4edf-b6b5-78990e347723"],

Cell["Find 4-perfect numbers:", "Text"],

Cell[BoxData[
 RowBox[{"PerfectSearch", "[", 
  RowBox[{"2", ",", 
   SuperscriptBox["10", "6"], ",", "4"}], "]"}]], "Input",ExpressionUUID->\
"06a94c6a-f557-4e7a-9a85-238b5c8da2f4"]
}, Closed]],

Cell[CellGroupData[{

Cell["PerfectSearchParallel", "Subsubsection"],

Cell[BoxData[
 RowBox[{"PerfectSearchParallel", "[", 
  RowBox[{"2", ",", "2200000", ",", "4"}], "]"}]], "Input",ExpressionUUID->\
"fa1aeb30-8f82-454c-9068-cdd07c8e5e06"]
}, Closed]],

Cell[CellGroupData[{

Cell["RadiusOfGyrationTensor", "Subsubsection"],

Cell[BoxData[
 RowBox[{"<<", "EPM`RandomWalks`"}]], "Input",ExpressionUUID->"88c11296-4cfd-4f1e-832e-c5413b0c834b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"walk", "=", 
   RowBox[{"RandomWalk", "[", 
    RowBox[{
     SuperscriptBox["10", "6"], ",", 
     RowBox[{"LatticeWalk", "\[Rule]", "False"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"\[ScriptCapitalT]", "=", 
  RowBox[{"RadiusOfGyrationTensor", "[", "walk", "]"}]}]}], "Input",Expression\
UUID->"49fda3f0-c2f7-4220-a44b-ceee63442ef8"]
}, Closed]],

Cell[CellGroupData[{

Cell["RandomGraphGnp", "Subsubsection"],

Cell[BoxData[
 RowBox[{"RandomGraphGnp", "[", 
  RowBox[{"30", ",", ".2", ",", 
   RowBox[{"VertexSize", "\[Rule]", "Large"}], ",", 
   RowBox[{"EdgeStyle", "\[Rule]", "Thin"}]}], "]"}]], "Input",ExpressionUUID-\
>"52a03612-b5d6-4c81-bd28-b801d083add3"]
}, Closed]],

Cell[CellGroupData[{

Cell["SmithNumberQ", "Subsubsection"],

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Range", "[", "1000", "]"}], ",", "SmithNumberQ"}], "]"}]], "Input",\
ExpressionUUID->"103a212d-da37-4cc1-b2bc-3ec7c6055b53"]
}, Closed]],

Cell[CellGroupData[{

Cell["StemPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"StemPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"PointSize", "[", "Medium", "]"}]}], ",", 
   RowBox[{"FillingStyle", "\[Rule]", 
    RowBox[{"RGBColor", "[", 
     RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}]], "Input",ExpressionU\
UID->"f808ddb6-c183-4026-ac79-6527ab171c0e"],

Cell["Test with multiple lists:", "Text"],

Cell[BoxData[
 RowBox[{"lists", "=", 
  RowBox[{"RandomInteger", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "8"}], "}"}]}], "]"}]}]], "Input",ExpressionUUID->\
"b2f66b96-56ce-4318-b4b0-a23c3cd81b20"],

Cell[BoxData[
 RowBox[{"StemPlot", "[", "lists", "]"}]], "Input",ExpressionUUID->"43abc654-6acf-4051-be93-9cd2e574b7ec"]
}, Closed]],

Cell[CellGroupData[{

Cell["ToEdges", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"lis", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ToEdges", "[", "lis", "]"}]}], "Input",ExpressionUUID->"0907991f-\
9e47-4a9a-8d50-6f92b42dace0"],

Cell[BoxData[
 RowBox[{"ToEdges", "[", 
  RowBox[{"{", 
   RowBox[{"3", ",", "2"}], "}"}], "]"}]], "Input",ExpressionUUID->"7b59a378-\
6828-45e7-858c-ed8944b94b15"],

Cell[BoxData[
 RowBox[{"ToEdges", "[", 
  RowBox[{"{", "}"}], "]"}]], "Input",ExpressionUUID->"8b7a45fb-e5be-4a31-9e13-cf7a3a47efcb"]
}, Closed]],

Cell[CellGroupData[{

Cell["TruthTable", "Subsubsection"],

Cell[BoxData[
 RowBox[{"TruthTable", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"A", "\[And]", "B"}], "\[Implies]", 
    RowBox[{"\[Not]", "C"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C"}], "}"}]}], "]"}]], "Input",ExpressionUUID\
->"6b07adbc-1a9a-4fbb-81a3-2a8ec2bfc8c5"]
}, Closed]]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{935, 832},
WindowMargins->{{Automatic, 699}, {Automatic, 20}},
ShowSelection->True,
FrontEndVersion->"11.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 16, \
2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "6.2 Solutions"->{
  Cell[12225, 381, 182, 5, 
  28, "Input", "ExpressionUUID" -> "b6edf40f-a00e-42d2-9d77-b324bef4df61",
   CellTags->"6.2 Solutions"],
  Cell[66163, 1886, 1079, 33, 
  80, "Input", "ExpressionUUID" -> "52592fef-08d7-4411-a005-0984446bf8c0",
   CellTags->"6.2 Solutions"]},
 "6.3 Solutions"->{
  Cell[61586, 1742, 549, 17, 
  45, "InputOnly", "ExpressionUUID" -> "2d602b22-a0f9-4e4f-825a-fd7cf4fbfd66",
   
   CellTags->"6.3 Solutions"],
  Cell[62138, 1761, 533, 16, 
  45, "InputOnly", "ExpressionUUID" -> "8326ecfa-fe97-437a-9019-42ad13d9f6a0",
   
   CellTags->"6.3 Solutions"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"6.2 Solutions", 86945, 2603},
 {"6.3 Solutions", 87237, 2610}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 60, 1, 64, "Section", "ExpressionUUID" -> \
"2c5f6cd6-499a-423e-8d71-a85b0321d2df",
 InitializationGroup->True],
Cell[642, 25, 240, 9, 49, "Text", "ExpressionUUID" -> \
"bf8f5797-1abf-4495-b44b-669e54eb3d14"],
Cell[CellGroupData[{
Cell[907, 38, 30, 0, 44, "Subsection", "ExpressionUUID" -> \
"9eb7f186-0b4b-4db6-8146-fd63fed4de29"],
Cell[940, 40, 109, 2, 32, "Input", "ExpressionUUID" -> \
"19860748-77b1-40d5-bd1c-c4f683fe6a54"],
Cell[1052, 44, 191, 5, 32, "Input", "ExpressionUUID" -> \
"ef1b277b-b2fd-46d2-a793-17296a06dd94"],
Cell[1246, 51, 146, 4, 32, "Input", "ExpressionUUID" -> \
"816b852d-2960-4ae2-83e9-2d05905de331"],
Cell[1395, 57, 262, 6, 32, "Input", "ExpressionUUID" -> \
"165a7d07-5784-4795-9bca-0147115c886b"],
Cell[1660, 65, 112, 2, 32, "Input", "ExpressionUUID" -> \
"9191fd73-061c-4d64-8ab7-879989faf9ba"],
Cell[1775, 69, 147, 4, 32, "Input", "ExpressionUUID" -> \
"7fa0099a-36a1-4fce-9a5e-0d9484af285a"],
Cell[1925, 75, 209, 5, 32, "Input", "ExpressionUUID" -> \
"71becb26-5841-420b-b04d-24d91cea1dd0"],
Cell[2137, 82, 256, 8, 32, "Input", "ExpressionUUID" -> \
"1dd1c2f5-16b4-4f5a-bc29-d65c59eee9f0"],
Cell[2396, 92, 620, 13, 75, "Input", "ExpressionUUID" -> \
"8a058800-9e21-4bde-a51b-d50a231036e6"],
Cell[3019, 107, 131, 3, 32, "Input", "ExpressionUUID" -> \
"6ffce7c1-7706-4486-a32c-d9d0a98a597f"],
Cell[3153, 112, 140, 4, 32, "Input", "ExpressionUUID" -> \
"542de6be-4c34-4674-85fc-82dfbb561e11"],
Cell[3296, 118, 181, 3, 32, "Input", "ExpressionUUID" -> \
"97536e40-e6bc-460d-b4de-55cd084e8fec"]
}, Closed]],
Cell[CellGroupData[{
Cell[3514, 126, 34, 0, 36, "Subsection", "ExpressionUUID" -> \
"68d4f467-64bf-4aa3-ae17-e86e04ef662b"],
Cell[3551, 128, 446, 8, 75, "Input", "ExpressionUUID" -> \
"79b4b489-f0f0-4550-bb55-70ce82b9a4ca"],
Cell[4000, 138, 123, 3, 32, "Input", "ExpressionUUID" -> \
"b5a23fb0-09d7-445e-a4e0-14274c2ed6ba"]
}, Closed]],
Cell[CellGroupData[{
Cell[4160, 146, 57, 0, 36, "Subsection", "ExpressionUUID" -> \
"e1a29863-d5fd-4c83-a78c-89ed3ab89389"],
Cell[4220, 148, 194, 5, 32, "Input", "ExpressionUUID" -> \
"b533867e-a08d-45c3-8294-20dc93fdbdfc"],
Cell[4417, 155, 518, 12, 75, "Input", "ExpressionUUID" -> \
"6820d949-8c29-4234-a19b-015dde3ff620"],
Cell[4938, 169, 208, 5, 54, "Input", "ExpressionUUID" -> \
"f7da0c0b-82cd-488a-b146-718e572f5d4f"],
Cell[5149, 176, 267, 6, 53, "InputOnly", "ExpressionUUID" -> \
"686e3f40-4512-4447-9480-012bca00c582"],
Cell[5419, 184, 212, 5, 54, "Input", "ExpressionUUID" -> \
"bafefb1c-2255-430c-8b68-f7885085b1b8"],
Cell[5634, 191, 436, 11, 75, "Input", "ExpressionUUID" -> \
"3e9e31fa-e021-4b33-abed-0fd4d6e7ded4"],
Cell[6073, 204, 248, 6, 32, "Input", "ExpressionUUID" -> \
"c59ce37f-f690-4051-a4be-dc088be247df"],
Cell[6324, 212, 239, 5, 32, "Input", "ExpressionUUID" -> \
"ca55ea95-494e-4da8-b58d-708fef5da590"],
Cell[6566, 219, 600, 13, 96, "Input", "ExpressionUUID" -> \
"7e7138f6-3106-4a3a-be68-0da2ee46986c"],
Cell[7169, 234, 1017, 26, 75, "Input", "ExpressionUUID" -> \
"ca35e371-8344-43ee-987c-4431d78d698a"],
Cell[8189, 262, 679, 15, 96, "Input", "ExpressionUUID" -> \
"98f0b89a-6812-4e47-ba10-1e564fc8581a"],
Cell[8871, 279, 567, 14, 96, "Input", "ExpressionUUID" -> \
"bfda4a26-863d-4458-b3db-b785e1521263"],
Cell[9441, 295, 285, 7, 54, "Input", "ExpressionUUID" -> \
"350d6a1b-1080-4fe2-93e8-7662182b6245"],
Cell[9729, 304, 361, 7, 54, "Input", "ExpressionUUID" -> \
"174d368e-01f2-43c0-9a3f-7a2765706cab"],
Cell[10093, 313, 405, 9, 75, "Input", "ExpressionUUID" -> \
"13cff2d4-c81d-44da-a763-c33ffa9cd926"],
Cell[10501, 324, 333, 7, 75, "Input", "ExpressionUUID" -> \
"a9fa18d6-4fad-49a9-8331-7965a2dd91e1"],
Cell[10837, 333, 236, 6, 32, "Input", "ExpressionUUID" -> \
"4018ac10-9ca3-436f-9aa0-28c8628e451e"],
Cell[11076, 341, 175, 5, 32, "Input", "ExpressionUUID" -> \
"253e339c-b38c-4f78-a996-6755706c3556"],
Cell[11254, 348, 259, 6, 32, "Input", "ExpressionUUID" -> \
"b9b4ee0f-095c-4877-8353-c2dd50e849cb"],
Cell[11516, 356, 347, 8, 75, "Input", "ExpressionUUID" -> \
"9e0fea59-64a8-463a-969c-2b9449948d84"]
}, Closed]],
Cell[CellGroupData[{
Cell[11900, 369, 29, 0, 36, "Subsection", "ExpressionUUID" -> \
"e1fe2006-6593-4bf3-96ea-e7be609c6752"],
Cell[11932, 371, 290, 8, 27, "InputOnly", "ExpressionUUID" -> \
"4f8872b6-cc2e-472c-940c-e5180aaa7c8d"],
Cell[12225, 381, 182, 5, 28, "Input", "ExpressionUUID" -> \
"b6edf40f-a00e-42d2-9d77-b324bef4df61",
 CellTags->"6.2 Solutions"],
Cell[12410, 388, 151, 4, 28, "Input", "ExpressionUUID" -> \
"8fc28a0f-09cf-43ce-9ab0-2cd20eb4c5df"],
Cell[12564, 394, 178, 5, 28, "Input", "ExpressionUUID" -> \
"48f7e088-3852-4611-a017-d71e5dec8283"]
}, Closed]],
Cell[CellGroupData[{
Cell[12779, 404, 37, 0, 36, "Subsection", "ExpressionUUID" -> \
"f3c1f31d-36ec-4a37-b4b7-fd6168c3c569"],
Cell[12819, 406, 92, 2, 28, "Input", "ExpressionUUID" -> \
"c3243b59-9f4f-4864-b8e2-e62359a9ad28"]
}, Closed]],
Cell[CellGroupData[{
Cell[12948, 413, 63, 0, 36, "Subsection", "ExpressionUUID" -> \
"8457a005-065c-482d-bed0-23ee575f422e"],
Cell[13014, 415, 40879, 1087, 66, "InputOnly", "ExpressionUUID" -> \
"1a754775-6eeb-480b-854d-c51f29cd8d0a"],
Cell[53896, 1504, 853, 24, 63, "Input", "ExpressionUUID" -> \
"4bd3fa5f-c28b-435f-97eb-09ef142ebf97"],
Cell[54752, 1530, 1392, 39, 131, "Input", "ExpressionUUID" -> \
"ccf15d31-0f79-4112-9562-b3bc5dad32ea"],
Cell[56147, 1571, 629, 18, 62, "InputOnly", "ExpressionUUID" -> \
"55d5fb60-6bc9-4a37-94e5-f6d3907d0807"],
Cell[56779, 1591, 1523, 45, 114, "Input", "ExpressionUUID" -> \
"5132fdaa-083b-415a-9b82-6b63585ef2c9"],
Cell[58305, 1638, 551, 17, 46, "Input", "ExpressionUUID" -> \
"a707ddba-d78c-42ed-a08d-36203d43666d"],
Cell[58859, 1657, 1078, 31, 114, "Input", "ExpressionUUID" -> \
"942620e1-dbd1-442e-8f5d-e7944d8f1391"],
Cell[59940, 1690, 683, 20, 63, "Input", "ExpressionUUID" -> \
"1b10efa8-5b4a-449a-9dfb-7ffbf5923768"],
Cell[60626, 1712, 957, 28, 97, "Input", "ExpressionUUID" -> \
"323ed742-57dc-4c8a-8fb9-9d655540e9ca"],
Cell[61586, 1742, 549, 17, 45, "InputOnly", "ExpressionUUID" -> \
"2d602b22-a0f9-4e4f-825a-fd7cf4fbfd66",
 CellTags->"6.3 Solutions"],
Cell[62138, 1761, 533, 16, 45, "InputOnly", "ExpressionUUID" -> \
"8326ecfa-fe97-437a-9019-42ad13d9f6a0",
 CellTags->"6.3 Solutions"],
Cell[62674, 1779, 631, 18, 63, "Input", "ExpressionUUID" -> \
"f35b7726-bd12-4d20-acf9-12919a7f9a07"],
Cell[63308, 1799, 629, 18, 63, "Input", "ExpressionUUID" -> \
"ad92deab-2ffb-4867-80dc-a3e3e8224a38"],
Cell[63940, 1819, 769, 21, 80, "Input", "ExpressionUUID" -> \
"192d064f-d003-45a0-8b2f-327d42003a8b"],
Cell[64712, 1842, 1448, 42, 131, "Input", "ExpressionUUID" -> \
"8f532e06-534b-45ef-a932-c56aa708d91e"],
Cell[66163, 1886, 1079, 33, 80, "Input", "ExpressionUUID" -> \
"52592fef-08d7-4411-a005-0984446bf8c0",
 CellTags->"6.2 Solutions"],
Cell[67245, 1921, 155, 4, 28, "Input", "ExpressionUUID" -> \
"904256dc-148c-4205-a961-768a50de8296"],
Cell[67403, 1927, 123, 3, 28, "Input", "ExpressionUUID" -> \
"1753dadc-115f-4545-a43a-30c8055c3ed4"],
Cell[67529, 1932, 677, 20, 63, "Input", "ExpressionUUID" -> \
"da4aa34b-6af2-497e-8dbf-30e283d0056f"],
Cell[68209, 1954, 823, 25, 98, "Input", "ExpressionUUID" -> \
"9a50a692-8bfb-4e4f-8360-9f22102926ef"],
Cell[69035, 1981, 476, 14, 46, "Input", "ExpressionUUID" -> \
"a52012a7-9aa2-453e-a095-6ad307034569"],
Cell[69514, 1997, 421, 12, 46, "Input", "ExpressionUUID" -> \
"15daf700-2fcb-49d3-8b52-1611841265f7"],
Cell[69938, 2011, 2945, 82, 199, "Input", "ExpressionUUID" -> \
"888063a9-21c8-408b-bd3f-240a1226d3d1"],
Cell[72886, 2095, 3076, 81, 199, "Input", "ExpressionUUID" -> \
"d9b217ac-8fd0-4a67-a334-f0aac4d77d2e"]
}, Closed]],
Cell[CellGroupData[{
Cell[75999, 2181, 41, 0, 36, "Subsection", "ExpressionUUID" -> \
"49604a6d-f360-4568-8483-30ce51c467a3"],
Cell[76043, 2183, 69, 2, 28, "Input", "ExpressionUUID" -> \
"54fd105b-c84a-48ee-a82f-b6fd594fbd50"]
}, Closed]],
Cell[CellGroupData[{
Cell[76149, 2190, 32, 0, 36, "Subsection", "ExpressionUUID" -> \
"32deca54-27b5-4adf-85c9-b19435bd0c9b"],
Cell[76184, 2192, 83, 2, 28, "Input", "ExpressionUUID" -> \
"9b40e27a-6b2c-4cc4-a4fe-f140ce81e33f"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[76316, 2200, 27, 0, 64, "Section", "ExpressionUUID" -> \
"e22a6a91-0a42-465b-827c-dccef7786f2f"],
Cell[CellGroupData[{
Cell[76368, 2204, 34, 0, 44, "Subsection", "ExpressionUUID" -> \
"27cd7292-adcc-4eea-b8d5-8c373323dd98"],
Cell[76405, 2206, 37, 0, 30, "Text", "ExpressionUUID" -> \
"2c8c2636-a0e8-4797-b32b-258b398536d6"],
Cell[76445, 2208, 85, 0, 32, "Input", "ExpressionUUID" -> \
"3c60f4a8-0cd4-43e4-ab85-2d715c6f835b"],
Cell[76533, 2210, 183, 6, 30, "Text", "ExpressionUUID" -> \
"262772ae-6db2-4c02-86b3-286a4cbda7e5"],
Cell[76719, 2218, 103, 1, 32, "Input", "ExpressionUUID" -> \
"f976b857-0243-4764-9f6e-1f51793a0771"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76859, 2224, 41, 0, 44, "Subsection", "ExpressionUUID" -> \
"84c1a1e8-ed46-4cd9-89a7-88afb2415011"],
Cell[76903, 2226, 58, 1, 32, "Input", "ExpressionUUID" -> \
"39fb4033-181f-4398-9319-ff0a27dfdae0"],
Cell[76964, 2229, 56, 1, 32, "Input", "ExpressionUUID" -> \
"a6faafd2-a9ba-46ae-9b23-7375d9e85d46"],
Cell[77023, 2232, 62, 1, 32, "Input", "ExpressionUUID" -> \
"e3df339e-2ee6-4f9f-ac45-9def483b9a43"],
Cell[77088, 2235, 50, 1, 32, "Input", "ExpressionUUID" -> \
"b124ae7f-d95f-43f3-aeb4-748a2b27557e"],
Cell[77141, 2238, 55, 1, 32, "Input", "ExpressionUUID" -> \
"3ee5595c-8a75-4857-b7f7-a2852673a492"],
Cell[77199, 2241, 56, 1, 32, "Input", "ExpressionUUID" -> \
"7b532fa9-3f44-4f50-9293-370fb8044e0d"],
Cell[77258, 2244, 49, 1, 32, "Input", "ExpressionUUID" -> \
"21120893-5d8b-4711-86a3-35a4c3aaca86"],
Cell[77310, 2247, 56, 1, 32, "Input", "ExpressionUUID" -> \
"1c638538-a687-4e32-8b46-09824ab18633"],
Cell[77369, 2250, 64, 1, 32, "Input", "ExpressionUUID" -> \
"7fbf417e-5d3e-400c-845a-2bf57d3be67b"],
Cell[77436, 2253, 65, 1, 32, "Input", "ExpressionUUID" -> \
"9c878cd5-c6a5-42d7-a1fb-fc1a491eeda9"],
Cell[77504, 2256, 57, 1, 32, "Input", "ExpressionUUID" -> \
"01d001f7-0529-43d1-8652-7c47e09e16a5"],
Cell[77564, 2259, 55, 1, 32, "Input", "ExpressionUUID" -> \
"e4d015c9-d431-4f03-837e-737bf57567aa"],
Cell[77622, 2262, 51, 1, 32, "Input", "ExpressionUUID" -> \
"fd032503-60c3-40e7-b3b7-d921468531ae"],
Cell[77676, 2265, 50, 1, 32, "Input", "ExpressionUUID" -> \
"d4812f26-9144-46b9-b192-3d6e590c4be4"],
Cell[77729, 2268, 53, 1, 32, "Input", "ExpressionUUID" -> \
"fbd6cb9d-a46b-48de-ac1e-44e36e40cbe7"]
}, Closed]],
Cell[CellGroupData[{
Cell[77819, 2274, 62, 0, 36, "Subsection", "ExpressionUUID" -> \
"530353e8-a11f-4fca-9bb9-fc3981364c16"],
Cell[CellGroupData[{
Cell[77906, 2278, 40, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"9079520d-1c3d-4de3-aba0-d676331ebec7"],
Cell[77949, 2280, 337, 9, 54, "Input", "ExpressionUUID" -> \
"25025f02-7ba5-47e2-8782-b227978ac02b"],
Cell[78289, 2291, 319, 7, 32, "Input", "ExpressionUUID" -> \
"7483bdb1-38ca-438b-bc5a-cb302002cbf9"]
}, Closed]],
Cell[CellGroupData[{
Cell[78645, 2303, 38, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"522f2f01-7be8-4844-8e8c-22a1f702dd3c"],
Cell[78686, 2305, 291, 8, 32, "Input", "ExpressionUUID" -> \
"ddac350f-4e82-4a46-9ac2-1d44ca2180cd"],
Cell[78980, 2315, 244, 5, 32, "Input", "ExpressionUUID" -> \
"2afe3133-5814-4f35-a594-9660f18e50a2"]
}, Closed]],
Cell[CellGroupData[{
Cell[79261, 2325, 44, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"2411b495-bd23-4e04-a9ae-cabb7986cdd3"],
Cell[79308, 2327, 538, 14, 54, "Input", "ExpressionUUID" -> \
"c96e98e6-3e34-4e07-a1db-802d01c3a370"]
}, Closed]],
Cell[CellGroupData[{
Cell[79883, 2346, 32, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"7eff6eb2-1b73-4c26-8da1-237dc448d66d"],
Cell[79918, 2348, 682, 17, 96, "Input", "ExpressionUUID" -> \
"f511f86d-e6d9-4c45-9c21-963492a3aed5"],
Cell[80603, 2367, 318, 8, 32, "Input", "ExpressionUUID" -> \
"8195e899-7dd1-40e5-bb43-450019cacdf0"]
}, Closed]],
Cell[CellGroupData[{
Cell[80958, 2380, 37, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"fd63c9e1-446a-4a64-9797-c6642d62f28e"],
Cell[80998, 2382, 123, 1, 32, "Input", "ExpressionUUID" -> \
"e0f84591-6230-4bdf-8b87-acd06568a222"]
}, Closed]],
Cell[CellGroupData[{
Cell[81158, 2388, 38, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"2276fdef-111e-462a-8464-c3b1539739f5"],
Cell[81199, 2390, 220, 6, 35, "Input", "ExpressionUUID" -> \
"1e103cd4-d03f-42a0-aaa1-84f05cef5122"],
Cell[81422, 2398, 247, 7, 35, "Input", "ExpressionUUID" -> \
"2a278719-1561-4d15-b58a-b758a57a5489"],
Cell[81672, 2407, 34, 0, 30, "Text", "ExpressionUUID" -> \
"fa9f9afe-b68a-4542-99d3-157e93eff72a"],
Cell[81709, 2409, 275, 8, 35, "Input", "ExpressionUUID" -> \
"1b65e5e2-e31f-4d28-9a67-ebcfa8ad7d88"]
}, Closed]],
Cell[CellGroupData[{
Cell[82021, 2422, 31, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"dce49d8a-ca70-4350-8499-a62701b53383"],
Cell[82055, 2424, 211, 5, 32, "Input", "ExpressionUUID" -> \
"6959bf60-5860-4a2b-b538-cd1a217389a0"],
Cell[82269, 2431, 161, 3, 32, "Input", "ExpressionUUID" -> \
"2392bf41-616a-421c-a921-5c0ca847810a"],
Cell[82433, 2436, 185, 4, 32, "Input", "ExpressionUUID" -> \
"dc886500-4733-4eee-8a38-c43d465360c7"]
}, Closed]],
Cell[CellGroupData[{
Cell[82655, 2445, 38, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"fdcd62b0-781d-4c6d-a971-096fe15ad045"],
Cell[82696, 2447, 172, 4, 35, "Input", "ExpressionUUID" -> \
"ab534794-a372-4edf-b6b5-78990e347723"],
Cell[82871, 2453, 39, 0, 30, "Text", "ExpressionUUID" -> \
"3be1fcf7-216e-4290-85a2-56a7b3d97e9e"],
Cell[82913, 2455, 182, 4, 35, "Input", "ExpressionUUID" -> \
"06a94c6a-f557-4e7a-9a85-238b5c8da2f4"]
}, Closed]],
Cell[CellGroupData[{
Cell[83132, 2464, 46, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"2f320141-8e89-4bf1-ae19-d968389e0d4c"],
Cell[83181, 2466, 170, 3, 32, "Input", "ExpressionUUID" -> \
"fa1aeb30-8f82-454c-9068-cdd07c8e5e06"]
}, Closed]],
Cell[CellGroupData[{
Cell[83388, 2474, 47, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"0a1691a0-5d50-4d0c-89a9-a1f987891a13"],
Cell[83438, 2476, 115, 1, 32, "Input", "ExpressionUUID" -> \
"88c11296-4cfd-4f1e-832e-c5413b0c834b"],
Cell[83556, 2479, 367, 9, 56, "Input", "ExpressionUUID" -> \
"49fda3f0-c2f7-4220-a44b-ceee63442ef8"]
}, Closed]],
Cell[CellGroupData[{
Cell[83960, 2493, 39, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"862a1eed-abbe-465f-b813-c4c7e392f0e5"],
Cell[84002, 2495, 253, 5, 32, "Input", "ExpressionUUID" -> \
"52a03612-b5d6-4c81-bd28-b801d083add3"]
}, Closed]],
Cell[CellGroupData[{
Cell[84292, 2505, 37, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"8fc0287b-355e-49e0-938f-8a3adb6009c2"],
Cell[84332, 2507, 186, 4, 32, "Input", "ExpressionUUID" -> \
"103a212d-da37-4cc1-b2bc-3ec7c6055b53"]
}, Closed]],
Cell[CellGroupData[{
Cell[84555, 2516, 33, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"8483bb0e-40d2-4d89-aa86-5da098e8bc58"],
Cell[84591, 2518, 425, 10, 32, "Input", "ExpressionUUID" -> \
"f808ddb6-c183-4026-ac79-6527ab171c0e"],
Cell[85019, 2530, 41, 0, 30, "Text", "ExpressionUUID" -> \
"a53cabe3-0a8b-42fa-b8fa-62a7f50ed40b"],
Cell[85063, 2532, 300, 9, 32, "Input", "ExpressionUUID" -> \
"b2f66b96-56ce-4318-b4b0-a23c3cd81b20"],
Cell[85366, 2543, 120, 1, 32, "Input", "ExpressionUUID" -> \
"43abc654-6acf-4051-be93-9cd2e574b7ec"]
}, Closed]],
Cell[CellGroupData[{
Cell[85523, 2549, 32, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"486268f8-62be-4d61-b971-e6a0d340240e"],
Cell[85558, 2551, 314, 9, 54, "Input", "ExpressionUUID" -> \
"0907991f-9e47-4a9a-8d50-6f92b42dace0"],
Cell[85875, 2562, 164, 4, 32, "Input", "ExpressionUUID" -> \
"7b59a378-6828-45e7-858c-ed8944b94b15"],
Cell[86042, 2568, 133, 2, 32, "Input", "ExpressionUUID" -> \
"8b7a45fb-e5be-4a31-9e13-cf7a3a47efcb"]
}, Closed]],
Cell[CellGroupData[{
Cell[86212, 2575, 35, 0, 35, "Subsubsection", "ExpressionUUID" -> \
"e6bfe605-6d84-412f-ad5e-103651b510fd"],
Cell[86250, 2577, 290, 8, 32, "Input", "ExpressionUUID" -> \
"6b07adbc-1a9a-4fbb-81a3-2a8ec2bfc8c5"]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

